//
//  NewSelectItemVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol NewSelectItemVcDelegate {
    func NewSelectItemVcSelect(datas:Array<InputInitInfoGoodsInfoModel>)
}
class NewSelectItemVc: BaseViewController,UITableViewDelegate,UITableViewDataSource{
    
    var rkDatas:Array<InputInitInfoGoodsInfoModel> = []
    var rkSelectArr:Array<InputInitInfoGoodsInfoModel> = []
    
    var delegate:NewSelectItemVcDelegate?
    
    @IBAction func submitAction(_ sender: Any) {
        delegate?.NewSelectItemVcSelect(datas: rkSelectArr)
        self.navigationController?.popViewController(animated: true)
    }
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var searchBg: UIView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "选择商品"
        self.view.addSubview(navbar)
        listView.register(UINib(nibName: "XuanZeShangPinCell", bundle: nil), forCellReuseIdentifier: "XuanZeShangPinCell")
        listView.separatorStyle = .none
        SetTopFrame(view:searchBg,height:0)
        // Do any additional setup after loading the view.
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        return rkDatas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "XuanZeShangPinCell") as! XuanZeShangPinCell
        cell.tag = indexPath.row
        let cellData = rkDatas[indexPath.row]
        
        cell.tapBtn.isUserInteractionEnabled = false
        
        cell.selectBtn.isSelected = false
        
        for item in rkSelectArr {
            if item.sku_id == cellData.sku_id {
                cell.selectBtn.isSelected = true
            }
        }
        cell.iconImg.sd_setImage(with:URL(string:SERVERCE_ImageHost +  cellData.goods_thumb!))
        cell.nameLbl.text = cellData.goods_name
        cell.detailLbl.text = cellData.spec_str
        cell.detailLbl2.text = "\(cellData.inventory!)"
        
        return cell
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 120
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        
        let data = rkDatas[indexPath.row]
        let idx = rkSelectArr.firstIndex { (model) -> Bool in
            return model.sku_id == data.sku_id
        }
        if idx != nil {
            rkSelectArr.remove(at: idx!)
        }else{
            rkSelectArr.append(data)
        }
        listView.reloadData()
    }
    
}
