//
//  NewOnlyRKCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol NewOnlyRKCellDelegate {
    func NewOnlyRKCellDateTypeSelect(sender:Int,cell:NewOnlyRKCell)//选择时间类型
    func NewOnlyRKCellDateSelect(cell:NewOnlyRKCell)//选择日期
    func NewOnlyRKCellAddRepord(cell:NewOnlyRKCell)//添加检测报告
    func NewOnlyRKCellDel(cell:NewOnlyRKCell)//删除
    func NewOnlyRKCellTFinput(text:String,inputType:Int,cell:NewOnlyRKCell)
}
class NewOnlyRKCell: UITableViewCell,UITextFieldDelegate {
    var delegate:NewOnlyRKCellDelegate?
    
    @IBOutlet weak var titLbl: UILabel!
    @IBOutlet weak var delBtn: UIButton!
    @IBOutlet weak var rightBtn: UIButton!
    @IBOutlet weak var leftBtn: UIButton!

    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var detailLbl: UILabel!
    
    @IBOutlet weak var bzqTf: UITextField!
    @IBOutlet weak var totalPriceTf: UITextField!
    @IBOutlet weak var rkCountTf: UITextField!
    @IBOutlet weak var rkPriceTf: UITextField!
    
    @IBOutlet weak var timeLbl: UILabel!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        leftBtn.isSelected = true
        leftBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
        // Initialization code
        bzqTf.delegate = self
        bzqTf.tag = 100
        totalPriceTf.delegate = self
        totalPriceTf.tag = 101
        rkCountTf.delegate = self
        rkCountTf.tag = 102
        rkPriceTf.delegate = self
        rkPriceTf.tag = 103
        
        setYuanJiao2(sender: leftBtn)
        setYuanJiao(sender: rightBtn)
        
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        if isPurnNumber(str: textField.text!) {
            delegate?.NewOnlyRKCellTFinput(text: textField.text!, inputType: textField.tag, cell: self)
        }
    }
    func setYuanJiao2(sender:UIView){
        let maskPath = UIBezierPath(roundedRect: sender.bounds,
                                    byRoundingCorners:[.bottomLeft, .topLeft], cornerRadii:CGSize(width:2, height:2))
        let masklayer = CAShapeLayer()
        masklayer.frame = sender.bounds
        masklayer.path = maskPath.cgPath
        sender.layer.mask = masklayer
    }
    
    func setYuanJiao(sender:UIView){
        let maskPath = UIBezierPath(roundedRect: sender.bounds,
                                    byRoundingCorners:[.bottomRight, .topRight], cornerRadii:CGSize(width:2, height:2))
        let masklayer = CAShapeLayer()
        masklayer.frame = sender.bounds
        masklayer.path = maskPath.cgPath
        sender.layer.mask = masklayer
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    @IBAction func dateTypeSelect(_
        sender: UIButton) {
        if sender.tag == 0{//月
            leftBtn.isSelected = false
            rightBtn.isSelected = true
            leftBtn.backgroundColor = UIColor(named: "app底色")
            rightBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
        }else{//天
            leftBtn.isSelected = true
            rightBtn.isSelected = false
            leftBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
            rightBtn.backgroundColor = UIColor(named: "app底色")
        }
        delegate?.NewOnlyRKCellDateTypeSelect(sender: sender.tag, cell: self)
        
    }
    @IBAction func selectDate(_ sender: UIButton) {
         delegate?.NewOnlyRKCellDateSelect(cell: self)
     }
    @IBAction func addAction(_ sender: UIButton) {
        delegate?.NewOnlyRKCellAddRepord(cell: self)
    }
    @IBAction func delAction(_ sender: UIButton) {
        delegate?.NewOnlyRKCellDel(cell: self)
    }
}
