//
//  XiaYunDanViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import WebKit
import MAMapKit
import SwiftyJSON
import SwiftDate
import SDWebImage
import IQKeyboardManagerSwift


class XiaYunDanViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,JiTuoWuXinXiViewDelegate,JiPaiFangShiViewControllerDelegate,ZengZhiServicesViewControllerDelegate,AdressSelectCellDelegate,DZGLViewControllerDelegate,XinZengDiZhiViewControllerDelegate,TitleAndTFBtnCellDelegate,WenDuCellDelegate,LogisticalSelectViewDelegate, UIPickerViewDataSource, UIPickerViewDelegate, GLAlertSelectViewDelegate,CLLocationManagerDelegate, CityListViewControllerDelegate,ToAndFormSelectViewControllerDelegate,WayBillAddressCanDelItemCellDelegate,HLLTopCellDelegate,OtherDemandViewControllerDelegate,OnlyViewCellDelegate, XiaDanUserInfoViewControllerDelegate{
    
    let datasArr = ["https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1597299369034&di=e29ff315ddeadcfc8b785c8060995b3c&imgtype=0&src=http%3A%2F%2F5b0988e595225.cdn.sohucs.com%2Fimages%2F20180520%2Fcfc6bc7922824542b3b3186041ba49de.jpeg","https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1597300858041&di=52f336ce7e6b501eb560fbf0848c754b&imgtype=0&src=http%3A%2F%2Fdingyue.ws.126.net%2FxprlH2GfSd8xmPWwqfyILcSqUCcHtdrfYuTBNezAfGJKi1545980365722.jpg","https://ss1.bdstatic.com/70cFuXSh_Q1YnxGkpoWK1HF6hhy/it/u=2992387834,114733111&fm=26&gp=0.jpg"]
    
    
    var xiaDanRenMsg:NSString = ""
    func XiaDanUserInfoViewControllerData(str: NSString) {
        xiaDanRenMsg = str
        let arr = xiaDanRenMsg.components(separatedBy: "_")
        hPart2P.insert("\(arr.first!)（\(arr[1])）", at: 1)
        hPart2P.remove(at: 2)
        hListView.reloadData()
    }
    
    var serviceSelect:Array<String> = []
    func OnlyViewCellSelect(idx: String) {
        let num = serviceSelect.index(of: idx)
        if num == nil {
            serviceSelect.append(idx)
        }else{
            serviceSelect.remove(at: num!)
        }
        hListView.reloadData()
    }
    
    
    var selectAr:Array<Int> = []
    var spec_select_arr:Array<Int> = []
    func OtherDemandViewControllerResult(strs: Array<spec_req_arr_data>,selectArr:Array<Int>) {
        
        var spec_req_arr_str = ""
        spec_select_arr.removeAll()
        for item in strs{
            spec_select_arr.append(item.type!)
        }
        for i in 0 ..< strs.count{
            let item = strs[i]
            if i == strs.count - 1 {
                spec_req_arr_str += item.name!
            }else{
                spec_req_arr_str += item.name! + ","
            }
        }
        
        selectAr.removeAll()
        selectAr = selectArr
        hPart2P.insert(spec_req_arr_str, at: 2)
        hPart2P.remove(at: 3)
        
        if adrArr.count > 0 {
            let firstData = adrArr.first! as NSDictionary
            if firstData["locName"] as! String != "空" && adrArr.count > 1 {
                
                var adrDs:Array<Any> = []
                adrDs.removeAll()
                for item in adrArr {
                    let data = item["adr"] as! cityListDataModel
                    let dict = ["lat":data.lat_lon!.lat!,"lon":data.lat_lon!.lon!,"city_id":data.city_id!] as [String : Any]
                    adrDs.append(dict)
                }
                let lat_lon_arr = dataChangeString(sender: adrDs)
                
                let fD = adrArr.first!
                let cityData = fD["adr"] as! cityListDataModel
                let params = ["user_token":UserToken as Any,
                              "nonce_str":String.randomStr(len: 30) as Any,
                              "city_id":cityData.city_id as Any,
                              "city_info_revision":carModel?.revision as Any,
                              "order_vehicle_id":carTypesArr[selectCarType].order_vehicle_id as Any,
                              "std_tag_arr":"" as Any,
                              "spec_req_arr":spec_select_arr as Any,
                              "lat_lon_arr":lat_lon_arr as Any
                ]
                
                orderPriceCalculate(params, success: { (data) in
                    let model = data as! orderPriceCalculateModel
                    self.YuGuPriceLbl.text = "\(model.data!.total_price_fen!/100)"
                    self.logisticsCostModel = model
                    let view = self.hListView.footerView(forSection: 1)
                    
                    view?.layoutIfNeeded()
                    
                    self.hListView.reloadData()
                    return
                }) { (err) in
                    
                }
            }
        }
        hListView.reloadData()
    }
    
    @IBAction func setHllOrder(_ sender: Any) {
        print("下运单")
        if adrArr.count == 0 {
            HUD.flash(.label("请选择完整的收发路线"), delay: 1.2)
            return
        }
        if stime == 0 {
            HUD.flash(.label("请选择用车时间"), delay: 1.2)
            return
        }
        let msgArr = xiaDanRenMsg.components(separatedBy: "_")
        if msgArr.first?.count == 0 || msgArr[1].count == 0 {
            HUD.flash(.label("请填写下单联系人及联系电话"), delay: 1.2)
            return
        }
        let dict = adrArr.first
        if adrArr.count > 1 && dict!["locName"] as! String != "空" {
            let firstDict = adrArr.first
            let firstCity = firstDict!["adr"] as! cityListDataModel
            var addr_info_arr:Array<Any> = []
            
            addr_info_arr.removeAll()
            for i in 0 ..< adrArr.count {
                let item = adrArr[i]
                let itemModel = item["adr"] as! cityListDataModel
                
                let itemData = (item["detailAdr"] as! NSString).components(separatedBy: "_")
                
                let dict = ["name":(itemData.last)! as Any,
                            "addr":itemData[2] as Any,
                            "city_name":itemData.first as Any,
                            "city_id":itemModel.city_id! as Any,
                            "district_name":itemData[1] as Any,
                            "house_number":item["menPai"]! as Any,
                            "contact_name":firstDict!["shouHuoRen"] as Any,
                            "contact_phone_no":firstDict!["phoneNum"] as Any,
                            "lat_lon":["lat":itemModel.lat_lon!.lat as Any,"lon":itemModel.lat_lon!.lon as Any]]
                
                addr_info_arr.append(dict)
            }
            
            let total = YuGuPriceLbl.text! as NSString
            var spec_select_arr_str = ""
            if spec_select_arr.count > 0 {
                spec_select_arr_str = dataChangeString(sender: spec_select_arr)
            }
            
            let dict1 = ["user_token":UserToken as Any,
                         "nonce_str":String.randomStr(len: 30) as Any,
                         "city_id":firstCity.city_id as Any,
                         "city_info_revision":carModel?.revision as Any,
                         "order_vehicle_id":carTypesArr[selectCarType].order_vehicle_id as Any,
                         "std_tag_arr":"" as Any,
                         "spec_req_arr":spec_select_arr_str as Any,
                         "order_time":stime as Any,
                         "total_price_fen":total.floatValue * 100 as Any,
                         "contact_name":msgArr.first as Any,
                         "contact_phone_no":msgArr[1] as Any,
                         "pay_type":"3" as Any,
                         "order_reason":"" as Any,
                         "remark":msgArr.last as Any,
                         "sale_plat":guanlianPingStr as Any,
                         "order_sn":guanlianDingStr as Any,
                         "addr_info":dataChangeString(sender: addr_info_arr) as Any
            ]
            
            shopsAuthList(dict1, success: { (data) in
                let model = data as! shopsAuthListModel
                HUD.flash(.success)
                let vc = WaybillDetailViewController()
                vc.lwb_no = "\(model.data!)"
                vc.isYDBc = true
                self.navigationController?.pushViewController(vc, animated: true)
            }) { (err) in
                
            }
            
        }else{
            HUD.flash(.label("请选择完整的收发路线"), delay: 1.2)
        }
    }
    
    @IBOutlet weak var YuGuPriceLbl: UILabel!
    func showScrollUI(){
        //左右按钮
        for item in lineArr{
            if item.tag == selectCarType {
                item.isHidden = false
            }else{
                item.isHidden = true
            }
        }
        for item in btnArr {
            if item.tag == selectCarType {
                item.isSelected = true
                item.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            }else{
                item.isSelected = false
                item.setTitleColor(UIColor(named: "提示语字体颜色"), for: .normal)
            }
        }
        let btn = btnArr[selectCarType]
        let idx = IndexPath(row: 0, section: 0)
        let cell = hListView.cellForRow(at:idx) as! HLLTopCell
        let w = cell.scViewBg.bounds.size.width
        cell.scrollView?.setContentOffset(CGPoint(x: selectCarType * Int(w), y: 0), animated: true)
        cell.idx = selectCarType
        
        let x = btn.frame.minX
        let rect = CGRect(x: Int(x), y: 0, width: Int(w), height: 1)
        topBtnScv.scrollRectToVisible(rect, animated: true)
        
        
        //刷新
        if adrArr.count > 0 {
            let firstData = adrArr.first! as NSDictionary
            if firstData["locName"] as! String != "空" && adrArr.count > 1 {
                
                var adrDs:Array<Any> = []
                adrDs.removeAll()
                for item in adrArr {
                    let data = item["adr"] as! cityListDataModel
                    
                    let dict = ["lat":data.lat_lon!.lat!,"lon":data.lat_lon!.lon!,"city_id":data.city_id!] as [String : Any]
                    
                    adrDs.append(dict)
                }
                
                let lat_lon_arr = dataChangeString(sender: adrDs)
                
                let fD = adrArr.first!
                let cityData = fD["adr"] as! cityListDataModel
                let params = ["user_token":UserToken as Any,
                              "nonce_str":String.randomStr(len: 30) as Any,
                              "city_id":cityData.city_id as Any,
                              "city_info_revision":carModel?.revision as Any,
                              "order_vehicle_id":carTypesArr[selectCarType].order_vehicle_id as Any,
                              "std_tag_arr":"" as Any,
                              "spec_req_arr":spec_select_arr as Any,
                              "lat_lon_arr":lat_lon_arr as Any
                ]
                orderPriceCalculate(params, success: { (data) in
                    let model = data as! orderPriceCalculateModel
                    self.YuGuPriceLbl.text = "\(model.data!.total_price_fen!/100)"
                    self.logisticsCostModel = model
                    let view = self.hListView.footerView(forSection: 1)
                    
                    view?.layoutIfNeeded()
                    
                    
                    self.hListView.reloadData()
                }) { (err) in
                    
                }
            }
        }
        self.hListView.reloadData()
    }
    
    func HLLTopCellScrollIdx(idx: Int) {
        selectCarType = idx
        showScrollUI()
    }
    
    func HLLTopCellBtnClick(idx: Int) {
        selectCarType = idx
        showScrollUI()
    }
    
    func WayBillAddressCanDelItemCellDelAc(idx: Int) {
        adrArr.remove(at: idx)
        let view = hListView.footerView(forSection: 1)
        view?.layoutIfNeeded()
        hListView.reloadData()
    }
    
    var carModel:cityCartDataModel?
    fileprivate func extractedFunc() {
        HUD.flash(.progress)
        cityCart(["user_token":UserToken as Any,"nonce_str":String.randomStr(len:30) as Any,"city_id":city_id as Any], success: { (data) in
            
            let model = data as! cityCartModel
            self.carModel = model.data
            self.carTypesArr.removeAll()
            for item in model.data!.vehicle_arr! {
                self.carTypesArr.append(item)
            }
            if self.carTypesArr.count == 0 {
                HUD.flash(.label("暂无车型可供选择"), delay: 1.2)
                return
            }
            let view = self.hListView.footerView(forSection: 0)
            view?.layoutIfNeeded()
            self.setBtnUI(carTypesArr: self.carTypesArr,view: self.topCarBtnSelectView)
            self.hListView.reloadData()
            
            HUD.hide()
            
        }) { (err) in
            
        }
    }
    
    @IBAction func toDetailpage(_ sender: Any) {
        if logisticsCostModel == nil {
            HUD.flash(.label("请选择完整的收发路线"), delay: 1.2)
            return
        }
        print("明细跳转 ")
        let vc = LogisticsCostDetailViewController()
        vc.model = logisticsCostModel
        //        vc.carModel = carTypesArr[selectCarType]
        self.navigationController?.pushViewController(vc, animated: true)
    }
    func ToAndFormSelectViewControllerSelectAdr(dict: Dictionary<String, Any>, idx: Int) {
        
        let adrModel = dict["adr"] as! cityListDataModel
        
        if idx == 0 {
            
            if city_id != adrModel.city_id {
                city_id = adrModel.city_id!
                selectCarType = 0
                
                let cell = hListView.cellForRow(at: IndexPath(row: 0, section: 0)) as! HLLTopCell
                cell.scrollView?.setContentOffset(CGPoint(x: selectCarType * Int(CGFloat(cell.scViewBg.bounds.size.width)), y: 0), animated: true)
                cell.idx = selectCarType
                var city_name = ""
                for item in adrDatas {
                    if item.city_id == city_id {
                        city_name = item.name!
                    }
                }
                locBtn.setTitle("  " + city_name, for:.normal)
                extractedFunc()
            }
        }
        
        
        if idx != 0 && adrArr.count == 0{
            let dic = NSMutableDictionary()
            dic["locName"] = "空"
            adrArr.append(dic)
            adrArr.append(dict as NSDictionary)
        }else{
            if adrArr.count > idx {
                adrArr.insert(dict as NSDictionary, at: idx)
                adrArr.remove(at: idx+1)
            }else{
                adrArr.append(dict as NSDictionary)
            }
        }
        
        
        let firstData = adrArr.first! as NSDictionary
        if firstData["locName"] as! String != "空" && adrArr.count > 1 {
            
            var adrDs:Array<Any> = []
            adrDs.removeAll()
            for item in adrArr {
                let data = item["adr"] as! cityListDataModel
                let dict = ["lat":data.lat_lon!.lat!,"lon":data.lat_lon!.lon!,"city_id":data.city_id!] as [String : Any]
                
                adrDs.append(dict)
            }
            let lat_lon_arr = dataChangeString(sender: adrDs)

            let fD = adrArr.first!
            let cityData = fD["adr"] as! cityListDataModel
            let params = ["user_token":UserToken as Any,
                          "nonce_str":String.randomStr(len: 30) as Any,
                          "city_id":cityData.city_id as Any,
                          "city_info_revision":carModel?.revision as Any,
                          "order_vehicle_id":carTypesArr[selectCarType].order_vehicle_id as Any,
                          "std_tag_arr":"" as Any,
                          "spec_req_arr":spec_select_arr as Any,
                          "lat_lon_arr":lat_lon_arr as Any
            ]
            orderPriceCalculate(params, success: { (data) in
                let model = data as! orderPriceCalculateModel
                self.YuGuPriceLbl.text = "\(model.data!.total_price_fen!/100)"
                self.logisticsCostModel = model
                let view = self.hListView.footerView(forSection: 1)
                
                view?.layoutIfNeeded()
                
                self.hListView.reloadData()
                return
            }) { (err) in
                
            }
        }
        let view = self.hListView.footerView(forSection: 1)
        
        view?.layoutIfNeeded()
        
        
        self.hListView.reloadData()
        
    }
    var logisticsCostModel:orderPriceCalculateModel?
    var loc:cityListDataModel!
    
    func CityListViewControllerLocSelect(loc: cityListDataModel) {
        selectLoc = loc.name!
        self.loc = loc
        locBtn.setTitle("  " + loc.name!, for: .normal)
        locBtn.sizeToFit()
        
        locBtn.snp.updateConstraints({ (make) in
            make.right.equalTo(-15)
            make.bottom.equalTo(self.navbar.snp_bottom).offset(-7)
            make.height.equalTo(30)
            make.width.equalTo(self.locBtn.bounds.size.width)
        })
        print("abc == ",adrArr.count)
        if adrArr.count == 0 {
            city_id = loc.city_id!
            print("abc == ")
            extractedFunc()
            return
        }
        if adrArr.count > 0 {
            city_id = loc.city_id!
            let dict = adrArr.first
            if dict!["locName"] as! String == "空"{
                extractedFunc()
                return
            }
        }
        
    }
    
    
    //时间选择背景
    var bgBtn:UIButton?
    var btmView:UIView?
    
    @IBOutlet weak var topCarBtnSelectView: UIView!
    
    var adrArr:Array<NSDictionary> = []
    var tempadrArr:Array<NSDictionary> = []
    //MARK:--地址信息
    var sender:String?
    var sendPhone:String?
    var sendAdr:String?
    var sendAddressModel:AddAddressDataModel?
    var sendAddressSelectModel:GetAddrsInfoDataModel?
    var isSelectSendAddressModel = false
    var s_province_name:String?
    var s_city_name:String?
    var s_district_name:String?
    var s_city:Int?
    var s_province:Int?
    var s_district:Int?
    
    var receiver:String?
    var receivePhone:String?
    var receiveAdr:String?
    var receiveAddressModel:AddAddressDataModel?
    var receiveAddressSelectModel:GetAddrsInfoDataModel?
    var isSelectReceiveAddressModel = false
    var r_province_name:String?
    var r_city_name:String?
    var r_district_name:String?
    var r_city:Int?
    var r_province:Int?
    var r_district:Int?
    
    
    func XinZengDiZhiViewControllerFinishAction(name: String, phone: String, adr: String, data: AddAddressDataModel?,province_name:String,city_name:String,district_name:String) {
        
        if isSend {
            sender = name
            sendPhone = phone
            sendAdr = adr
            sendAddressModel = data
            isSelectSendAddressModel = false
            s_province_name = province_name
            s_city_name = city_name
            s_district_name = district_name
            s_city = data?.city
            s_province = data?.province
            s_district = data?.district
        }else{
            receiver = name
            receivePhone = phone
            receiveAdr = adr
            receiveAddressModel = data
            isSelectReceiveAddressModel = false
            r_province_name = province_name
            r_city_name = city_name
            r_district_name = district_name
            r_city = data?.city
            r_province = data?.province
            r_district = data?.district
        }
        listView.reloadData()
        getLogPayPrice()
    }
    
    func DZGLViewControllerSelect(data: GetAddrsInfoDataModel) {
        print("已选的收发货地址\(data.addr_name!)")
        if isSend {
            sender = data.consignee
            sendPhone = data.mobile
            sendAdr = data.address
            isSelectSendAddressModel = true
            sendAddressSelectModel = data
            s_province_name = data.province_cn
            s_city_name = data.city_cn
            s_district_name = data.district_cn
            s_city = data.city
            s_province = data.province
            s_district = data.district
        }else{
            receiver = data.consignee
            receivePhone = data.mobile
            receiveAdr = data.address
            receiveAddressSelectModel = data
            isSelectReceiveAddressModel = true
            r_province_name = data.province_cn
            r_city_name = data.city_cn
            r_district_name = data.district_cn
            r_city = data.city
            r_province = data.province
            r_district = data.district
        }
        
        listView.reloadData()
        getLogPayPrice()
    }
    
    //MARK:--寄托物信息
    var itemName = ""
    var tiJi:Float?
    var weight:Float?
    var count:Int?
    var isCheck:Bool?
    var chang:String?
    var kuang:String?
    var gao:String?
    
    func JiTuoWuXinXiViewSubmit(itemName: String, tiJi: Float, weight: Float, count: Int, isCheck: Bool,chang:String?,kuang:String?,gao:String?) {
        self.itemName = itemName
        self.tiJi = tiJi
        self.weight = weight
        self.count = count
        self.isCheck = isCheck
        self.chang = chang
        self.kuang = kuang
        self.gao = gao
        jtwxxView?.removeFromSuperview()
        jtwxxView = nil
        listView.reloadData()
        getLogPayPrice()
    }
    
    func AdressSelectCellBtnCLick(row: Int) {
        let vc = DZGLViewController()
        vc.isSelectlogAddress = true
        vc.isSelectMotion = true
        vc.delegate = self
        isSend = true
        if row == 1 {
            isSend = false
        }
        self.navigationController?.pushViewController(vc, animated: true )
    }
    var isSend = true
    func AdressSelectCellTap(row: Int) {
        let vc = XinZengDiZhiViewController()
        vc.navTitle = "新增地址"
        vc.delegate = self
        isSend = true
        if row == 1 {
            isSend = false
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    var send = 0
    var receive = 0
    //MARK:--寄派方式信息
    
    func JiPaiFangShiViewControllerDelegateFinish(send: Int, receive: Int, pickup_time: String, day: Int) {
        self.send = send
        self.receive = receive
        self.pickup_time = pickup_time
        self.day = day
        getLogPayPrice()
        listView.reloadData()
    }
    //MARK:--增值信息
    var price:Float? = 0
    var commend = ""
    func ZengZhiServicesViewControllerFinish(price: Float, content: String) {
        self.price = price
        commend = content
        listView.reloadData()
    }
    
    var wenduIndex:Int = 0 //0为未选 2冷冻 1冷藏
    //MARK:--控温范围
    func WenDuCellSelect(index: Int) {
        wenduIndex = index
    }
    //MARK:--关联信息
    var guanlianDingStr:String? = ""
    var guanlianPingStr:String? = ""
    func TitleAndTFBtnCellEndEdit(contentStr: String, cellTag: Int) {
        if cellTag == 0 {
            guanlianDingStr = contentStr
        }else if cellTag == 1 {
            guanlianPingStr = contentStr
        }
    }
    
    func JiTuoWuXinXiViewClose() {
        jtwxxView?.removeFromSuperview()
        jtwxxView = nil
    }
    var jtwxxView:JiTuoWuXinXiView?
    var selectBtn:UIButton?
    let titleArr = ["物品寄托","寄派方式","增值服务","温控范围"]
    let title2Arr = ["关联订单号","关联平台"]
    //MARK:--预估费用
    @IBOutlet weak var priceLbl: UILabel!
    weak var weak_alertView:LogisticalSelectView? = nil
    @IBAction func orderAction(_ sender: Any) {
        if r_city == nil || s_city == nil || weight == nil || tiJi == nil || wenduIndex == 0{
            HUD.flash(.label("请填写相关信息"), delay: 1.2)
            return
        }
        if logPayPriceModel == nil {
            HUD.flash(.label("无法估算运费"), delay: 1.2)
            return
        }
        let alertView = LogisticalSelectView(frame: self.view.window!.bounds)
        alertView.delegate = self
        alertView.jdPriceLbl.text = "京东冷运（预估运费" + (logPayPriceModel?.price_jd)! + "元）"
        alertView.sfPriceLbl.text = "顺丰冷运（预估运费" + String(format: "%.2f",  (logPayPriceModel?.price_sf)!) + "元）"
        self.view.window?.addSubview(alertView)
        if logPayPriceModel?.price_jd != "-" {
            alertView.jdSelectBtn.isSelected = false
            alertView.sfSelectBtn.isSelected = true
            let num1 = logPayPriceModel?.price_sf
            let num2 = logPayPriceModel?.price_jd as! NSString
            if num1! > num2.floatValue {
                alertView.jdSelectBtn.isSelected = true
                alertView.sfSelectBtn.isSelected = false
            }
        }
        var futitleArr:Array<String> = []
        logPayPriceModel?.sf_data?.forEach({ (model) in
            let str = model.cn! + "：￥" + (model.number)!
            futitleArr.append(str)
        })
        alertView.fuTitleArr = futitleArr
        weak_alertView = alertView
        
    }
    override func viewWillAppear(_ animated: Bool) {
        //MARK:--viewWillAppear 因重写出现问题，需要补写
        self.navigationController?.navigationBar.isHidden = true
        IQKeyboardManager.shared.shouldPlayInputClicks = true
        IQKeyboardManager.shared.enable = true
        IQKeyboardManager.shared.shouldResignOnTouchOutside = true
        
        //MARK:--每次进来都更新
        if weak_alertView != nil {
            weak_alertView!.isHidden = false
        }
    }
    override func viewWillDisappear(_ animated: Bool) {
        if weak_alertView != nil {
            weak_alertView!.isHidden = true
        }
    }
    var lc_id: Int?
    func LogisticalSelectViewSure(index: Int) {
        lc_id = index
        //MARK:--提交运单
        addLogisticsOrderUpdata()
        
    }
    func LogisticalSelectViewWebBy(index: Int) {
        let vc = WebViewController()
        if index == 0 {
            print("京东快件服务协议")
            vc.urlStr = logPayPriceModel!.kjxy_jd
        }else if index == 1 {
            print("顺丰快件服务协议")
            vc.urlStr = logPayPriceModel!.kjxy_sf
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    @IBOutlet weak var topBtnView: UIView!
    @IBOutlet weak var bottomView: UIView!
    @IBOutlet weak var listView: UITableView!
    
    var locBtn = UIButton()
    @IBOutlet weak var hListView: UITableView!
    
    var isAlready = true
    var city_id = 0
    
    var selectCarType = 0
    var carTypesArr:Array<vehicle_arr_data> = []
    @IBAction func selectAction(_ sender: UIButton) {
        
        if rightBtn == sender {
            
            hBtnViewH.constant = CGFloat(TabHeight)
           
            if locationIsOpen == false {
                checkLocation()
                return
            }
            
            if adrDatas.count == 0{
                print("city_id = ",city_id)
                HUD.flash(.progress)
                cityList(["user_token":UserToken as Any,"nonce_str":String.randomStr(len: 30) as Any], success: { (data) in
                    let model = data as! cityListModel
                    self.adrDatas.removeAll()
                    for item in model.data! {
                        if self.selectLoc.contains("\(item.name!)") || self.selectLoc.localizedLowercase.contains("\(item.name_en!)") {
                            self.loc = item
                        }
                        self.adrDatas.append(item)
                    }
                    
                    self.getUICarList()
                    HUD.hide()
                }) { (err) in}
            }else{
                if isAlready {
                    getUICarList()
                }else{
                    rightBtn.isSelected = true
                    leftBtn.isSelected = false
                    lineV.frame.origin.x = fullScreenWidth * 0.5
                    hllView.isHidden = false
                    locBtn.isUserInteractionEnabled = true
                }
            }
        }else{
            locBtn.isUserInteractionEnabled = false
            rightBtn.isSelected = false
            leftBtn.isSelected = true
            lineV.frame.origin.x = 0
            hllView.isHidden = true
            closeCarList()
        }
    }
    
    
    func getUICarList(){
        rightBtn.isSelected = true
        leftBtn.isSelected = false
        lineV.frame.origin.x = fullScreenWidth * 0.5
        hllView.isHidden = false
        locBtn.isUserInteractionEnabled = true
        for item in adrDatas {
            
            if selectLoc.contains("\(item.name!)") || selectLoc.localizedLowercase.contains("\(item.name_en!)"){
                city_id = item.city_id!
            }
        }
        
        extractedFunc()
        let line = UIView()
        line.backgroundColor = UIColor(named: "灰色分界线")
        topCarBtnSelectView.addSubview(line)
        line.snp_makeConstraints { (make) in
            make.height.equalTo(1)
            make.left.right.bottom.equalTo(0)
        }
    }
    
    @IBOutlet weak var lineV: UIView!
    @IBOutlet weak var leftBtn: UIButton!
    @IBOutlet weak var hBtnViewH: NSLayoutConstraint!
    @IBOutlet weak var hllView: UIView!
    @IBOutlet weak var rightBtn: UIButton!
    var adrDatas:Array<cityListDataModel> = []
    @objc func locSelect(){
        
        if adrDatas.count == 0 {
            HUD.flash(.progress)
            cityList(["user_token":UserToken as Any,"nonce_str":String.randomStr(len: 30) as Any], success: { (data) in
                let model = data as! cityListModel
                
                self.adrDatas.removeAll()
                for item in model.data! {
                    if self.selectLoc.contains("\(item.name!)") || self.selectLoc.localizedLowercase.contains("\(item.name_en!)") {
                        self.loc = item
                    }
                    self.adrDatas.append(item)
                }
                let vc = CityListViewController()
                vc.adrDatas = self.adrDatas
                vc.locatStr = self.selectLoc
                vc.delegate = self
                self.navigationController?.pushViewController(vc, animated: true)
                HUD.hide()
            }) { (err) in
                
            }
        }else{
            let vc = CityListViewController()
            vc.adrDatas = adrDatas
            vc.locatStr = self.selectLoc
            vc.delegate = self
            self.navigationController?.pushViewController(vc, animated: true)
        }
        
    }
    
    var manger:CLLocationManager = CLLocationManager()
    var selectLoc = ""
    lazy var geoCoder: CLGeocoder = {
        return CLGeocoder()
    }()
    
    func locationManager(_ manager: CLLocationManager, didUpdateLocations locations: [CLLocation]) {
        manger.stopUpdatingLocation()
        geoCoder.reverseGeocodeLocation(locations.last!) { (pls: [CLPlacemark]?, error: Error?)  in
            if error == nil {
                print("反地理编码成功")
                guard let plsResult = pls else {return}
                let firstPL = plsResult.first
                
                if self.selectLoc.count == 0 {
                    self.locBtn.isUserInteractionEnabled = false
                    self.locBtn.setImage(UIImage(named: "dzdingwei"), for: .normal)
                    self.locBtn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
                    self.locBtn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
                    
                    self.locBtn.addTarget(self, action: #selector(self.locSelect), for: .touchUpInside)
                    self.locBtn.setTitle("  " + (firstPL?.postalAddress?.city)!, for: .normal)
                    self.selectLoc = (firstPL?.postalAddress?.city)!
                    self.locBtn.sizeToFit()
                    self.view.addSubview(self.locBtn)
                    
                    self.locBtn.snp_makeConstraints({ (make) in
                        make.right.equalTo(-15)
                        make.bottom.equalTo(self.navbar.snp_bottom).offset(-7)
                        make.height.equalTo(30)
                        make.width.equalTo(self.locBtn.bounds.size.width)
                    })
                }
            }else {
                print("错误")
            }
        }
        
    }
    
    func needsLocation(){
        manger.delegate = self
        manger.requestAlwaysAuthorization()
        manger.requestWhenInUseAuthorization()
        manger.startUpdatingLocation()
    }
    var locationIsOpen = false
    func checkLocation(){
        if(CLLocationManager.authorizationStatus() != .denied) {
            print("应用拥有定位权限")
            locationIsOpen = true
        }else {
            let aleat = UIAlertController(title: "打开定位开关", message:"定位服务未开启,请进入系统设置>隐私>定位服务中打开开关,并允许商户端使用定位服务", preferredStyle: .alert)
            let tempAction = UIAlertAction(title: "取消", style: .cancel) { (action) in
            }
            let callAction = UIAlertAction(title: "立即设置", style: .default) { (action) in
                let url = NSURL.init(string: UIApplication.openSettingsURLString)
                if(UIApplication.shared.canOpenURL(url! as URL)) {
                    UIApplication.shared.openURL(url! as URL)
                }
            }
            aleat.addAction(tempAction)
            aleat.addAction(callAction)
            self.present(aleat, animated: true, completion: nil)
        }
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        checkLocation()
        
        needsLocation()
        
        navbar.title = "运单列表"
        self.view.addSubview(navbar)
        
        SetTopFrame(view: topBtnView, height: 44)
        
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "AdressSelectCell", bundle: nil), forCellReuseIdentifier: "AdressSelect")
        listView.register(UINib(nibName: "PersonCenterCell", bundle: nil), forCellReuseIdentifier: "PersonCenter")
        listView.register(UINib(nibName: "TitleAndTFBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFBtnCell")
        listView.register(UINib(nibName: "WenDuCell", bundle: nil), forCellReuseIdentifier: "WenDu")
        
        listView.register(UINib(nibName: "LalamoveBillTableViewCell", bundle: nil), forCellReuseIdentifier: "LalamoveBillTableViewCell")
        
        //MARK: - 货拉拉
        hListView.separatorStyle = .none
        hListView.register(UINib(nibName: "TitleAndSwitchCell", bundle: nil), forCellReuseIdentifier: "TitleAndSwitchCell")
        hListView.register(UINib(nibName: "OnlyViewCell", bundle: nil), forCellReuseIdentifier: "OnlyViewCell")
        hListView.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtnCell")
        hListView.register(UINib(nibName: "TitleAndTFBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFBtnCell")
        hListView.register(UINib(nibName: "HLLTopCell", bundle: nil), forCellReuseIdentifier: "HLLTopCell")
        hListView.register(UINib(nibName: "WayBillAddressCanDelItemCell", bundle: nil), forCellReuseIdentifier: "WayBillAddressCanDelItemCell")
        
        lenyunAppointmentTime()
    }
    
    //MARK:--//冷运请求期望上门时间
    var pickup_time : String? = ""
    var day : Int? = 0 //0 今天 1 明天 2 后天
    var timeData:appointmentTimeDataModel? = nil
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    func lenyunAppointmentTime() {
        
        HUD.flash(.progress)
        
        appointmentTime(["user_token":UserToken as Any], success: { (data) in
            let dataModel = data as! appointmentTimeModel
            self.timeData = dataModel.data
            
            
            if dataModel.data?.today == nil {
                
                let keys = dataModel.data?.tomorrow?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                let rightIndexKey = keysArr![0]
                let rightText = dataModel.data?.tomorrow![rightIndexKey as! String]
                self.pickup_time = rightText!
                self.day = 1
            }else{
                let keys = dataModel.data?.today?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                let rightIndexKey = keysArr![0]
                let rightText = dataModel.data?.tomorrow![rightIndexKey as! String]
                self.pickup_time = rightText!
                self.day = 0
            }
            HUD.hide()
        }) { (error) in
            HUD.flash(.label("获取期望上门时间失败"),delay: 1.2)
            
        }
    }
    
    let hPart2 = ["请选择用车时间","下单联系人信息","额外需求","货物保障"]
    var hPart2P = ["","","",""]
    let hPart3 = ["关联平台：","关联订单号："]
    
    
    //MARK: - CELL DELEGATE
    //MARK: - 货拉拉 headerView
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        
        if tableView == hListView {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 5))
            view.backgroundColor = UIColor(named: "app底色")
            return view
        }
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if tableView == hListView {//货拉拉
            if section == 0{
                return 0.1
            }
            return 5
            
            
        }else{
            return 0.1
        }
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if tableView == listView {
            let view = UIView()
            view.backgroundColor = UIColor(named: "app底色")
            return view
        }else{//货拉拉
            if section == 1 {
                let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 49))
                view.backgroundColor = UIColor.white
                let lineT = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 1))
                lineT.backgroundColor = UIColor(named: "灰色分界线")
                view.addSubview(lineT)
                let lineB = UIView(frame: CGRect(x: 0, y: 48, width: fullScreenWidth, height: 1))
                lineB.backgroundColor = UIColor(named: "灰色分界线")
                view.addSubview(lineB)
                let lineC = UIView(frame: CGRect(x: fullScreenWidth*0.5-0.5, y: 7, width: 1, height: 35))
                lineC.backgroundColor = UIColor(named: "灰色分界线")
                view.addSubview(lineC)
                if adrArr.count > 2 {
                    let leftBtn = UIButton(frame: CGRect(x: 0, y: 0, width: fullScreenWidth*0.5, height: 44))
                    leftBtn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
                    leftBtn.setTitle("调整收货地顺序", for: .normal)
                    leftBtn.addTarget(self, action: #selector(huoLLAdrAction(sender:)), for: .touchUpInside)
                    leftBtn.tag = 0
                    leftBtn.setTitleColor(UIColor(named: "灰色字体颜色"), for: .normal)
                    view.addSubview(leftBtn)
                    let rightBtn = UIButton(frame: CGRect(x: fullScreenWidth*0.5, y: 0, width: fullScreenWidth*0.5, height: 44))
                    rightBtn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
                    rightBtn.setTitle("继续添加收货地址", for: .normal)
                    rightBtn.tag = 1
                    rightBtn.addTarget(self, action: #selector(huoLLAdrAction(sender:)), for: .touchUpInside)
                    rightBtn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
                    view.addSubview(rightBtn)
                }else{
                    let addBtn = UIButton(frame:view.bounds)
                    addBtn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
                    addBtn.backgroundColor = UIColor.white
                    addBtn.setTitle("添加收货地址", for: .normal)
                    if adrArr.count > 1 {
                        addBtn.setTitle("继续添加收货地址", for: .normal)
                    }
                    addBtn.tag = 1
                    addBtn.addTarget(self, action: #selector(huoLLAdrAction(sender:)), for: .touchUpInside)
                    addBtn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
                    view.addSubview(addBtn)
                    
                }
                return view
            }
            let view = UIView()
            return view
        }
    }
    
    var closeBtn:UIButton?
    var changeCellSortView:UIView?
    //MARK: - 改变地址顺序
    @objc func huoLLAdrAction(sender:UIButton){
        if sender.tag == 0 {
            print("调位置")
            
            tempadrArr = adrArr
            var h = CGFloat(adrArr.count + 2)*49
            if h > CGFloat(fullScreenHeight) * 0.65 {
                h = CGFloat(fullScreenHeight) * 0.65
            }
            
            changeCellSortView?.isHidden = false
            closeBtn?.isHidden = false
            if closeBtn == nil {
                closeBtn = UIButton(frame: self.view.bounds)
                closeBtn?.backgroundColor = UIColor(named: "标题字颜色")
                closeBtn?.alpha = 0.4
                closeBtn?.addTarget(self, action: #selector(closeCarList), for: .touchUpInside)
                self.view.addSubview(closeBtn!)
                
                changeCellSortView = UIView()
                changeCellSortView?.backgroundColor = UIColor.white
                changeCellSortView?.layer.cornerRadius = 5
                changeCellSortView?.layer.maskedCorners = [CACornerMask.layerMinXMinYCorner,CACornerMask.layerMaxXMinYCorner]
                self.view.addSubview(changeCellSortView!)
            }
            changeCellSortView?.frame = CGRect(x: 0, y: fullScreenHeight - CGFloat(h), width: fullScreenWidth, height: CGFloat(h))
            
            let leftBtn = UIButton()
            leftBtn.addTarget(self, action: #selector(changeCellSortAc(sender:)), for: .touchUpInside)
            leftBtn.backgroundColor = RGB(r: 170, g: 205, b: 240)
            leftBtn.setTitle("取消", for: .normal)
            leftBtn.titleLabel?.font = UIFont(name: "PingFangSC-Medium", size: 17)
            changeCellSortView?.addSubview(leftBtn)
            leftBtn.snp.makeConstraints { (make) in
                make.left.bottom.equalTo(0)
                make.height.equalTo(49)
                make.width.equalTo(fullScreenWidth*0.5)
            }
            
            let rightBtn = UIButton()
            rightBtn.addTarget(self, action: #selector(changeCellSortAc(sender:)), for: .touchUpInside)
            rightBtn.tag = 1
            rightBtn.backgroundColor = RGB(r: 53, g: 135, b: 219)
            rightBtn.setTitle("确定", for: .normal)
            rightBtn.titleLabel?.font = UIFont(name: "PingFangSC-Medium", size: 17)
            changeCellSortView?.addSubview(rightBtn)
            rightBtn.snp.makeConstraints { (make) in
                make.left.equalTo(leftBtn.snp.right)
                make.bottom.equalTo(0)
                make.height.equalTo(49)
                make.width.equalTo(fullScreenWidth*0.5)
            }
            
            let titleLbl = UILabel()
            titleLbl.textAlignment = .center
            titleLbl.text = "调整地址"
            titleLbl.textColor = UIColor(named: "标题字颜色")
            titleLbl.font = UIFont(name: "PingFangSC-Medium", size: 15)
            changeCellSortView?.addSubview(titleLbl)
            titleLbl.snp.makeConstraints { (make) in
                make.top.left.right.equalTo(0)
                make.height.equalTo(49)
            }
            let line = UIView()
            line.backgroundColor = UIColor(named: "灰色分界线")
            changeCellSortView?.addSubview(line)
            line.snp.makeConstraints { (make) in
                make.top.equalTo(titleLbl.snp.bottom)
                make.left.right.equalTo(0)
                make.height.equalTo(1)
            }
            
            let blueL = UILabel()
            blueL.text = "发"
            blueL.textColor = UIColor.white
            blueL.backgroundColor = UIColor(named: "按钮背景颜色")
            blueL.layer.cornerRadius = 11
            blueL.textAlignment = .center
            blueL.font = UIFont.systemFont(ofSize: 13)
            blueL.layer.masksToBounds = true
            changeCellSortView?.addSubview(blueL)
            blueL.snp.makeConstraints { (make) in
                make.width.height.equalTo(22)
                make.left.equalTo(20)
                make.top.equalTo(line.snp.bottom).offset(13.5)
            }
            
            let adrFisrtLbl = UILabel()
            if adrArr.count > 0 {
                let dict = adrArr.first! as! NSDictionary
                adrFisrtLbl.text = dict["locName"] as! String
            }
            adrFisrtLbl.textColor = UIColor(named: "标题字颜色")
            adrFisrtLbl.font = UIFont.systemFont(ofSize: 13)
            changeCellSortView?.addSubview(adrFisrtLbl)
            adrFisrtLbl.snp.makeConstraints { (make) in
                make.centerY.equalTo(blueL.snp.centerY)
                make.left.equalTo(blueL.snp.right).offset(10)
                make.right.equalTo(15)
                make.height.equalTo(18.5)
            }
            
            let line2 = UIView()
            line2.backgroundColor = UIColor(named: "灰色分界线")
            changeCellSortView?.addSubview(line2)
            line2.snp.makeConstraints { (make) in
                make.top.equalTo(line.snp.bottom).offset(49)
                make.left.equalTo(15)
                make.right.equalTo(0)
                make.height.equalTo(1)
            }
            
            let tbv = UITableView()
            tbv.tag = 999
            tbv.separatorStyle = .none
            tbv.setEditing(true, animated:true)
            tbv.delegate = self
            tbv.dataSource = self
            tbv.register(UINib(nibName: "ToFormChangeTableViewCell", bundle: nil), forCellReuseIdentifier: "ToFormChangeTableViewCell")
            changeCellSortView?.addSubview(tbv)
            tbv.snp.makeConstraints { (make) in
                make.top.equalTo(line2.snp.bottom)
                make.left.right.equalTo(0)
                make.bottom.equalTo(leftBtn.snp.top)
            }
            
            
        }else{
            print("添加")
            if locationIsOpen  == false {
                checkLocation()
                return
            }
            
            if adrDatas.count == 0 {
                HUD.flash(.progress)
                cityList(["user_token":UserToken as Any,"nonce_str":String.randomStr(len: 30) as Any], success: { (data) in
                    let model = data as! cityListModel
                    
                    self.adrDatas.removeAll()
                    for item in model.data! {
                        if self.selectLoc.contains("\(item.name!)") || self.selectLoc.localizedLowercase.contains("\(item.name_en!)") {
                            self.loc = item
                        }
                        self.adrDatas.append(item)
                    }
                    let vc = ToAndFormSelectViewController()
                    vc.idx = 10086
                    vc.adrDatasArr = self.adrDatas
                    vc.delegate = self
                    self.navigationController?.pushViewController(vc, animated: true)
                    HUD.hide()
                }) { (err) in
                    
                }
            }else{
                let vc = ToAndFormSelectViewController()
                vc.idx = 10086
                vc.adrDatasArr = adrDatas
                vc.delegate = self
                if adrDatas.count > 0 {
                    self.navigationController?.pushViewController(vc, animated: true)
                }
            }
            
            
            
        }
        
    }
    @objc func changeCellSortAc(sender:UIButton){
        changeCellSortView?.isHidden = true
        closeBtn?.isHidden = true
        if sender.tag == 0 {
            print("左边")
            adrArr = tempadrArr
        }
        
        hListView.reloadData()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if tableView == listView {
            if section == 0 {
                return 10
            }
            if section == 1 {
                return 5
            }
            
            return 41.5
        }else{//货拉拉
            
            if section == 1 {
                return 49
            }
            return 5
            
        }
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        if tableView.tag == 999 {
            return 1
        }
        if tableView == listView {
            //            return 4
            //            //待修改
            return 3
        }else{//货拉拉
            return 5
        }
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView.tag == 999 {
            return adrArr.count - 1
        }
        if tableView == listView {
            switch section {
            case 0:return 2
            case 1:return 4
                //            //待修改
                //            case 3:return 1
            //注释case 3
            default: return 2
            }
        }else{//货拉拉
            switch section {
            case 0:
                //MARK: --  车型附加选项，打开即可使用
                //                if carTypesArr.count > 0 {
                //                    let carItem = carTypesArr[selectCarType]
                //                    if carItem.vehicle_std_arr!.count > 0 {
                //                        return 2
                //                    }
                //                }
                return 1
            case 1:
                if adrArr.count < 2 {
                    return 2
                }
                return adrArr.count
            case 2:return 4
            case 3:return 2
            default:break
            }
        }
        return 0
    }
    
    var bzIdx = 10086
    var bzArr = ["0元最高保5万","3元最高保10万","4元最高保20万","6元最高保30万","10元最高保50万","40元最高保100万","100元最高保200万"]
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if tableView == listView {
            if indexPath.section == 1 {
                if indexPath.row < 3 {
                    switch indexPath.row {
                    case 0:
                        if jtwxxView == nil {
                            let view = JiTuoWuXinXiView(frame: self.view.bounds)
                            view.delegate = self
                            self.view.addSubview(view)
                            jtwxxView = view
                            if self.itemName.count > 0 {
                                jtwxxView?.itemNameTF.text =  self.itemName
                                jtwxxView?.tiJiTF.text = String(format: "%.2f", (tiJi)!)
                                jtwxxView?.weightTf.text = String(format: "%.f", (weight)!)
                                jtwxxView?.countTf.text = String(format: "%.d", (count)!)
                                jtwxxView?.infoSw.isOn = isCheck!
                                jtwxxView?.changTf.text = chang
                                jtwxxView?.kuanTf.text = kuang
                                jtwxxView?.gaoTf.text = gao
                            }
                        }
                        break
                    case 1:
                        let vc = JiPaiFangShiViewController()
                        vc.delegate = self
                        vc.timeData = self.timeData
                        vc.pickup_time = self.pickup_time
                        vc.day = self.day
                        self.navigationController?.pushViewController(vc, animated: true)
                        break
                    default:
                        let vc = ZengZhiServicesViewController()
                        vc.delegate = self
                        if self.price != nil {
                            vc.price = String(format: "%.2f",(self.price)!)
                        }
                        if commend.count > 0 {
                            vc.commend = commend
                            
                        }
                        self.navigationController?.pushViewController(vc, animated: true)
                        break
                    }
                }
            }
        }else{//MARK: - 货拉拉did select
            if indexPath.section == 1 {
                if locationIsOpen == false {
                    checkLocation()
                    return
                }
                if adrDatas.count == 0 {
                    HUD.flash(.progress)
                    cityList(["user_token":UserToken as Any,"nonce_str":String.randomStr(len: 30) as Any], success: { (data) in
                        let model = data as! cityListModel
                        
                        self.adrDatas.removeAll()
                        for item in model.data! {
                            if self.selectLoc.contains("\(item.name!)") || self.selectLoc.localizedLowercase.contains("\(item.name_en!)") {
                                self.loc = item
                            }
                            self.adrDatas.append(item)
                        }
                        let vc = ToAndFormSelectViewController()
                        vc.idx = indexPath.row
                        vc.adrDatasArr = self.adrDatas
                        vc.delegate = self
                        
                        
                        if self.adrArr.count > indexPath.row {
                            let dict = self.adrArr[indexPath.row] as! NSDictionary
                            if dict["locName"] as! String != "空" && dict["locName"] != nil{
                                vc.nameStr = (dict["shouHuoRen"] as! String)
                                vc.phoneNum = (dict["phoneNum"] as! String)
                                vc.adrStr = (dict["menPai"] as! String)
                                let adr = dict["adr"] as! cityListDataModel
                                vc.lat = adr.lat_lon!.lat!
                                vc.lng = adr.lat_lon!.lon!
                            }
                        }
                        
                        self.navigationController?.pushViewController(vc, animated: true)
                        HUD.hide()
                    }) { (err) in
                        
                    }
                }else{
                    
                    let vc = ToAndFormSelectViewController()
                    vc.idx = indexPath.row
                    vc.adrDatasArr = adrDatas
                    vc.delegate = self
                    
                    if adrArr.count > indexPath.row {
                        let dict = adrArr[indexPath.row] as! NSDictionary
                        if dict["locName"] as! String != "空" && dict["locName"] != nil{
                            vc.nameStr = (dict["shouHuoRen"] as! String)
                            vc.phoneNum = (dict["phoneNum"] as! String)
                            vc.adrStr = (dict["menPai"] as! String)
                            let coordinate = (dict["lat_lon"] as! NSString).components(separatedBy: "_")
                            vc.lat = (coordinate.first as! NSString).doubleValue
                            vc.lng = (coordinate.last as! NSString).doubleValue
                        }
                    }
                    
                    if adrDatas.count > 0 {
                        
                        self.navigationController?.pushViewController(vc, animated: true)
                    }
                }
            }
            
            if indexPath.section == 2 {
                if indexPath.row == 1 {
                    let view = XiaDanUserInfoViewController()
                    view.delegate = self
                    view.str = xiaDanRenMsg
                    self.navigationController?.pushViewController(view, animated: true)
                }
                if indexPath.row == 2 {
                    let view = OtherDemandViewController()
                    view.delegate = self
                    view.carModel = carModel
                    view.selectArr = selectAr
                    self.navigationController?.pushViewController(view, animated: true)
                }
                //保障
                if indexPath.row == 3 {
                    //                    if glSelectView == nil {
                    //                        let view = GLAlertSelectView(frame: self.view.bounds)
                    //                        view.delegate = self
                    //                        view.isBz = true
                    //                        if bzIdx != 10086 {
                    //                            view.selectNum = bzIdx
                    //                            view.tempNum = view.selectNum
                    //                        }
                    //                        view.titleLbl.text = "货物保障"
                    //                        view.dataArr = bzArr
                    //                        self.view.addSubview(view)
                    //                        glSelectView = view
                    //                    }
                }
                //时间
                if indexPath.row == 0 {
                    HUD.flash(.progress)
                    getHllTime(["user_token":UserToken as Any], success: { (data) in
                        let model = data as! getHllTimeModel
                        if self.bgBtn == nil {
                            let btn = UIButton()
                            self.view.addSubview(btn)
                            btn.backgroundColor = UIColor.black
                            btn.alpha = 0.4
                            btn.addTarget(self, action: #selector(self.closeAc), for: .touchUpInside)
                            btn.snp.makeConstraints { (make) in
                                make.top.right.bottom.left.equalTo(0)
                            }
                            self.bgBtn = btn
                        }
                        
                        if self.btmView == nil {
                            let view = UIView()
                            view.backgroundColor = UIColor.white
                            self.view.addSubview(view)
                            self.btmView = view
                            view.snp.makeConstraints { (make) in
                                make.left.bottom.right.equalTo(0)
                                make.height.equalTo(360)
                            }
                            view.layer.cornerRadius = 5
                            view.layer.maskedCorners = [CACornerMask.layerMinXMinYCorner,CACornerMask.layerMaxXMinYCorner]
                        }
                        
                        self.dayArr.removeAll()
                        for item in model.data! {
                            self.dayArr.append(item)
                        }
                        self.showTimeSelect(view: self.btmView!)
                        HUD.hide()
                    }) { (err) in
                        
                    }
                }
            }
        }
    }
    var glSelectView:GLAlertSelectView?
    
    @objc func closeAc(){
        bgBtn?.removeFromSuperview()
        btmView?.subviews.forEach({ (view) in
            view.removeFromSuperview()
        })
        btmView?.removeFromSuperview()
        btmView = nil
        bgBtn = nil
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if tableView.tag == 999 {
            return 49
        }
        if tableView == listView {
            if indexPath.section == 0 {
                if indexPath.row == 0 {
                    if sender != nil {
                        return 93
                    }
                }
                if indexPath.row == 1 {
                    if receiver != nil {
                        return 93
                    }
                }
                
                return 70
            }
            if indexPath.section == 1{
                if indexPath.row == 3 {
                    return 96
                }
                return 49
            }
            if indexPath.section == 3 {
                return 128
            }
            return 49
            
        }else{//货拉拉
            if indexPath.section == 0 {
                if indexPath.row == 0 {
                    return 181
                }
                return UITableView.automaticDimension
            }
            if indexPath.section == 1 {
                return UITableView.automaticDimension
            }
            return 49
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if tableView.tag == 999 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "ToFormChangeTableViewCell") as! ToFormChangeTableViewCell
            cell.accessoryType = UITableViewCell.AccessoryType.disclosureIndicator
            let dict = adrArr[indexPath.row+1] as! NSDictionary
            cell.titleLbl.text = dict["locName"] as! String
            return cell
        }
        
        if tableView == listView {
            switch indexPath.section {
                
            case 3:
                let cell = tableView.dequeueReusableCell(withIdentifier: "LalamoveBillTableViewCell") as! LalamoveBillTableViewCell
                
                cell.datasArr = datasArr
                return cell
                
            case 0:
                let cell = tableView.dequeueReusableCell(withIdentifier: "AdressSelect") as! AdressSelectCell
                cell.titleLbl.text = "寄"
                
                cell.tag = indexPath.row
                cell.delegate = self
                cell.contentLbl.isHidden = false
                cell.contentV.isHidden = true
                if indexPath.row == 0 {
                    if sender != nil {
                        cell.contentLbl.isHidden = true
                        cell.contentV.isHidden = false
                        cell.nameLbl.text = sender!
                        cell.phoneLbl.text = sendPhone!
                        cell.adrLbl.text = sendAdr!
                    }
                }
                if indexPath.row == 1 {
                    cell.titleLbl.backgroundColor = UIColor(named: "企业、预售字体")
                    cell.titleLbl.text = "收"
                    if receiver != nil {
                        cell.contentLbl.isHidden = true
                        cell.contentV.isHidden = false
                        cell.nameLbl.text = receiver!
                        cell.phoneLbl.text = receivePhone!
                        cell.adrLbl.text = receiveAdr!
                    }
                }
                return cell
            case 1:
                let cell = tableView.dequeueReusableCell(withIdentifier: "PersonCenter") as! PersonCenterCell
                cell.titleLbl.text = titleArr[indexPath.row]
                if indexPath.row == 0 {
                    cell.introLbl.text = "（必填）"
                    cell.introLbl.textColor = UIColor(named: "蓝色字体颜色")
                    cell.introLbl.isHidden = false
                    if isCheck != nil {
                        cell.contentStr = itemName + "; \(count!)箱; \(weight!)kg"
                    }
                }
                if indexPath.row == 1 {
                    var sendStr = "上门提货"
                    if send != 0 {
                        sendStr = "自送到库"
                    }
                    var receiveStr = "送货上门"
                    if receive != 0 {
                        receiveStr = "到库自取"
                    }
                    cell.contentStr = sendStr + "; " + receiveStr
                }
                if indexPath.row == 2 {
                    cell.introLbl.isHidden = false
                    if price != nil {
                        cell.contentStr = "保价金额:\(price!)"
                    }
                }
                if indexPath.row == 3 {
                    let cell = tableView.dequeueReusableCell(withIdentifier: "WenDu") as! WenDuCell
                    cell.titleLbl.text = titleArr[indexPath.row]
                    cell.delegate = self
                    return cell
                }
                
                
                return cell
            default:
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFBtnCell") as! TitleAndTFBtnCell
                cell.delegate = self
                cell.tag = indexPath.row
                cell.nameLbl.text = title2Arr[indexPath.row]
                return cell
            }
        }else{
            //MARK: - 货拉拉cell
            if indexPath.section == 0 {
                if indexPath.row == 1 {
                    let cell = tableView.dequeueReusableCell(withIdentifier: "OnlyViewCell") as! OnlyViewCell
                    cell.datas = carTypesArr[selectCarType].vehicle_std_arr
                    cell.delegate = self
                    
                    return cell
                }
                let cell = tableView.dequeueReusableCell(withIdentifier: "HLLTopCell") as! HLLTopCell
                cell.datas = carTypesArr
                cell.delegate = self
                cell.idx = selectCarType
                return cell
            }
            if indexPath.section == 1 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "WayBillAddressCanDelItemCell") as! WayBillAddressCanDelItemCell
                cell.tag = indexPath.row
                cell.delegate = self
                cell.iconW.constant = 22
                cell.iconH.constant = 22
                cell.iconLbl.layer.cornerRadius = 11
                cell.lineTopView.isHidden = false
                cell.delBtn.isHidden = true
                
                if adrArr.count > 1 && indexPath.row != 0 {
                    cell.delBtn.isHidden = false
                    let dict = adrArr[indexPath.row] as! NSDictionary
                    
                    cell.addressLbl.text = dict["locName"] as! String
                    let menPai = (dict["menPai"]! as! String)
                    let shouHuoRen = (dict["shouHuoRen"]! as! String)
                    let phoneNum = (dict["phoneNum"]! as! String)
                    
                    
                    cell.addressDetailLbl.text = menPai
                    cell.namePhoneLbl.text = shouHuoRen + " " + phoneNum
                    
                    cell.delBtnTop.constant = -25
                    if menPai.count > 0 || (phoneNum.count > 0 || shouHuoRen.count > 0) {
                        cell.topH.constant = 5
                        cell.delBtnTop.constant = -13
                    }
                    
                    if menPai.count > 0 && (phoneNum.count > 0 || shouHuoRen.count > 0) {
                        cell.topH.constant = 5
                        cell.delBtnTop.constant = 0
                    }
                }else{
                    cell.topH.constant = 25
                }
                
                if indexPath.row == 0 {
                    cell.namePhoneLbl.text = ""
                    cell.delBtn.isHidden = true
                    cell.iconLbl.text = "发"
                    cell.iconLbl.backgroundColor = UIColor.init(named: "蓝色字体颜色")
                    cell.lineTopView.isHidden = true
                    
                    if adrArr.count > 0 {
                        let dict = adrArr[indexPath.row] as! NSDictionary
                        if (dict["locName"] as! String) != "空" {
                            cell.addressDetailLbl.isHidden = false
                            cell.namePhoneLbl.isHidden = false
                            cell.nodataLbl.isHidden = true
                            cell.addressLbl.isHidden = false
                            cell.addressLbl.text = dict["locName"] as! String
                            let menPai = (dict["menPai"]! as! String)
                            let shouHuoRen = (dict["shouHuoRen"]! as! String)
                            let phoneNum = (dict["phoneNum"]! as! String)
                            
                            cell.addressDetailLbl.text = menPai
                            cell.namePhoneLbl.text = shouHuoRen + " " + phoneNum
                            
                            if menPai.count > 0 || (phoneNum.count > 0 || shouHuoRen.count > 0) {
                                cell.topH.constant = 5
                            }
                        }else{
                            cell.addressDetailLbl.isHidden = true
                            cell.namePhoneLbl.isHidden = true
                            cell.addressLbl.isHidden = true
                        }
                    }
                }
                
                if indexPath.row != adrArr.count - 1 && indexPath.row != 0 && adrArr.count > 2 {
                    cell.iconLbl.text = ""
                    cell.iconLbl.backgroundColor = UIColor.init(named: "虚线分界线颜色")
                    cell.iconW.constant = 12
                    cell.iconH.constant = 12
                    cell.iconLbl.layer.cornerRadius = 6
                }
                
                if (indexPath.row == adrArr.count - 1 || adrArr.count <= 1) && indexPath.row != 0  {
                    //最后的不显示lineview
                    cell.lineView.isHidden = true
                    cell.iconLbl.text = "收"
                    cell.nodataLbl.text = "请选择或填写收货信息"
                    if adrArr.count > 1 {
                        cell.nodataLbl.isHidden = true
                        cell.addressDetailLbl.isHidden = false
                        cell.namePhoneLbl.isHidden = false
                        cell.addressLbl.isHidden = false
                    }else{
                        cell.addressDetailLbl.isHidden = true
                        cell.namePhoneLbl.isHidden = true
                        cell.addressLbl.isHidden = true
                        cell.nodataLbl.isHidden = false
                    }
                    cell.iconLbl.backgroundColor = UIColor.init(named: "企业、预售字体")
                }else{
                    cell.lineView.isHidden = false
                }
                
                
                
                return cell
            }
            if indexPath.section == 2 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                cell.btn.isUserInteractionEnabled = false
                cell.nameLbl.text = hPart2[indexPath.row]
                cell.contentLbl.text = hPart2P[indexPath.row]
                if indexPath.row == 3 {
                    cell.contentLbl.text = "0元最高保5万"
                }
                return cell
            }
            if indexPath.section == 4 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSwitchCell") as! TitleAndSwitchCell
                cell.namelbl.text = "号码保护"
                cell.introLbl.isHidden = false
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFBtnCell") as! TitleAndTFBtnCell
            cell.nameLbl.text = hPart3[indexPath.row]
            return cell
        }
    }
    @objc func topBtnClick(btn:UIButton){
        //顶栏按钮
        
        selectCarType = btn.tag
        
        showScrollUI()
        let idx = IndexPath(row: 0, section: 0)
        let cell = hListView.cellForRow(at:idx) as! HLLTopCell
        cell.scrollView?.setContentOffset(CGPoint(x: selectCarType * Int(CGFloat(cell.scViewBg.bounds.size.width)), y: 0), animated: true)
        
        
    }
    
    
    
    var btnArr:Array<UIButton> = []
    var lineArr:Array<UIView> = []
    var topBtnScv:UIScrollView!
    func setBtnUI(carTypesArr:Array<vehicle_arr_data>,view:UIView){
        isAlready = false
        btnArr.removeAll()
        lineArr.removeAll()
        for item in view.subviews {
            item.removeFromSuperview()
        }
        let scv = UIScrollView(frame: view.bounds)
        view.addSubview(scv)
        topBtnScv = scv
        var scvContentWidth = 0
        scv.showsHorizontalScrollIndicator = false
        scv.tag = 99
        for i in 0 ..< carTypesArr.count {
            let btn = UIButton()
            let model = carTypesArr[i]
            btn.setTitle(model.name, for: .normal)
            btn.tag = i
            scv.addSubview(btn)
            btn.sizeToFit()
            var x:CGFloat = 0
            if btnArr.count != 0 {
                let button = btnArr[i-1]
                x = button.frame.maxX
            }
            btn.frame = CGRect(x:x, y: 0, width: btn.bounds.size.width + 6, height: 44)
            btn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
            btn.setTitleColor(UIColor(named: "提示语字体颜色"), for: .normal)
            btn.addTarget(self, action: #selector(topBtnClick), for: .touchUpInside)
            btnArr.append(btn)
            scvContentWidth += Int(btn.bounds.size.width)
            
            let topBtnLine = UIView()
            topBtnLine.tag = btn.tag
            topBtnLine.backgroundColor = UIColor(named: "蓝色字体颜色")
            topBtnLine.layer.cornerRadius = 1.25
            topBtnLine.layer.masksToBounds = true
            topBtnLine.isHidden = true
            btn.addSubview(topBtnLine)
            topBtnLine.snp.makeConstraints { (make) in
                make.bottom.equalToSuperview()
                make.left.equalTo(10)
                make.right.equalTo(-10)
                make.height.equalTo(3)
            }
            lineArr.append(topBtnLine)
        }
        
        scv.contentSize = CGSize(width: scvContentWidth, height:1)
        if carTypesArr.count > 5 {
            let button = UIButton(frame: CGRect(x: fullScreenWidth-44, y: 0, width: 44, height: 44))
            button.backgroundColor = UIColor.white
            button.setImage(UIImage(named: "dot"), for: .normal)
            view.addSubview(button)
            button.addTarget(self, action: #selector(selectAllCars), for: .touchUpInside)
            let line = UIView()
            line.backgroundColor = UIColor(named: "灰色分界线")
            view.addSubview(line)
            line.snp_makeConstraints { (make) in
                make.height.equalTo(30)
                make.width.equalTo(1)
                make.right.equalTo(button.snp_left)
                make.centerY.equalTo(view.snp_centerY)
            }
            
            scv.snp.updateConstraints { (make) in
                make.top.left.bottom.equalToSuperview()
                make.right.equalTo(line.snp.left)
            }
        }
        
        if btnArr.count > 0 {
            let btn = btnArr.first
            btn!.isSelected = true
            btn!.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            let line = lineArr.first
            line!.isHidden = false
        }
        
    }
    
    //MARK: - 选择所有车型
    
    var carListView:UIView?
    var cBtn:UIButton?
    @objc func closeCarList(){
        carListView?.isHidden = true
        cBtn?.isHidden = true
        closeBtn?.isHidden = true
        changeCellSortView?.isHidden = true
    }
    @objc func selectAllCars(){
        cBtn?.isHidden = false
        carListView?.isHidden = false
        let w = fullScreenWidth / 3
        var a = 0
        if carTypesArr.count % 3 != 0 {
            a = 1
        }
        let h = w * CGFloat(a + carTypesArr.count / 3)
        if carListView == nil {
            let view = UIView(frame: CGRect(x: 0, y: topBtnView.frame.maxY, width: fullScreenWidth, height: h + 44))
            view.backgroundColor = UIColor.white
            self.view.addSubview(view)
            carListView = view
            
            
            let lbl = UILabel(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 44))
            lbl.text = "所有车型"
            lbl.textAlignment = .center
            lbl.font = UIFont.systemFont(ofSize: 13)
            lbl.textColor = UIColor(named: "标题字颜色")
            carListView!.addSubview(lbl)
            
            let closeBtn = UIButton(frame: CGRect(x: fullScreenWidth-44, y: 0, width: 44, height: 44))
            //            closeBtn.backgroundColor = UIColor.red
            closeBtn.setImage(UIImage(named: "xx"), for: .normal)
            closeBtn.addTarget(self, action: #selector(closeCarList), for: .touchUpInside)
            carListView!.addSubview(closeBtn)
            
            
            let line = UIView(frame: CGRect(x: 0, y: 43.5, width: fullScreenWidth, height: 0.5))
            line.backgroundColor = UIColor(named: "灰色分界线")
            carListView!.addSubview(line)
            
            for i in 0 ..< carTypesArr.count {
                setCarListUI(index: i, bg: carListView!)
            }
        }
        
        let width = CGFloat(3 - carTypesArr.count % 3) * w
        let yValue = (CGFloat(carTypesArr.count / 3) * w )+44
        
        let lineV = UIView(frame: CGRect(x: fullScreenWidth - width, y: yValue, width: width, height: w))
        lineV.layer.borderColor = UIColor(named: "灰色分界线")?.cgColor
        lineV.layer.borderWidth = 0.5
        carListView!.addSubview(lineV)
        
        if cBtn == nil {
            cBtn = UIButton()
            cBtn!.backgroundColor = UIColor(named: "标题字颜色")
            cBtn!.alpha = 0.4
            cBtn?.addTarget(self, action: #selector(closeCarList), for: .touchUpInside)
            self.view.addSubview(cBtn!)
            cBtn?.snp_makeConstraints({ (make) in
                make.top.equalTo(carListView!.snp_bottom).offset(0)
                make.left.right.bottom.equalToSuperview()
            })
        }
    }
    
    func setCarListUI(index:Int,bg:UIView){
        let w = fullScreenWidth / 3
        let cols = 3
        
        let col = index % cols
        let row = index / cols
        
        let shopX = CGFloat(col) * w
        let shopY = CGFloat(row) * w
        let btn = UIButton(frame: CGRect(x: shopX, y: shopY+44, width: w, height: w))
        btn.addTarget(self, action: #selector(carSelect(sender:)), for: .touchUpInside)
        btn.tag = index
        btn.layer.borderColor = UIColor(named: "灰色分界线")?.cgColor
        btn.layer.borderWidth = 0.5
        let model = carTypesArr[index]
        let imgV = UIImageView()
        SDWebImageDownloader.shared.downloadImage(with: URL(string:model.img_url_high_light!), options: .continueInBackground, progress: { (a, b, nil) in
        }) { (img, data, err, true) in
            imgV.image = img
            let p = w / (imgV.image?.size.width)!
            imgV.frame = CGRect(x: btn.frame.origin.x, y: btn.frame.origin.y + 15, width: w, height: w * p * 1.8)
            
            let lbl = UILabel(frame: CGRect(x: btn.frame.origin.x, y: btn.frame.origin.y + 10 + imgV.bounds.size.height, width: w, height: w - (w * p * 2.5)))
            lbl.textColor = UIColor(named: "灰色字体颜色")
            lbl.font = UIFont.systemFont(ofSize: 13)
            lbl.textAlignment = .center
            lbl.text = model.name
            bg.addSubview(lbl)
        }
        bg.addSubview(imgV)
        
        
        btn.setTitleColor(UIColor.black, for: .normal)
        bg.addSubview(btn)
    }
    
    
    @objc func carSelect(sender:UIButton){
        
        let btn = btnArr[sender.tag]
        topBtnClick(btn: btn)
        closeCarList()
        let idx = IndexPath(row: 0, section: 0)
        let cell = hListView.cellForRow(at:idx) as! HLLTopCell
        let w = cell.scViewBg.bounds.size.width
        cell.scrollView?.setContentOffset(CGPoint(x: sender.tag * Int(w), y: 0), animated: true)
        cell.idx = sender.tag
        
        let x = btn.frame.minX
        let rect = CGRect(x: Int(x), y: 0, width: Int(w), height: 1)
        topBtnScv.scrollRectToVisible(rect, animated: true)
        
        selectCarType = sender.tag
    }
    
    //MARK:---预估费用操作
    var logPayPriceModel :registerDataModel? = nil
    func getLogPayPrice() {
        
        if r_city == nil || s_city == nil || weight == nil || tiJi == nil{
            return
        }
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        let addr = ["s_city":s_city as Any,"r_city":r_city as Any,"s_province_name":s_province_name as Any,"r_province_name":r_province_name as Any,"s_city_name":s_city_name as Any,"r_city_name":r_city_name as Any,"s_district_name":s_district_name as Any,"r_district_name":r_district_name as Any]
        
        var home_delivery_on = "false"
        if send == 0 {
            home_delivery_on = "true"
        }
        var site_delivery = "false"
        if receive == 0 {
            site_delivery = "true"
        }
        let info = ["weight":weight as Any,"volume":tiJi as Any,"home_delivery_on":home_delivery_on as Any,"site_delivery":site_delivery as Any]
        
        
        let dict = ["user_token":UserToken as Any,"addr":addr as Any,"info":info as Any]
        estimatedCost(dict, success: { (data) in
            
            let dataModel = data as! registerModel
            self.logPayPriceModel = dataModel.data
            self.priceLbl.text = "￥" + String(format: "%.2f", (dataModel.data?.price_jd)!)
            if dataModel.data?.price_jd != "-" {
                self.priceLbl.text = "￥" + String(format: "%.2f", (dataModel.data?.price_jd)!)
                let num1 = dataModel.data?.price_sf
                let num2 = dataModel.data?.price_jd as! NSString
                if num1! > num2.floatValue {
                    self.priceLbl.text = "￥" + (dataModel.data?.price_jd)!
                }
            }
        }) { (error) in
            
        }
        
    }
    
    func addLogisticsOrderUpdata() {
        var home_delivery_on = 0
        if send == 0 {
            home_delivery_on = 1
        }
        var site_delivery = 1
        if receive == 0 {
            site_delivery = 1
        }else{
            site_delivery = 0
        }
        
        
        let infodic = ["order_sn":guanlianDingStr as Any,
                       "sale_plat":guanlianPingStr as Any,
                       "express_item_name":itemName as Any,
                       "weight":weight as Any,
                       "volume":tiJi as Any,
                       "express_item_qty":count as Any,
                       "tempture_num":wenduIndex as Any,
                       "home_delivery_on":home_delivery_on as Any,
                       "site_delivery":site_delivery as Any,
                       "remark":commend as Any,
                       "guarantee_value":price as Any,
                       "fc_flag":0 as Any,
                       "pickup_time":pickup_time as Any,
                       "day":day as Any,
                       "lc_id":lc_id as Any]
        
        
        let addrdic = ["s_consignee":sender as Any,
                       "s_country":1 as Any,
                       "s_province":s_province as Any,
                       "s_city":s_city as Any,
                       "s_district":s_district as Any,
                       "s_province_name":s_province_name as Any,
                       "s_city_name":s_city_name as Any,
                       "s_district_name":s_district_name as Any,
                       "s_address":sendAdr as Any,
                       "s_mobile":sendPhone as Any,
                       "r_consignee":receiver as Any,
                       "r_country":1 as Any,
                       "r_province":r_province as Any,
                       "r_city":r_city as Any,
                       "r_district":r_district as Any,
                       "r_province_name":r_province_name as Any,
                       "r_city_name":r_city_name as Any,
                       "r_district_name":r_district_name as Any,
                       "r_address":receiveAdr as Any,
                       "r_mobile":receivePhone as Any]
        
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        
        let dic = ["info":infodic as Any,"addr":addrdic as Any,"user_token":UserToken as Any]
        
        addLogisticsOrder(dic, success: { (data) in
            let dataModel = data as! AddLogisticsOrderModel
            
            let vc = XiaDanChengGongViewController()
            vc.orderID = dataModel.data?.id
            self.navigationController?.pushViewController(vc, animated: true)
        }) { (error) in
            
        }
        
    }
    //选择器
    var pickerView:UIPickerView!
    //所以地址数据集合
    var dayArr:Array<getHllTimeDataModel> = []
    
    var dayIdx = 0
    var hourIdx = 0
    var minIdx = 0
    //MARK:--地址选择器
    func showTimeSelect(view:UIView){
        let lbl = UILabel()
        view.addSubview(lbl)
        lbl.text = "请选择用车时间"
        lbl.font = UIFont(name: "PingFangSC-Medium", size: 15)
        lbl.textColor = UIColor(named: "标题字颜色")
        lbl.textAlignment = .center
        lbl.snp.makeConstraints { (make) in
            make.top.left.right.equalTo(0)
            make.height.equalTo(50)
        }
        
        let line = UIView()
        view.addSubview(line)
        line.backgroundColor = UIColor(named: "灰色分界线")
        line.snp.makeConstraints { (make) in
            make.top.equalTo(lbl.snp.bottom)
            make.left.right.equalTo(0)
            make.height.equalTo(1)
        }
        //创建选择器
        pickerView=UIPickerView()
        //将dataSource设置成自己
        pickerView.dataSource=self
        //将delegate设置成自己
        pickerView.delegate=self
        view.addSubview(pickerView)
        
        
        pickerView.snp.makeConstraints { (make) in
            make.top.equalTo(line.snp.bottom)
            make.left.right.equalTo(0)
            make.bottom.equalTo(-TabHeight)
        }
        pickerView.selectRow(dayIdx, inComponent: 0, animated: false)
        pickerView(pickerView, didSelectRow: dayIdx, inComponent: 0)
        pickerView.selectRow(hourIdx, inComponent: 1, animated: false)
        pickerView(pickerView, didSelectRow: hourIdx, inComponent: 1)
        pickerView.selectRow(minIdx, inComponent: 2, animated: false)
        pickerView(pickerView, didSelectRow: minIdx, inComponent: 2)
        
        let btmBtn = UIButton()
        btmBtn.backgroundColor = UIColor(named: "按钮渐变色上")
        btmBtn.setTitleColor(UIColor.white, for: .normal)
        btmBtn.addTarget(self, action: #selector(submitAc), for: .touchUpInside)
        view.addSubview(btmBtn)
        btmBtn.snp.makeConstraints { (make) in
            make.top.equalTo(pickerView.snp.bottom)
            make.left.right.bottom.equalTo(0)
        }
        
        let lbl1 = UILabel()
        lbl1.text = "确定"
        lbl1.font = UIFont.init(name: "PingFangSC-Medium", size: 15)
        lbl1.textColor = UIColor.white
        lbl1.textAlignment = .center
        view.addSubview(lbl1)
        lbl1.snp.makeConstraints { (make) in
            make.top.equalTo(pickerView.snp.bottom)
            make.left.right.equalTo(0)
            make.height.equalTo(49)
        }
    }
    var stime:Double = 0
    @objc func submitAc(){
        let day = dayArr[dayIdx]
        let mins = day.h![hourIdx]
        if dayIdx == 0 && hourIdx == 0 {
            stime = mins.stime!
        }else{
            let min = mins.i![minIdx]
            stime = min.stime!
        }
        var dateTimeStr = ""
        if dayIdx == 0 && hourIdx == 0 {
            dateTimeStr =  "立刻用车"
        }else{
            dateTimeStr =  "\(day.date!):\(String(describing: day.h![hourIdx].val!)):\(String(describing: mins.i![minIdx].val!))"
        }
        hPart2P.insert(dateTimeStr, at: 0)
        hPart2P.remove(at: 1)
        hListView.reloadData()
        bgBtn?.removeFromSuperview()
        bgBtn = nil
        btmView?.removeFromSuperview()
        btmView = nil
        print("时间戳 -- ",stime)
    }
    
    //设置选择框的列数为3列,继承于UIPickerViewDataSource协议
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 3
    }
    
    //设置选择框的行数，继承于UIPickerViewDataSource协议
    func pickerView(_ pickerView: UIPickerView,
                    numberOfRowsInComponent component: Int) -> Int {
        let model = self.dayArr[dayIdx]
        if component == 0 {
            return self.dayArr.count
        } else if component == 1 {
            let hours = model.h
            return hours!.count
        } else {
            if dayIdx == 0 && hourIdx == 0{
                return 0
            }else{
                
                let hour = model.h![hourIdx]
                if hour.i == nil {
                    return 0
                }
                return hour.i!.count
            }
        }
    }
    //设置选择框各选项的内容，继承于UIPickerViewDelegate协议
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int,
                    forComponent component: Int) -> String? {
        if component == 0 {
            let model = self.dayArr[row]
            return model.date
        }else if component == 1 {
            let day = self.dayArr[dayIdx]
            let hour = day.h![row]
            return hour.val
        }else {
            let day = self.dayArr[dayIdx]
            let hours = day.h!
            let hour = hours[hourIdx]
            let mins = hour.i!
            return mins[row].val
        }
    }
    
    //选中项改变事件（将在滑动停止后触发）
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int,
                    inComponent component: Int) {
        //根据列、行索引判断需要改变数据的区域
        switch (component) {
        case 0:
            dayIdx = row;
            pickerView.reloadComponent(1);
            pickerView.reloadComponent(2);
            pickerView.selectRow(hourIdx, inComponent: 1, animated: false)
            pickerView.selectRow(minIdx, inComponent: 2, animated: false)
        case 1:
            hourIdx = row;
            pickerView.reloadComponent(2);
            pickerView.selectRow(minIdx, inComponent: 2, animated: false)
        case 2:
            minIdx = row;
        default:
            break;
        }
    }
    //自定义UIPickerView
    func pickerView(_ pickerView: UIPickerView, viewForRow row: Int, forComponent component: Int, reusing view: UIView?) -> UIView {
        let genderLbl = UILabel()
        genderLbl.textAlignment = .center
        genderLbl.font = UIFont.systemFont(ofSize: 15)
        genderLbl.textColor = UIColor.init(named: "标题字颜色")
        
        if component == 0 {
            let rowDic = self.dayArr[row]
            genderLbl.text = rowDic.date
            
        }else if component == 1 {
            
            let day = self.dayArr[dayIdx]
            let hour = day.h![row]
            genderLbl.text = hour.val
        }else {
            let day = self.dayArr[dayIdx]
            let hours = day.h
            let hour = hours![hourIdx]
            let mins = hour.i!
            genderLbl.text = mins[row].val
        }
        
        return genderLbl
    }
    
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        bzIdx = selectnum
        view.removeFromSuperview()
        glSelectView = nil
    }
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        bzIdx = selectNum
        if bzIdx != 10086 {
            hPart2P.insert(bzArr[bzIdx], at: 3)
            hPart2P.remove(at: 4)
            hListView.reloadData()
        }
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    
    
    
    //单元格的编辑样式
    func tableView(_ tableView: UITableView, editingStyleForRowAt indexPath: IndexPath)
        -> UITableViewCell.EditingStyle {
            return .none
    }
    //去除编辑模式下的头部缩进
    func tableView(_ tableView: UITableView, shouldIndentWhileEditingRowAt
        indexPath: IndexPath) -> Bool {
        return false
    }
    //在编辑状态，可以拖动设置cell位置
    func tableView(_ tableView: UITableView, canMoveRowAt indexPath: IndexPath) -> Bool {
        return true
    }
    
    //移动cell事件
    func tableView(_ tableView: UITableView, moveRowAt sourceIndexPath: IndexPath,
                   to destinationIndexPath: IndexPath) {
        
        if sourceIndexPath != destinationIndexPath{
            //获取移动行对应的值
            let itemValue:NSDictionary = adrArr[sourceIndexPath.row+1] as! NSDictionary
            //删除移动的值
            adrArr.remove(at: sourceIndexPath.row+1)
            //如果移动区域大于现有行数，直接在最后添加移动的值
            if destinationIndexPath.row+1 > adrArr.count{
                adrArr.append(itemValue)
            }else{
                //没有超过最大行数，则在目标位置添加刚才删除的值
                adrArr.insert(itemValue, at:destinationIndexPath.row+1)
            }
        }
    }
}
