//
//  RuKuViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/28.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class RuKuViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,AddGuiGeCellDelegate{
    
    
    let p1Arr1 = ["仓库：","库位：","入库类型：","入库时间："]
    let chu1Arr1 = ["仓库：","库位：","出库类型：","入库时间："]
    let p1Arr2 = ["默认仓库","默认库位","请选择入库类型","0"]
    let chu1Arr2 = ["默认仓库","默认库位","请选择出库类型","0"]
    let p3Arr1 = ["入库价格：","入库数量：","生产日期：","保质期：","检测报告："]
    @IBAction func submitAction(_ sender: Any) {
    }
    var barTitle:String?
    @IBOutlet weak var btmView: UIView!
    @IBOutlet weak var listVIew: UITableView!
    
    //测试数据
    var selectArr = ["1","2"]
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = barTitle
        
        self.view.addSubview(navbar)
        
        listVIew.separatorStyle = .none
        listVIew.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(btmView.snp_top)
        }
        listVIew.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listVIew.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtnCell")
        listVIew.register(UINib(nibName: "AddGuiGeCell", bundle: nil), forCellReuseIdentifier: "AddGuiGeCell")
        listVIew.register(UINib(nibName: "TitleAndOnlyBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndOnlyBtnCell")
        listVIew.register(UINib(nibName: "RuKuJiaGeCell", bundle: nil), forCellReuseIdentifier: "RuKuJiaGeCell")
        listVIew.register(UINib(nibName: "BaoZhiQiCell", bundle: nil), forCellReuseIdentifier: "BaoZhiQiCell")
        listVIew.register(UINib(nibName: "ChuKuCell", bundle: nil), forCellReuseIdentifier: "ChuKuCell")
    }
    //MARK: - cell delegate
    //header
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 1 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 36))
            view.backgroundColor = UIColor.white
            let title = UILabel()
            title.text = "商品清单"
            title.font = UIFont.boldSystemFont(ofSize: 15)
            title.textColor = UIColor(named: "标题字颜色")
            view.addSubview(title)
            title.sizeToFit()
            title.snp.makeConstraints { (make) in
                make.left.equalTo(15)
                make.height.equalTo(21)
                make.width.equalTo(title.bounds.size.width)
                make.bottom.equalTo(0)
            }
            let ti1 = UILabel()
            if barTitle == "入库"{
                ti1.text = "（只可选择一种商品入库）"
            }else{
                ti1.text = "（只可选择一种商品出库）"
            }
            ti1.font = UIFont.boldSystemFont(ofSize: 11)
            ti1.textColor = UIColor(named: "灰色字体颜色")
            view.addSubview(ti1)
            ti1.sizeToFit()
            ti1.snp.makeConstraints { (make) in
                make.left.equalTo(title.snp_right)
                make.height.equalTo(15)
                make.width.equalTo(ti1.bounds.size.width)
                make.bottom.equalTo(0)
            }
            return view
        }
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 1 {
            return 38
        }
        return 0.001
    }
    //footer
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 10
    }
    //cell
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 1 {
            return 123.5
        }
        return 49
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        switch section {
        case 0: return 4
        case 1:return 1
        default:
            if barTitle == "入库" {
                return 5
            }
            return 1 + selectArr.count
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            if indexPath.row == 3 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
                cell.textTF.isUserInteractionEnabled = false
                if barTitle == "入库"{
                    cell.nameLbl.text = p1Arr1[indexPath.row]
                }else{
                    cell.nameLbl.text = chu1Arr1[indexPath.row]
                }
                
                cell.textTF.text = "2020.03.16  15:03:56"
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
            if barTitle == "入库"{
                cell.nameLbl.text = p1Arr1[indexPath.row]
                cell.contentLbl.text = p1Arr2[indexPath.row]
            }else{
                cell.nameLbl.text = chu1Arr1[indexPath.row]
                cell.contentLbl.text = chu1Arr2[indexPath.row]
            }
            
            
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "AddGuiGeCell") as! AddGuiGeCell
            cell.imgBtn.setImage(UIImage(named: "tianjiashangpin"), for: .normal)
            cell.delegate = self
            return cell
        default:
            if barTitle == "入库" {
                switch indexPath.row {
                case 0:
                    let cell = tableView.dequeueReusableCell(withIdentifier: "RuKuJiaGeCell") as! RuKuJiaGeCell
                    cell.nameLbl.text = p3Arr1[indexPath.row]
                    return cell
                case 1:
                    let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
                    cell.nameLbl.text = p3Arr1[indexPath.row]
                    cell.textTF.layer.cornerRadius = 3
                    cell.textTF.layer.masksToBounds = true
                    cell.textTF.layer.borderWidth = 1
                    cell.textTF.placeholder = "0"
                    cell.textTF.textAlignment = .center
                    cell.textTF.keyboardType = .numberPad
                    cell.textTF.layer.borderColor = UIColor(named: "灰色字体颜色")?.cgColor
                    cell.textTF.snp.makeConstraints { (make) in
                        make.centerY.equalTo(cell.snp_centerY)
                        make.right.equalTo(-15)
                        make.width.equalTo(83)
                        make.height.equalTo(32)
                    }
                    return cell
                case 2:
                    let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                    cell.nameLbl.text = p3Arr1[indexPath.row]
                    cell.contentLbl.text = "请选择生产日期"
                    return cell
                case 3:
                    let cell = tableView.dequeueReusableCell(withIdentifier: "BaoZhiQiCell") as! BaoZhiQiCell
                    cell.nameLbl.text = p3Arr1[indexPath.row]
                    
                    return cell
                default:
                    let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndOnlyBtnCell") as! TitleAndOnlyBtnCell
                    cell.titleLbl.text = p3Arr1[indexPath.row]
                    cell.button.setTitle("编辑", for: .normal)
                    return cell
                }
            }else{
                if indexPath.row == 0 {
                    let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                    cell.nameLbl.text = "出库数量："
                    cell.contentLbl.text = "选择批次/填写出库数量"
                    if selectArr.count > 0 {
                        cell.lineWidth.constant = 0
                    }else{
                        cell.lineWidth.constant = 15
                    }
                    return cell
                }
                let cell = tableView.dequeueReusableCell(withIdentifier: "ChuKuCell") as! ChuKuCell
                
                return cell
                
            }
        }
    }
    //MARK: - 自定义delegate
    func AddGuiGeCellClick(cell: AddGuiGeCell) {
        print("添加商品")
    }
    
}
