//
//  CRKXiangQVC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/1.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol CRKXiangQVCDelegate {
    func CRKXiangQVCFinishAction()
}
class CRKXiangQVC: BaseViewController,UITableViewDelegate,UITableViewDataSource,NewCKCellDelegate,PiCiXuanZeViewControllerDelegate,WarehoseMangementListVCDelegate,GLAlertSelectViewDelegate,GeliAlertTextViewDelegate,GeliAlertViewDelegate{
    var w_id:Int?
    var p_id:Int?
    var w_name:String?
    var p_name:String?
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    func sureGeliAlertViewAction(sender: UIButton) {
        
        
        
        //MARK: - 出入库列表 iog_id
        
        
        
        var goodInfoArr:Array<Any> = []
        inGoodsModels?.forEach({ (item) in
            let goods = [
                "w_id":w_id as Any,
                "p_id":p_id as Any,
                "iog_id":item.iog_id as Any
            ]
            goodInfoArr.append(goods)
        })
        
        let goodsInfo = dataChangeString(sender: goodInfoArr)
        
        let dict = [
            "user_token":UserToken as Any,
            "io_id":model?.io_id as Any,
            "goods_info":goodsInfo as Any
        ]
        GoodsInputAudit(dict, success: { (data) in
            self.delegate?.CRKXiangQVCFinishAction()
            self.navigationController?.popViewController(animated: true)
        }) { (error) in
            
        }
    }
    
    
    
    
    var delegate:CRKXiangQVCDelegate?
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        selectIdx = selectnum
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    
    func WarehoseMangementListVCSelectFinish(sender: ShopWarehouseListDataModel, kuWeiArr: Array<ShopWarehouseDetailDataPositionModel>) {
        wareHouseModel = sender
        holderArr?.insert(sender.w_name!, at: 0)
        holderArr?.remove(at: 1)
        holderArr?.insert("请选择库位", at: 1)
        holderArr?.remove(at: 2)
        w_id = sender.w_id
        positionArr?.removeAll()
        kuWeiArr.forEach { (item) in
            positionArr?.append(item)
        }
        listView.reloadData()
    }
    
    var selectIdx:Int?
    var isFailAction = false
    var glSelectView:GLAlertSelectView? = nil
    var positionArr:Array<ShopWarehouseDetailDataPositionModel>? = []//库位
    var wareHouseModel:ShopWarehouseListDataModel?//仓库
    var isGm:Bool?
    var status:Int?
    var piCiArr:Array<Array<GetGoodBatchDataModel>> = []//批次
    @IBOutlet weak var btmView: UIView!
    @IBOutlet weak var listView: UITableView!
    var model:WarehouseIoListDataDetailModel?
    @IBOutlet weak var btmViewH: NSLayoutConstraint!
    
    var inGoodsModels:Array<InGoodsDetailDataGoodsResModel>? = []
    var outGoodsModels:Array<OutGoodsDetailDataGoodsResModel>? = []
    var ioGoodsModels:Array<IoGoodsDetailDataGoodsResModel>? = []
    @IBOutlet weak var btmColor: UIView!
    var titleArr:Array<String>? = []
    var holderArr:Array<String>? = []
    
    var outGoodsBatchArr:Array<Int>? = []
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        
        let dict = ["user_token":UserToken as Any,"io_id":model?.io_id as Any]
        let strs = model!.io_type_cn?.components(separatedBy: ":")
        let str = strs?.last! as! String
        
        
        if model?.status != 1 || isGm == false{//非审核中状态，不可点击
            btmView.isHidden = true
            btmColor.isHidden = true
            btmViewH.constant = 0
        }
        
        if model?.status == 2 {//通过审核
            IoGoodsDetail(dict, success: { (data) in
                let model = data as! IoGoodsDetailModel
                model.data?.goods_res?.forEach({ (item) in
                    self.ioGoodsModels?.append(item)
                })
                let data = self.ioGoodsModels?.first
                if self.model?.io_type == 1 {
                    self.titleArr = ["仓库","库位","入库类型","审核人","备注"]
                    var remark = "-"
                    if (model.data?.io_res?.apply_remark)!.count > 0 {
                        remark = (model.data?.io_res?.apply_remark)!
                    }
                    self.holderArr = [(data?.w_name)! as String,(data?.p_name)! as String
                        ,str,(self.model?.auditor)! as String,remark]
                    self.navbar.title = "商品入库详情"
                }else{
                    self.titleArr = ["出库类型","审核人","备注"]
                    var remark = "-"
                    if (model.data?.io_res?.apply_remark)!.count > 0 {
                        remark = (model.data?.io_res?.apply_remark)!
                    }
                    self.holderArr = [str,(self.model?.auditor)! as String,remark]
                    self.navbar.title = "商品出库详情"
                }
                self.listView.reloadData()
            }) { (error) in
                
            }
            
            
            
        }else if model?.status == 3 {//不通过
            IoGoodsDetail(dict, success: { (data) in
                let model = data as! IoGoodsDetailModel
                model.data?.goods_res?.forEach({ (item) in
                    self.ioGoodsModels?.append(item)
                })
                
                if self.model?.io_type == 1 {
                    self.titleArr = ["入库类型","审核人","备注","未通过原因"]
                    var remark = "-"
                    if (model.data?.io_res?.apply_remark)!.count > 0 {
                        remark = (model.data?.io_res?.apply_remark)!
                    }
                    var audit_remark = "-"
                    if (model.data?.io_res?.audit_remark)!.count > 0 {
                        audit_remark = (model.data?.io_res?.audit_remark)!
                    }
                    
                    self.holderArr = [str,(self.model?.auditor)! as String,remark,audit_remark]
                    self.navbar.title = "商品入库详情"
                }else{
                    var remark = "-"
                    if (model.data?.io_res?.apply_remark)!.count > 0 {
                        remark = (model.data?.io_res?.apply_remark)!
                    }
                    var audit_remark = "-"
                    if (model.data?.io_res?.audit_remark)!.count > 0 {
                        audit_remark = (model.data?.io_res?.audit_remark)!
                    }
                    self.titleArr = ["出库类型","审核人","备注","未通过原因"]
                    self.holderArr = [str,(self.model?.auditor)! as String,remark,audit_remark]
                    self.navbar.title = "商品出库详情"
                }
                self.listView.reloadData()
            }) { (error) in
                
            }
            
        }else{
            //MARK: - 入库详情
            if model?.io_type == 1 {
                titleArr = ["仓库","库位","入库类型"]
                holderArr = ["请选择仓库","请选择库位",str]
                if w_name != nil {
                    holderArr = [w_name!,"请选择库位",str]
                }
                
                if p_name != nil {
                    holderArr = [w_name!,p_name!,str]
                }
                
                navbar.title = "商品入库详情"
                
                InGoodsDetail(dict, success: { (data) in
                    let model = data as! InGoodsDetailModel
                    model.data?.goods_res?.forEach({ (item) in
                        self.inGoodsModels?.append(item)
                    })
                    if self.isGm == false {
                        self.titleArr = ["入库类型","备注"]
                        var remark = "-"
                        if (model.data?.io_res?.apply_remark)!.count > 0 {
                            remark = (model.data?.io_res?.apply_remark)!
                        }
                        self.holderArr = [str,remark]
                    }
                    self.listView.reloadData()
                }) { (error) in
                    
                }
                
            }
            if model?.io_type == 2 {
                titleArr = ["出库类型","出库日期","出库商品"]
                holderArr = [str,dayAndTimeByDouble(sender: (model?.add_time)!),"\(model!.goods_res!.count)件"]
                navbar.title = "商品出库详情"
                OutGoodsDetail(dict, success: { (data) in
                    let model = data as! OutGoodsDetailModel
                    model.data?.goods_res!.forEach({ (item) in
                        self.outGoodsModels?.append(item)
                        self.piCiArr.append([])
                    })
                    if self.isGm == false {
                        self.titleArr = ["出库类型","备注"]
                        var remark = "-"
                        if (model.data?.io_res?.apply_remark)!.count > 0 {
                            remark = (model.data?.io_res?.apply_remark)!
                        }
                        self.holderArr = [str,remark]
                    }
                    self.listView.reloadData()
                }) { (error) in
                    
                }
            }
        }
        self.view.addSubview(navbar)
        listView.register(UINib(nibName: "CRKBtnCell", bundle: nil), forCellReuseIdentifier: "CRKBtnCell")
        listView.separatorStyle = .none
        SetTopFrameView(view: listView, btmView: btmView)
        listView.register(UINib(nibName: "NewCKCell", bundle: nil), forCellReuseIdentifier: "NewCKCell")
        listView.register(UINib(nibName: "NewRKCell", bundle: nil), forCellReuseIdentifier: "NewRKCell")
    }
    
    //MARK: - 通过点击事件
    @IBAction func crkxqBtnClick(_ sender: UIButton) {
        if sender.tag == 0 {//通过
            if model?.io_type == 1 {
                let str = holderArr![0]
                if str == "请选择仓库" {
                    HUD.flash(.label("请选择仓库"), delay: 1.2)
                    return
                }
                
                let str1 = holderArr![1]
                if str1 == "请选择库位" {
                    HUD.flash(.label("请选择库位"), delay: 1.2)
                    return
                }
                let alertView = GeliAlertView(frame: self.view.window!.bounds)
                alertView.delegate = self;
                alertView.tishiLbl.text = ""
                alertView.titileLbl.text = "是否通过审核？"
                alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
                self.view.window?.addSubview(alertView)
            }else{
                let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
                alterView.delegate = self
                alterView.titleLbl.text = "请填写通过备注"
                alterView.placerLbl.text = "请填写通过备注..."
                self.view.window?.addSubview(alterView)
                isFailAction = false
            }
        }else{
            let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
            alterView.delegate = self
            alterView.titleLbl.text = "请填写不通过备注"
            alterView.placerLbl.text = "请填写不通过备注..."
            self.view.window?.addSubview(alterView)
            isFailAction = true
        }
        
    }
    //MARK: - 通过审核
    func sureGeliAlertTextViewAction(sender: String) {
        if sender.count == 0 {
            HUD.flash(.label("请填写备注"), delay: 1.2)
            return
        }
        if sender.count > 0 {
            
            if isFailAction {//不通过
                let dict = [
                    "user_token":UserToken as Any,
                    "io_id":model?.io_id as Any,
                    "audit_remark":sender as Any
                ]
                AuditFail(dict, success: { (data) in
                    self.delegate?.CRKXiangQVCFinishAction()
                    self.navigationController?.popViewController(animated: true)
                }) { (error) in
                    
                }
                return
            }
            //出库通过
            var batchInfo:Array<Any> = []
            piCiArr.forEach { (batchArr) in
                batchArr.forEach { (model) in
                    let batch = [
                        "w_id":model.w_id as Any,
                        "p_id":model.p_id as Any,
                        "number":model.chuHuoLiang as Any,
                        "production_data":model.production_data as Any,
                        "shelf_life":model.shelf_life as Any,
                        "valid_date":model.valid_date as Any,
                        "batch_id":model.batch_id as Any,
                        "report_id":model.report_id as Any
                    ]
                    batchInfo.append(batch)
                }
            }
            var goodsInfoArr : Array<Any> = []
            outGoodsModels?.forEach({ (item) in
                let goods = [
                    "goods_id":item.goods_id as Any,
                    "goods_name":item.goods_name as Any,
                    "goods_spec":item.goods_spec as Any,
                    "sku_id":item.sku_id as Any,
                    "number":item.number as Any,
                    "batch_info":batchInfo
                    ] as [String : Any]
                goodsInfoArr.append(goods)
            })
            let goods_info = dataChangeString(sender: goodsInfoArr)
            let dict = [
                "user_token":UserToken as Any,
                "io_id":model?.io_id as Any,
                "audit_remark":sender,
                "goods_info":goods_info]
            GoodsOutputAudit(dict, success: { (data) in
                self.delegate?.CRKXiangQVCFinishAction()
                self.navigationController?.popViewController(animated: true)
            }) { (error) in
            }
            
        }
        
    }
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        if isGm! && status! == 1{
            if indexPath.section == 0  {
                let cell = tableView.cellForRow(at: indexPath) as! CRKBtnCell
                
                if cell.nameLbl.text != "库位" && cell.nameLbl.text != "仓库"{
                    return
                }
                if indexPath.row == 0 {
                    let vc = WarehoseMangementListVC()
                    vc.isSelectWarehouse = true
                    vc.delegate = self
                    self.navigationController?.pushViewController(vc, animated: true)
                }
                if indexPath.row == 1 {
                    
                    if positionArr!.count > 0 {
                        if glSelectView == nil {
                            let view = GLAlertSelectView(frame: self.view.bounds)
                            if selectIdx != nil {
                                view.selectNum = selectIdx
                                view.tempNum = view.selectNum
                            }
                            view.isOnlySelectKuWei = true
                            view.delegate = self
                            view.titleLbl.text = "请选择库位"
                            var poiArr:Array<String> = []
                            print(positionArr?.count)
                            for item in positionArr! {
                                let str = item.p_name! + "(库存数:\(item.inventory_count!)"
                                poiArr.append(str)
                            }
                            
                            view.dataArr = poiArr
                            self.view.addSubview(view)
                            glSelectView = view
                        }
                    }else{
                        if w_id != nil {
                            
                            WarehouseDetail(["user_token":UserToken as Any,"w_id":w_id as Any], success: { (data) in
                                
                                let mo = data as! ShopWarehouseDetailModel
                                mo.data?.position_res?.forEach({ (item) in
                                    self.positionArr!.append(item)
                                })
                                if self.glSelectView == nil {
                                    let view = GLAlertSelectView(frame: self.view.bounds)
                                    if self.selectIdx != nil {
                                        view.selectNum = self.selectIdx
                                        view.tempNum = view.selectNum
                                    }
                                    view.isOnlySelectKuWei = true
                                    view.delegate = self
                                    view.titleLbl.text = "请选择库位"
                                    var poiArr:Array<String> = []
                                    for item in self.positionArr! {
                                        let str = item.p_name! + "(库存数:\(item.inventory_count!)"
                                        poiArr.append(str)
                                    }
                                    
                                    view.dataArr = poiArr
                                    self.view.addSubview(view)
                                    self.glSelectView = view
                                }
                            }) { (error) in
                                
                            }
                        }else{
                            HUD.flash(.label("请选择仓库"), delay: 1.2)
                        }
                    }
                    
                }
            }
        }
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 0 {
            return titleArr!.count
        }
        if (model?.status)! > 1 {
            return ioGoodsModels!.count
        }
        if model?.io_type == 1 {
            return inGoodsModels!.count
            
        }
        return outGoodsModels!.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "CRKBtnCell") as! CRKBtnCell
            cell.nameLbl.text = titleArr![indexPath.row]
            cell.contentLbl.text = holderArr![indexPath.row]
            
            if (model?.status)! > 1 {
                setCellUI(cell: cell)
            }else{
                if cell.nameLbl.text != "仓库" && cell.nameLbl.text != "库位" {
                    setCellUI(cell: cell)
                }
            }
            
            return cell
        }
        
        if model?.io_type == 1 || (model?.status!)! > 1 { //入库
            
            let cell = tableView.dequeueReusableCell(withIdentifier: "NewRKCell") as! NewRKCell
            if inGoodsModels!.count > 0 || ioGoodsModels!.count > 0{
                if self.model!.status! > 1 {
                    let  data = ioGoodsModels![indexPath.row]
                    cell.nameLbl.text = data.goods_name
                    cell.guiGe.text = "规格:---"
                    if data.goods_spec!.count > 0{
                        cell.guiGe.text = data.goods_spec
                    }
                    
                    if navbar.title == "商品入库详情" {
                        cell.rukuShu.text = "入库数量:" + "\(data.number!)"
                        cell.rkjg.text = "入库价格:¥" + data.amount!
                        cell.rkzj.text = "入库总价:¥" + data.subtotal!
                    }else{
                        cell.rukuShu.text = "出库数量:" + "\(data.number!)"
                        cell.rkjg.text = "仓库名:" + data.w_name!
                        cell.rkzj.text = "库位名:" + data.p_name!
                    }
                    
                    
                    
                    cell.scrq.text = "生产日期:---"
                    if data.production_data! != 0 {
                        cell.scrq.text = "生产日期:" + dayByDouble(sender: data.production_data!)
                    }
                    cell.gqrq.text = "过期日期:---"
                    if data.valid_date! != 0 {
                        cell.gqrq.text = "过期日期:" + dayByDouble(sender:data.valid_date!)
                    }
                    
                    cell.baozhiQ.text = "保质期:---"
                    if data.shelf_life != 0 {
                        cell.baozhiQ.text = "保质期:" + "\(data.shelf_life!)天"
                        let month = data.shelf_life!/30
                        let day = data.shelf_life! % 30
                        if month > 0 {
                            if day != 0 {
                                cell.baozhiQ.text = "保质期:" + "\(month)月" + "\(day)天"
                            }else{
                                cell.baozhiQ.text = "保质期:" + "\(month)月"
                            }
                            
                        }
                    }
                    
                    cell.baogao.text = "报告:无"
                    if data.report_sn != nil  {
                        cell.baogao.text = "报告:" + "\(data.report_sn!)"
                    }
                    return cell
                }else{
                    let   model = inGoodsModels![indexPath.row]
                    cell.nameLbl.text = model.goods_name
                    cell.guiGe.text = "规格:---"
                    if model.goods_spec!.count > 0 {
                        cell.guiGe.text = model.goods_spec
                    }
                    
                    cell.scrq.text = "生产日期:---"
                    if model.production_data! != 0 {
                        cell.scrq.text = "生产日期:" + dayByDouble(sender: model.production_data!)
                    }
                    cell.gqrq.text = "过期日期:---"
                    if model.valid_date! != 0 {
                        cell.gqrq.text = "过期日期:" + dayByDouble(sender:model.valid_date!)
                    }
                    
                    
                    cell.rukuShu.text = "入库数量:" + "\(model.number!)"
                    cell.rkjg.text = "入库价格:¥" + "\(model.amount!)"
                    cell.rkzj.text = "入库总价:¥" + "\(model.subtotal!)"
                    
                    cell.baozhiQ.text = "保质期:---"
                    if model.shelf_life != 0 {
                        cell.baozhiQ.text = "保质期:" + "\(model.shelf_life!)天"
                        let month = model.shelf_life!/30
                        let day = model.shelf_life! % 30
                        if month > 0 {
                            if day != 0 {
                                cell.baozhiQ.text = "保质期:" + "\(month)月" + "\(day)天"
                            }else{
                                cell.baozhiQ.text = "保质期:" + "\(month)月"
                            }
                            
                        }
                    }
                    
                    cell.baogao.text = "报告:无"
                    if model.report_sn != nil {
                        cell.baogao.text = "报告:" + "\(model.report_sn!)"
                    }
                    return cell
                }
                
            }
            
        }
        if isGm == false {
            let cell = tableView.dequeueReusableCell(withIdentifier: "NewRKCell") as! NewRKCell
            let   model = outGoodsModels![indexPath.row]
            cell.nameLbl.text = model.goods_name
            cell.guiGe.text = model.goods_spec
            cell.rukuShu.text = "仓库名:---"
            if model.w_name!.count > 0 {
                cell.rukuShu.text = "仓库名:" + "\(model.w_name!)"
            }
            cell.scrq.text = "生产日期:---"
            if model.production_data! != 0 {
                cell.scrq.text = "生产日期:" + dayByDouble(sender: model.production_data!)
            }
            cell.gqrq.text = "过期日期:---"
            if model.valid_date! != 0 {
                cell.gqrq.text = "过期日期:" + dayByDouble(sender: model.valid_date!)
            }
            cell.rkjg.text = "库位名:---"
            if model.p_name!.count > 0 {
                cell.rkjg.text = "库位名:" + "\(model.p_name!)"
            }
            cell.rkzj.text = "保质期:---"
            if model.shelf_life != 0 {
                cell.rkzj.text = "保质期:" + "\(model.shelf_life!)天"
                let month = model.shelf_life!/30
                let day = model.shelf_life!%30
                if month > 0 {
                    if day != 0 {
                        cell.baozhiQ.text = "保质期:" + "\(month)月" + "\(day)天"
                    }else{
                        cell.baozhiQ.text = "保质期:" + "\(month)月"
                    }
                    
                }
            }
            cell.baozhiQ.text = "报告:无"
            if model.report_sn != nil {
                cell.baozhiQ.text = "报告:" + "\(model.report_sn!)"
            }
            cell.baogao.isHidden = true
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "NewCKCell") as! NewCKCell
        cell.delegate = self
        cell.tag = indexPath.row
        if outGoodsModels!.count > 0 {
            let data = outGoodsModels![indexPath.row]
            cell.nameLbl.text = data.goods_name
            cell.guiGeLbl.text = data.goods_spec
            cell.chuKuLbl.text = "出库数量：" + "\(data.number!)"
            cell.keChuKuLbl.text = "可出库数量：" + "\(data.inventory!)"
            
            if piCiArr.count > 0 {
                let arr = piCiArr[indexPath.row]
                cell.piCiArr = arr
                cell.btmTitleView.alpha = 1
                cell.btmListView.alpha = 1
            }else{
                cell.btmTitleViewH.constant = 0
                cell.btmTitleView.isHidden = true
                cell.btmListViewH.constant = 0
                cell.btmTitleView.alpha = 0
                cell.btmListView.alpha = 0
            }
        }
        return cell
    }
    func NewCKCellBtnClick(cell: NewCKCell) {
        if model?.io_type == 2 {
            let data = outGoodsModels![cell.tag]
            let vc = PiCiXuanZeViewController()
            vc.sku_id = data.sku_id
            vc.delegate = self
            vc.tag = cell.tag
            let arr = piCiArr[cell.tag]
            vc.recordArr = arr
            self.navigationController?.pushViewController(vc, animated: true)
        }
    }
    
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0{
            return 49
        }
        if model?.io_type == 1 {//入库
            return 264
        }
        if (model?.status)! > 1 {
            return 264
        }
        if isGm == false {
            return 264
        }
        let arr = piCiArr[indexPath.row]
        if arr.count > 0 {
            return CGFloat(214 + 35 + arr.count * 43)
        }else{
            return 214
        }
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    
    func setCellUI(cell:CRKBtnCell){
        
        cell.mustLbl.isHidden = true
        cell.arrowImg.isHidden = true
        cell.contentLbl.textColor = UIColor(named: "标题字颜色")
        cell.mustWidth.constant = 0
        cell.nameLeft.constant = 0
        cell.contentRight.constant = -7
    }
    
    func PiCiXuanZeViewControllerPiCiSelect(data: Array<GetGoodBatchDataModel>, p_id: Int) {
        piCiArr.insert(data, at: p_id)
        piCiArr.remove(at: p_id + 1)
        listView.reloadData()
    }
    
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        selectIdx = selectNum
        let data = positionArr![selectIdx!]
        holderArr?.insert(data.p_name!, at: 1)
        holderArr?.remove(at: 2)
        p_id = data.p_id
        glSelectView?.removeFromSuperview()
        glSelectView = nil
        listView.reloadData()
    }
}
