//
//  NewCKCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/1.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol NewCKCellDelegate {
    func NewCKCellBtnClick(cell:NewCKCell)
}
class NewCKCell: UITableViewCell {
    
    @IBOutlet weak var ckslLbl: UILabel!
    @IBOutlet weak var piCiIdLbl: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    
    @IBOutlet weak var btmTitleView: UIView!
    @IBOutlet weak var btmListViewH: NSLayoutConstraint!
    @IBOutlet weak var btmTitleViewH: NSLayoutConstraint!
    @IBOutlet weak var btmListView: UIView!
    
    var delegate:NewCKCellDelegate?
    @IBOutlet weak var guiGeLbl: UILabel!
    
    @IBOutlet weak var line: UIView!
    @IBOutlet weak var chuKuLbl: UILabel!
    
    
    @IBOutlet weak var keChuKuLbl: UILabel!
    var piCiArr:Array<GetGoodBatchDataModel>? = []
    @IBAction func btnClick(_ sender: UIButton) {
        delegate?.NewCKCellBtnClick(cell: self)
    }
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        // Initialization code
    }
    override func layoutIfNeeded() {
        super.layoutIfNeeded()
        btmListView.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        
        if piCiArr!.count > 0 {
            for i in 0 ..< piCiArr!.count {
                btmListViewH.constant = CGFloat(43 * piCiArr!.count)
                btmTitleViewH.constant = 35
                btmTitleView.isHidden = false
                
                let data = piCiArr![i]
                let view = UIView()
                btmListView.addSubview(view)
                view.snp.makeConstraints { (make) in
                    make.top.equalTo(i * 43)
                    make.height.equalTo(43)
                    make.right.left.equalTo(0)
                }
                let leftLbl = UILabel()
                view.addSubview(leftLbl)
                leftLbl.font = UIFont.systemFont(ofSize: 13)
                leftLbl.text = "\(data.batch_id!)"
                leftLbl.textColor = UIColor(named: "个人中心灰色字体")
                leftLbl.snp.makeConstraints { (make) in
                    make.centerY.equalTo(view.snp_centerY)
                    make.centerX.equalTo(piCiIdLbl.snp_centerX)
                    make.height.equalTo(13)
                }
                let rightLbl = UILabel()
                view.addSubview(rightLbl)
                rightLbl.font = UIFont.systemFont(ofSize: 13)
                rightLbl.textAlignment = .right
                if data.chuHuoLiang != nil {
                    rightLbl.text = "\(data.chuHuoLiang!)"
                }
                rightLbl.textColor = UIColor(named: "个人中心灰色字体")
                rightLbl.snp.makeConstraints { (make) in
                    make.centerY.equalTo(view.snp_centerY)
                    make.centerX.equalTo(ckslLbl.snp_centerX)
                    make.height.equalTo(13)
                }
            }
        }
        
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
