//
//  YingFuZKListViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/8.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class YingFuZKListViewController: BaseViewController,UISearchBarDelegate,SearchBarViewDelegate,UITableViewDataSource,UITableViewDelegate,YingFuZhangKuanXQViewControllerDelegate {
    func YingFuZhangKuanXQViewControllerFinish() {
        listView.mj_header?.beginRefreshing()
    }
    @IBOutlet weak var selectListH: NSLayoutConstraint!
    
    var exist = 0
    var amount_order = 0
    
    
    @IBAction func topBtnClick(_ sender: UIButton) {
        switch sender.tag {
        case 0:
            
            rightImg.image = UIImage(named: "xiala")
            rightBtnTitle.textColor = UIColor(named: "标题字颜色")
            if leftBtnTitle.textColor == UIColor(named: "蓝色字体颜色"){
                leftBtnTitle.textColor = UIColor(named: "标题字颜色")
                leftImg.image = UIImage(named: "xiala")
                closeBtn.isHidden = true
                selectList.isHidden = true
            }else{
                leftBtnTitle.textColor = UIColor(named: "蓝色字体颜色")
                leftImg.image = UIImage(named: "shangla")
                closeBtn.isHidden = false
                selectList.isHidden = false
                selectListH.constant = 3 * 49
                selectList.reloadData()
            }
            break
        case 1:
            leftBtnTitle.textColor = UIColor(named: "标题字颜色")
            leftImg.image = UIImage(named: "xiala")
            if rightBtnTitle.textColor == UIColor(named: "蓝色字体颜色") {
                rightBtnTitle.textColor = UIColor(named: "标题字颜色")
                rightImg.image = UIImage(named: "xiala")
                closeBtn.isHidden = true
                selectList.isHidden = true
            }else{
                rightBtnTitle.textColor = UIColor(named: "蓝色字体颜色")
                rightImg.image = UIImage(named: "shangla")
                closeBtn.isHidden = false
                selectList.isHidden = false
                selectList.reloadData()
                selectListH.constant = 2 * 49
            }
            break
        default:
            closeBtn.isHidden = true
            selectList.isHidden = true
            leftImg.image = UIImage(named: "xiala")
            rightImg.image = UIImage(named: "xiala")
            rightBtnTitle.textColor = UIColor(named: "标题字颜色")
            leftBtnTitle.textColor = UIColor(named: "标题字颜色")
            break
        }
        
    }
    @IBOutlet weak var closeBtn: UIButton!
    
    @IBOutlet weak var selectList: UITableView!
    @IBOutlet weak var rightImg: UIImageView!
    @IBOutlet weak var rightBtnTitle: UILabel!
    @IBOutlet weak var leftImg: UIImageView!
    @IBOutlet weak var leftBtnTitle: UILabel!
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var page : Int = 0
    var keyword: String = ""
    var dataArr:Array<accountsPayableListDataModel> = []//应付
    var datas:Array<accountReceivableListDataModel> = []//应收
    @IBOutlet weak var titleLbl: UILabel!
    @IBOutlet weak var totalPriceLbl: UILabel!
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var listView: UITableView!
    var searchV : SearchBarView? = nil
    var barTitle:String?
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = barTitle
        self.view.addSubview(navbar)
        listView.separatorStyle = .none
        SetTopFrame(view: topView, height: 44)
        leftBtnTitle.text = "全部"
        rightBtnTitle.text = "欠款"
        if barTitle == "应收账款" {
            titleLbl.text = "当前应收款余额总计："
            rightBtnTitle.text = "余额"
        }
        
        let searchBr = SearchBarView.init()
        topView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(30)
        }
        searchV = searchBr
        if (barTitle?.contains("应收"))! {
            searchBr.placeholderStr = "请输入客户名字或ID"
        }else{
            searchBr.placeholderStr = "请输入供应商名字或ID"
        }
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        listView.register(UINib(nibName: "YingFuZhangKuanCell", bundle: nil), forCellReuseIdentifier: "YingFuZhangKuanCell")
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        listView.mj_header = headerMJ
        listView.mj_header?.beginRefreshing()
        
        //        selectList.register(UINib(nibName: "OnlyLabelCell", bundle: nil), forCellReuseIdentifier: "OnlyLabelCell")
    }
    
    
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if tableView == selectList {
            
            if leftBtnTitle.textColor == UIColor(named:"蓝色字体颜色"){
                exist = indexPath.row
                leftBtnTitle.text = leftArr1[exist]
                if (barTitle?.contains("应收"))!{
                    leftBtnTitle.text = leftArr2[exist]
                }
            }else{
                amount_order = indexPath.row
                rightBtnTitle.text = rightArr[amount_order]
            }
            leftImg.image = UIImage(named: "xiala")
            rightImg.image = UIImage(named: "xiala")
            rightBtnTitle.textColor = UIColor(named: "标题字颜色")
            leftBtnTitle.textColor = UIColor(named: "标题字颜色")
            selectList.isHidden = true
            closeBtn.isHidden = true
            listView.mj_header?.beginRefreshing()
            return
        }
        let vc = YingFuZhangKuanXQViewController()
        vc.delegate = self
        if (barTitle?.contains("应付"))!{
            let model = dataArr[indexPath.row]
            vc.ven_id = model.ven_id!
            vc.navTitle = "\(model.ven_name!)-\(barTitle!)详情"
        }else{
            let model = datas[indexPath.row]
            vc.ven_id = model.cus_id!
            vc.navTitle = "\(model.cus_name!)-\(barTitle!)详情"
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == selectList {
            if leftBtnTitle.textColor == UIColor(named:"蓝色字体颜色"){
                return 3
            }else{
                return 2
            }
        }
        if (barTitle?.contains("应付"))!{
            return dataArr.count
        }else{
            return datas.count
        }
    }
    let leftArr1 = ["全部","有应付账款","无应付账款"]
    let leftArr2 = ["全部","有应收账款","无应收账款"]
    let rightArr = ["由多到少","由少到多"]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if tableView == selectList {
            var cell = tableView.dequeueReusableCell(withIdentifier: "select")
            if cell == nil {
                cell = UITableViewCell(style: .default, reuseIdentifier: "select")
            }
            cell?.textLabel?.font = UIFont.systemFont(ofSize: 13)
            cell?.textLabel?.textColor = UIColor(named: "标题字颜色")
            if leftBtnTitle.textColor == UIColor(named:"蓝色字体颜色"){
                if (barTitle?.contains("应收"))!{
                    cell?.textLabel!.text = leftArr2[indexPath.row]
                    if exist == indexPath.row {
                        cell?.textLabel?.textColor = UIColor(named: "蓝色字体颜色")
                    }
                }else{
                    cell?.textLabel!.text = leftArr1[indexPath.row]
                    if exist == indexPath.row {
                        cell?.textLabel?.textColor = UIColor(named: "蓝色字体颜色")
                    }
                }
            }else{
                cell?.textLabel!.text = rightArr[indexPath.row]
                if amount_order == indexPath.row {
                    cell?.textLabel?.textColor = UIColor(named: "蓝色字体颜色")
                }
            }
            return cell!
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "YingFuZhangKuanCell") as! YingFuZhangKuanCell
        if (barTitle?.contains("应付"))!{
            
            let mo = dataArr[indexPath.row]
            cell.nameLbl.text = mo.ven_name!
            if mo.payable_money != "0.00" {
                cell.priceLbl.text = "¥" + mo.payable_money!
            }else{
                cell.priceLbl.text = "¥0"
            }
        }else{
            let mo = datas[indexPath.row]
            cell.nameLbl.text = mo.cus_name!
            if mo.arrears_money != "0.00" {
                cell.priceLbl.text = "¥" + mo.arrears_money!
            }else{
                cell.priceLbl.text = "¥0"
            }
        }
        return cell
        
    }
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        listView.mj_header?.beginRefreshing()
        
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if searchBar.text?.count == 0 && keyword.count != 0{
            keyword = searchBar.text!
            listView.mj_header?.beginRefreshing()
            
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        selectList.isHidden = true
        closeBtn.isHidden = true
        
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(topView!.snp_bottom)
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        page = 1
        let dic = ["user_token":UserToken as Any,"keyword":keyword as Any,"page":page as Any,"exist":exist as Any,"amount_order":amount_order+1 as Any]
        if (barTitle?.contains("应付"))!{
            accountsPayableList(dic, success: { (data) in
                let model = (data as! accountsPayableListModel)
                self.dataArr.removeAll()
                model.data?.vendor_res?.forEach({ (model) in
                    self.dataArr.append(model)
                })
                if self.dataArr.count == 20 {
                    //上拉加载相关设置
                    self.footerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadMoreData))
                    self.listView.mj_footer = self.footerMJ
                    
                }
                if model.data?.total_payable_money != nil {
                    self.totalPriceLbl.text = "¥\(model.data!.total_payable_money!)"
                }
                self.listView.reloadData()
                self.listView.mj_header?.endRefreshing()
                self.page = 2
                if model.data?.vendor_res?.count == 0 {
                    self.listView.mj_footer?.endRefreshingWithNoMoreData()
                }else{
                    self.listView.mj_footer?.endRefreshing()
                }
            }) { (error) in
                self.listView.mj_header?.endRefreshing()
            }
        }else{//应收
            accountReceivableList(dic, success: { (data) in
                let model = (data as! accountReceivableListModel)
                self.datas.removeAll()
                model.data?.list?.forEach({ (model) in
                    self.datas.append(model)
                })
                if self.datas.count == 20 {
                    //上拉加载相关设置
                    self.footerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadMoreData))
                    self.listView.mj_footer = self.footerMJ
                }
                self.totalPriceLbl.text = "¥\(model.data!.arrears_money_sum!)"
                self.listView.reloadData()
                self.listView.mj_header?.endRefreshing()
                self.page = 2
                if model.data?.list?.count == 0 {
                    self.listView.mj_footer?.endRefreshingWithNoMoreData()
                }else{
                    self.listView.mj_footer?.endRefreshing()
                }
            }) { (error) in
                self.listView.mj_header?.endRefreshing()
            }
        }
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        
        let dic = ["user_token":UserToken as Any,"keyword":keyword as Any,"page":page as Any,"exist":exist as Any,"amount_order":amount_order+1 as Any]
        if (barTitle?.contains("应付"))!{
            accountsPayableList(dic, success: { (data) in
                let dataM = data as! accountsPayableListModel
                if dataM.data?.vendor_res == nil {
                    self.footerMJ.setTitle("看完了", for: .noMoreData)
                    self.listView.mj_footer?.endRefreshingWithNoMoreData()
                }else{
                    self.page += 1
                    dataM.data?.vendor_res?.forEach({ (model) in
                        self.dataArr.append(model)
                    })
                    self.listView.reloadData()
                    self.listView.mj_footer?.endRefreshing()
                }
            }) { (error) in
                self.listView.mj_footer?.endRefreshing()
                
            }
        }else{//应收
            accountReceivableList(dic, success: { (data) in
                let model = (data as! accountReceivableListModel)
                if model.data?.list == nil {
                    self.listView.mj_footer?.endRefreshingWithNoMoreData()
                    self.footerMJ.setTitle("看完了", for: .noMoreData)
                }else{
                    self.page += 1
                    model.data?.list?.forEach({ (model) in
                        self.datas.append(model)
                    })
                    self.listView.reloadData()
                    self.listView.mj_header?.endRefreshing()
                }
            }) { (error) in
                self.listView.mj_header?.endRefreshing()
            }
        }
    }
}
