//
//  CreatNewSpecsViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/21.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import IQKeyboardManagerSwift

protocol CreatNewSpecsViewControllerDelegate {
    func CreatNewSpecsViewControllerSaveAction(datas:Array<GuiGeModel>,selectIdx:IndexPath)
    func CreatNewSpecsViewControllerDeleteAction(datas:Array<GuiGeModel>,selectIdx:IndexPath)
}
class CreatNewSpecsViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,TitleAndTFCellDelegate,TitleAndBtnCellDelegate,TitleAndSwitchCellDelegate,TitleAndSwitchHeaderViewDelegate,NewCreateHeaderDelegate,NewCreateFooterDelegate,YuShouCellDelegate,GLAlertSelectViewDelegate,PuTongJieTiCellDelegate,UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout,UITextFieldDelegate{
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        if selectnum != 10086 {
            if view.titleLbl.text == "请选择商品温藏" {
                tempSelect = selectnum
            }
            if view.titleLbl.text == "请选择商品单位" {
                itemDanWeiSelect = selectnum
            }
        }
        view.removeFromSuperview()
        selectView = nil
    }
    var ysKuCun:String = ""//预售库存
    var DJBiLi:String = ""//定金比例
    var yuShouPrice:String = ""//预售价格
    var layout = UICollectionViewFlowLayout()
    var delegate:CreatNewSpecsViewControllerDelegate?
    var collectView:UICollectionView?
    var datasArr:Array<GuiGeModel> = []
    var dataModel = GuiGeModel()
    var firstTimeSetting = true
    let titleArray = ["售价：","规格：","重量(kg)：","温藏：","单位："]
    let pliceHolderArr = ["请输入商品售价","请输入商品规格","请输入商品重量","常温","请选择商品单位"]
    @IBOutlet weak var btmLbl: UILabel!
    @IBOutlet weak var bottomBtn: LGButton!
    @IBOutlet weak var listTbv: UITableView!
    var selectIdx:IndexPath?
    var isYuShouSetting = false//打开预售
    
    @IBOutlet weak var btmLblH: NSLayoutConstraint!
    var isJieTiOpen = false//控制阶梯价是否打开
    var isYsJieTiOpen = false//控制预售阶梯是否打开
    
    //    var isOpenYSSetting = false//是否打开预售设置
    var selectYuShou = false//是否选择设置预售价格
    
    
    var isAllEditing = true//全局控制编辑
    //选择页面
    var selectView:GLAlertSelectView? = nil
    var selectListArr:Array<String> = ["常温","-18℃","-25℃~-4℃","-4℃~10℃","0℃~8℃","4℃~10℃"]
    var danWeiArr:Array<String>?
    var price = ""
    var guiGe = ""
    var weight = ""
    var wenDu = "常温"
    var danWei = ""
    //规格
    var specalArr:Array<Any> = []{
        willSet{
            specalArr.removeAll()
            specalArr = newValue
        }
    }//预售
    var jieTiArr:Array<Any> = []{
        willSet{
            jieTiArr.removeAll()
            jieTiArr = newValue
            
        }
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        collectView?.selectItem(at:selectIdx, animated: false, scrollPosition: .bottom)
    }
    @IBOutlet weak var topBarView: UIView!
    @IBOutlet weak var topBarViewH: NSLayoutConstraint!
    var barTitle:String?
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = barTitle
        self.view.addSubview(navbar)
        if barTitle == "查看规格"{
            isAllEditing = false
            bottomBtn.isHidden = true
            btmLbl.isHidden = true
            btmLblH.constant = 0
        }
        if datasArr.count > 1 && barTitle!.contains("编辑") == true {//展示topbar
            
            SetTopFrame(view: topBarView, height: 41)
            if collectView == nil {
                let collectionView = UICollectionView(frame: CGRect(x: 0, y: 0, width: 0, height: 0), collectionViewLayout: layout)
                collectionView.backgroundColor = UIColor.white
                collectionView.delegate = self
                collectionView.dataSource = self
                topBarView.addSubview(collectionView)
                collectionView.snp.makeConstraints { (make) in
                    make.bottom.left.right.equalTo(0)
                    make.height.equalTo(41)
                }
                collectionView.showsHorizontalScrollIndicator = false
                collectionView.isPagingEnabled = true
                var w:CGFloat = 0
                if datasArr.count < 5 {
                    w = fullScreenWidth/CGFloat(datasArr.count)
                }else{
                    w = fullScreenWidth * 0.2
                }
                layout.itemSize = CGSize(width: w, height: 41)
                layout.scrollDirection = .horizontal
                collectionView.collectionViewLayout = layout
                collectionView.register(UINib(nibName: "ItemCell", bundle: nil), forCellWithReuseIdentifier: "ItemCell")
                collectView = collectionView
            }
        }else{
            SetTopFrame(view: topBarView, height: 0)
            topBarViewH.constant = 0
        }
        
        listTbv?.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTF")
        listTbv?.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtn")
        listTbv?.register(UINib(nibName: "TitleAndSwitchCell", bundle: nil), forCellReuseIdentifier: "TitleAndSwitch")
        listTbv?.register(UINib(nibName: "YuShouCell", bundle: nil), forCellReuseIdentifier: "YuShou")
        listTbv?.register(UINib(nibName: "PuTongJieTiCell", bundle: nil), forCellReuseIdentifier: "PuTongJieTi")
        listTbv?.register(UINib(nibName: "DelGuiGeCell", bundle: nil), forCellReuseIdentifier: "DelGuiGe")
        
    }
    
    @IBAction func saveAction(_ sender: Any) {
        print("save")
        print("open = ",isJieTiOpen)
        
        if price.count == 0 {
            HUD.flash(.label("请输入售价"), delay: 1.2)
            return
        }
        if isPurnNumber(str: price) == false {
            HUD.flash(.label("请输入正确的售价"), delay: 1.2)
            return
        }
        if guiGe.count == 0 {
            HUD.flash(.label("请输入规格"), delay: 1.2)
            return
        }
        
        if isYuShouSetting {
            if isPurnNumber(str: yuShouPrice) == false{
                HUD.flash(.label("请输入正确的预售价格"), delay: 1.2)
                return
            }
            if isPurnNumber(str: ysKuCun) == false {
                HUD.flash(.label("请输入正确的库存"), delay: 1.2)
                return
            }
        }
        if jieTiArr.count > 0 {
            for item in jieTiArr {
                let str = item as! String
                let arr = str.components(separatedBy: "_")
                for letter in arr {
                    if letter.count == 0 {//提示阶梯数据未完整
                        HUD.flash(.label("请完整填写阶梯价数据"), delay: 1.2)
                        return
                    }
                }
            }
        }
        
        if specalArr.count > 0 {
            for item in specalArr {
                let str = item as! String
                let arr = str.components(separatedBy: "_")
                for letter in arr {
                    if letter.count == 0 {//提示预售阶梯数据未完整
                        HUD.flash(.label("请完整填写预售阶梯价数据"), delay: 1.2)
                        return
                    }
                }
            }
        }
        
        dataModel.price = price
        dataModel.guiGe = guiGe
        dataModel.weight = weight
        dataModel.wenDu = wenDu
        dataModel.danWei = danWei
        dataModel.isYsJieTiOpen = isYsJieTiOpen
        dataModel.jieTiArr = jieTiArr as! Array<Any>
        dataModel.specalArr = specalArr as! Array<Any>
        dataModel.yuShouPrice = yuShouPrice
        dataModel.selectYuShou = selectYuShou
        dataModel.itemDanWeiSelect = itemDanWeiSelect
        dataModel.tempSelect = tempSelect
        dataModel.isJieTiOpen = isJieTiOpen
        //        dataModel.isOpenYSSetting = isOpenYSSetting
        if DJBiLi.count == 0 {
            DJBiLi = "0"
        }
        dataModel.DJBiLi = DJBiLi
        dataModel.ysKuCun = ysKuCun
        if barTitle?.contains("编辑") == true {
            datasArr.insert(dataModel, at: selectIdx!.item)
            datasArr.remove(at: selectIdx!.item+1)
        }else{
            dataModel.sku_id = 0
            datasArr.append(dataModel)
            selectIdx?.item = datasArr.count - 1
        }
        delegate?.CreatNewSpecsViewControllerSaveAction(datas:datasArr,selectIdx:selectIdx!)
        self.navigationController?.popViewController(animated: true)
    }
    //MARK: - TEXTFIELD DELEGATE
    func textFieldDidEndEditing(_ textField: UITextField) {
        print(textField.tag)
        switch textField.tag {
        case 0:
            if isPurnNumber(str: textField.text!) {
                textField.text = formatShowNumber(value: textField.text!)
                price = textField.text!
                if isYuShouSetting && firstTimeSetting{
                    yuShouPrice = price
                    let idx = IndexPath(row: 0, section: 1)
                    let cell = listTbv.cellForRow(at: idx) as! YuShouCell
                    cell.inputTF1.text = yuShouPrice
                    firstTimeSetting = false
                }
            }else{
                HUD.flash(.label("请输入正确的价格"), delay: 1.2)
                textField.text = ""
                price = textField.text!
            }
            break
        case 1:
            guiGe = textField.text!
        case 2:
            if isPurnNumber(str: textField.text!) {
                textField.text = formatShowNumber(value: textField.text!)
                weight = textField.text!
            }else{
                HUD.flash(.label("请输入正确的重量"), delay: 1.2)
                textField.text = ""
                weight = textField.text!
            }
            break
        default:
            break
        }
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        switch textField.tag {
        case 1:
            guiGe = textField.text!
            break
        default:
            break
        }
        return true
    }
    func PuTongJieTiClickDone() {
        IQKeyboardManager.shared.resignFirstResponder()
    }
    //MARK: - cell delegate
    func numberOfSections(in tableView: UITableView) -> Int {
        if (navbar.title?.contains("编辑"))! {
            return 4
        }else{
            return 3
        }
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        if section == 0 {
            return titleArray.count
        }
        if section == 2 {
            if selectYuShou {//预售
                return specalArr.count
            }else{//非预售
                return jieTiArr.count
            }
        }
        return 1
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        if indexPath.section == 0 {
            if indexPath.row < 3 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTF") as! TitleAndTFCell
                cell.nameLbl.text = titleArray[indexPath.row]
                cell.textTF.isUserInteractionEnabled = isAllEditing
                cell.tag = indexPath.row
                cell.textTF.tag = cell.tag
                //keyboardType
                cell.textTF.returnKeyType = .done
                cell.textTF.delegate = self
                if indexPath.row == 0 || indexPath.row == 2{
                    cell.textTF.keyboardType = .decimalPad
                }
                let str = NSAttributedString(string: pliceHolderArr[indexPath.row], attributes: [NSAttributedString.Key.foregroundColor:UIColor(named: "灰色字体颜色")])
                cell.textTF.attributedPlaceholder = str
                if datasArr.count > 0 {
                    switch indexPath.row {
                    case 0:
                        cell.textTF.text = price
                        break
                    case 1:
                        cell.textTF.text = guiGe
                        break
                    default:
                        cell.textTF.text = weight
                        break
                    }
                    
                }
                cell.delegate = self
                return cell
            }else{
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtn") as! TitleAndBtnCell
                cell.tag = indexPath.row
                cell.btn.isUserInteractionEnabled = isAllEditing
                cell.delegate = self
                cell.nameLbl.text = titleArray[indexPath.row]
                cell.contentLbl.text = pliceHolderArr[indexPath.row]
                if indexPath.row == 3 {
                    
                    cell.contentLbl.text = selectListArr[tempSelect]
                    
                }
                if indexPath.row == 4 {
                    if itemDanWeiSelect != nil {
                        cell.contentLbl.text = danWeiArr![itemDanWeiSelect!]
                    }
                }
                if datasArr.count > 0 {
                    switch indexPath.row {
                    case 3:
                        if wenDu.count > 0{
                            cell.contentLbl.text = wenDu
                        }
                        break
                    case 4:
                        if danWei.count > 0 {
                            cell.contentLbl.text = danWei
                        }
                        break
                    default:
                        break
                    }
                    
                }
                return cell
            }
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSwitch") as! TitleAndSwitchCell
        cell.delegate = self
        cell.namelbl.font = UIFont.boldSystemFont(ofSize: 15)
        cell.infoSw.isUserInteractionEnabled = isAllEditing
        if indexPath.section == 1{
            cell.namelbl.text = "预售设置"
            if isYuShouSetting  == false{
                cell.namelbl.alpha = 0.45
                cell.isUserInteractionEnabled = false
            }
            cell.tag = 5
            
        }
        
        if indexPath.section == 1 {
            if isYuShouSetting == true {
                let cell = tableView.dequeueReusableCell(withIdentifier: "YuShou") as! YuShouCell
                cell.infoSw.isHidden = true
                cell.inputTF1.isUserInteractionEnabled = isAllEditing
                cell.inputTF2.isUserInteractionEnabled = isAllEditing
                cell.inputTF2.keyboardType = .numberPad
                cell.inputTF3.isUserInteractionEnabled = isAllEditing
                cell.tag = indexPath.row
                cell.infoSw.isUserInteractionEnabled = isAllEditing
                //                cell.infoSw.isOn = isOpenYSSetting
                cell.delegate = self
                cell.inputTF1.text = yuShouPrice
                cell.inputTF2.text = ysKuCun
                cell.inputTF3.text = DJBiLi
                return cell
            }
        }
        
        if indexPath.section == 2 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "PuTongJieTi") as! PuTongJieTiCell
            cell.btn.isUserInteractionEnabled = isAllEditing
            cell.delegate = self
            cell.titleLbl.text = "\(indexPath.row+1).数量≥"
            cell.tag = indexPath.row
            cell.countTF.isUserInteractionEnabled = isAllEditing
            cell.priceTF.isUserInteractionEnabled = isAllEditing
            cell.isYuShou = selectYuShou
            cell.countTF.text = ""
            cell.priceTF.text = ""
            var item:NSString = ""
            if selectYuShou {
                item = specalArr[indexPath.row] as! NSString
            }else{
                item = jieTiArr[indexPath.row] as! NSString
            }
            if item != "" {
                //MARK:--阶梯价格切割
//                print("sjklasd",item)
                let arr = item.components(separatedBy: "_")
                cell.priceTF.text = arr[0]
                cell.countTF.text = arr[1]
            }
            
            return cell
        }
        if indexPath.section == 3 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "DelGuiGe") as! DelGuiGeCell
            
            return cell
        }
        return cell
        
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if isAllEditing == false {
            return
        }
        if indexPath.section == 3 {
            //删除
            datasArr.remove(at: selectIdx!.item)
            var num = 0
            if selectIdx!.item > 0 {
                num = selectIdx!.item - 1
            }
            let idx = IndexPath(item: num, section: 0)
            
            delegate?.CreatNewSpecsViewControllerDeleteAction(datas: datasArr,selectIdx:idx)
            self.navigationController?.popViewController(animated: true)
            
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 1 {
            if isYuShouSetting == false{
                return 0.001
            }else{
                return 184.5
            }
            //            if isOpenYSSetting {
            //
            //            }
        }
        if indexPath.section == 2 {
            if isJieTiOpen && selectYuShou == false {
                return 49
            }
            if isYsJieTiOpen && selectYuShou {
                return 49
            }
            return 0.001
            
        }
        return 49
    }
    
    //header
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView()
        if section == 2 {//阶梯价设置
            if isYuShouSetting {//预售阶梯价
                let view = TitleAndSwitchHeaderView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 90))
                view.infoSW.isUserInteractionEnabled = isAllEditing
                view.ysInfoSw.isUserInteractionEnabled = isAllEditing
                view.delegate = self
                view.selectYuShou = selectYuShou
                view.infoSW.isOn = isJieTiOpen//普通
                view.ysInfoSw.isOn = isYsJieTiOpen//预售
                return view
            }else{//普通
                let view = NewCreateHeader(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 49))
                view.delegate = self
                view.infoSw.isUserInteractionEnabled = isAllEditing
                view.infoSw.isOn = isJieTiOpen
                if isJieTiOpen == false{
                    return view
                }
                return view
            }
        }
        return view
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section != 0 {
            if section == 2 {
                if isYuShouSetting{
                    return 90
                }
                return 59
            }
            if section == 1 {
                if isYuShouSetting == false{
                    return 0.001
                }
            }
            return 10
        }
        
        return 0.01
    }
    //footer
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 2 {
            if barTitle?.contains("查看") == false {
                if isJieTiOpen && selectYuShou == false{
                    let view = NewCreateFooter(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 49))
                    view.delegate = self
                    return view
                }
                if isYsJieTiOpen && selectYuShou{
                    let view = NewCreateFooter(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 49))
                    view.delegate = self
                    return view
                }
            }
        }
        let view = UIView()
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0 || section == 1 {
            if isYuShouSetting == false{
                return 0.001
            }
        }
        if section == 2 {
            if isJieTiOpen && selectYuShou == false {
                return 49
            }
            if isYsJieTiOpen && selectYuShou{
                return 49
            }
        }
        return 0.01
    }
    //MARK: - NEW CELL DELEGATE
    
    func YuShouCellTFContent(Price: NSString) {
        let arr = Price.components(separatedBy: "_")
        yuShouPrice = arr[0]
        ysKuCun = arr[1]
        DJBiLi = arr[2]
    }
    
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        let cell = listTbv.cellForRow(at: IndexPath(row: view.tag, section: 0)) as! TitleAndBtnCell
        if view.tag == 3 {
            tempSelect = selectNum
            wenDu = selectListArr[selectNum]
            cell.contentLbl.text = selectListArr[selectNum]
        }else{
            itemDanWeiSelect = selectNum
            cell.contentLbl.text = danWeiArr![selectNum]
            danWei = danWeiArr![selectNum]
        }
        
        
        selectView?.removeFromSuperview()
        selectView = nil
    }
    
    
    
    
    var tempSelect = 0
    var itemDanWeiSelect:Int?
    
    func btnClick(content: String, cell: TitleAndBtnCell) {
        if cell.tag == 3 {
            if selectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.tag = cell.tag
                view.titleLbl.text = "请选择商品温藏"
                view.delegate = self
                view.dataArr = selectListArr
                for i in 0 ..< selectListArr.count{
                    if wenDu == selectListArr[i] {
                        tempSelect = i
                    }
                }
                
                view.selectNum = tempSelect
                view.tempNum = view.selectNum
                
                self.view.addSubview(view)
                selectView = view
            }
        }else{
            if selectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.tag = cell.tag
                view.titleLbl.text = "请选择商品单位"
                view.delegate = self
                if danWeiArr != nil {
                    view.dataArr = danWeiArr!
                    for i in 0 ..< danWeiArr!.count{
                        if danWei == danWeiArr![i] {
                            itemDanWeiSelect = i
                        }
                    }
                }
                if itemDanWeiSelect != nil {
                    view.selectNum = itemDanWeiSelect!
                }
                self.view.addSubview(view)
                selectView = view
            }
        }
        
    }
    
    func switchStatus(sender: UISwitch) {//阶梯价设置
        if sender.tag == 99 {
            isYsJieTiOpen = sender.isOn
        }else{
            isJieTiOpen = sender.isOn
        }
        listTbv.reloadData()
    }
    
    func switchClick(content: UISwitch, cell: TitleAndSwitchCell) {
        //控制
        if cell.tag == 5{
            let idxPath = IndexPath(row: 0, section: 1)
            if isYuShouSetting   {//单独点击预售设置
                listTbv.reloadData()
            }else{//单独打开预售设置
                listTbv.reloadRows(at: [idxPath], with: .none)
            }
        }
        
    }
    func newCreateSwitchStatus(sender: UISwitch) {
        //打开switch 阶梯价设置
        //        isJieTiJiaSetting = sender.isOn
        isJieTiOpen = sender.isOn
        listTbv.reloadData()
    }
    
    func footerClickAction() {
        if isAllEditing == false {
            return
        }
        print(jieTiArr)
        if selectYuShou {//预售
            specalArr.append("")
        }else{//非预售
            jieTiArr.append("")
        }
        listTbv.reloadData()
    }
    func YuShouCellSwitchStatus(sender: UISwitch) {
        //控制
        //        isYuShouSetting = sender.isOn
        //        isOpenYSSetting = sender.isOn
        listTbv.reloadData()
    }
    func PuTongJieTiDelAction(sender: PuTongJieTiCell) {
        if selectYuShou {
            specalArr.remove(at: sender.tag)
            listTbv.reloadData()
        }else{
            jieTiArr.remove(at: sender.tag)
            listTbv.reloadData()
        }
        
    }
    func PuTongJieTiContentSp(price: String, count: String, cell: PuTongJieTiCell) {
        specalArr.insert("\(price)_\(count)", at: cell.tag)
        specalArr.remove(at: cell.tag+1)
    }
    func PuTongJieTiContent(price: String, count: String, cell: PuTongJieTiCell) {
        
        jieTiArr.insert("\(price)_\(count)", at: cell.tag)
        jieTiArr.remove(at: cell.tag+1)
        
    }
    
    func selectYuShou(sender: UIButton) {
        if sender.tag == 0 {
            selectYuShou = false
        }else{
            selectYuShou = true
        }
        listTbv.reloadData()
    }
    //MARK: - COLLECTIONVIEW DELEGATE
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 0
    }
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return datasArr.count
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "ItemCell", for: indexPath)
            as! ItemCell
        cell.tag = indexPath.item
        cell.nameLbl.text = "规格" + "\(indexPath.item+1)"
        if indexPath == selectIdx {
            cell.nameLbl.textColor = UIColor(named: "蓝色字体颜色")
            cell.lineView.isHidden = false
        }else{
            cell.nameLbl.textColor = UIColor(named: "标题字颜色")
            cell.lineView.isHidden = true
        }
        return cell
        
    }
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        selectIdx = indexPath
        //刷新cell
        let dataDict = datasArr[selectIdx!.item]
        price = dataDict.price
        guiGe = dataDict.guiGe
        weight = dataDict.weight
        wenDu = dataDict.wenDu
        danWei = dataDict.danWei
        yuShouPrice = dataDict.yuShouPrice
        specalArr = dataDict.specalArr
        jieTiArr = dataDict.jieTiArr
        isJieTiOpen = dataDict.isJieTiOpen
        //        isOpenYSSetting = dataDict.isOpenYSSetting
        DJBiLi = dataDict.DJBiLi
        isYsJieTiOpen = dataDict.isYsJieTiOpen
        ysKuCun = dataDict.ysKuCun
        selectYuShou = dataDict.selectYuShou
        listTbv.reloadData()
        collectionView.reloadData()
    }
}
