//
//  XinCaiGouViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/9.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

protocol XinCaiGouViewControllerDelegate {
    func XinCaiGouViewControllerFinish()
}
class XinCaiGouViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,CGDCellDelegate,XuanZeShangPinViewControllerDelegate, ShowTimeSelectViewDelegate,GLAlertSelectViewDelegate, GYSListViewControllerDelegate,UITextFieldDelegate, GeliAlertViewDelegate,GeliAlertTextViewDelegate{
     let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var isSQ = false //isSq == true 必须审核
    
    func sureGeliAlertTextViewAction(sender: String) {
        contentStr = sender
        listView.reloadData()
    }
    
    var delegate:XinCaiGouViewControllerDelegate?
    
    var idx:Int?
    
    func getNewPicDictsArray(){
        print("源数据")
        var tempArr:Array<GetGoodsInfoDataModel> = []
        var tempOldArr:Array<GetGoodsInfoDataModel> = []
        datas.forEach { (model) in
            tempArr.append(model)
        }
        recordArr.forEach({ (model) in
            tempOldArr.append(model)
        })
        
        var sameItem:Array<GetGoodsInfoDataModel> = []
        tempOldArr.forEach { (old) in
            tempArr.forEach { (new) in
                if old.sku_id == new.sku_id {
                    sameItem.append(new)
                }
            }
        }
        
        
        sameItem.forEach { (same) in
            tempOldArr.forEach { (old) in
                if old.sku_id == same.sku_id {
                    let idx = tempOldArr.lastIndex { (model) -> Bool in
                        return model.sku_id == same.sku_id
                    }
                    tempOldArr.remove(at: idx!)
                }
            }
        }
        var delItem:Array<GetGoodsInfoDataModel> = []
        tempOldArr.forEach { (item) in
            item.edit_status = 3
            delItem.append(item)
        }
        
        sameItem.forEach { (same) in
            tempArr.forEach { (old) in
                if old.sku_id == same.sku_id {
                    let idx = tempArr.lastIndex { (model) -> Bool in
                        return model.sku_id == same.sku_id
                    }
                    tempArr.remove(at: idx!)
                }
            }
        }
        var newItem:Array<GetGoodsInfoDataModel> = []
        tempArr.forEach { (item) in
            item.edit_status = 2
            newItem.append(item)
        }
        holderItemArr = newItem + sameItem + delItem
    }
    var holderItemArr:Array<GetGoodsInfoDataModel> = []
    
    func sureGeliAlertViewAction(sender: UIButton) {
       
        
        var goodsInfoArr:Array<Any>? = []
        if sender.tag == 999 {
            getNewPicDictsArray()
            holderItemArr.forEach { (model) in
                let p = model.target_Price as! NSString
                let amount = p.floatValue * Float(model.target_Count!)
                let goods = [
                    "goods_id":model.goods_id as Any,
                    "sku_id":model.sku_id as Any,
                    "goods_name":model.goods_name as Any,
                    "sku_name":model.sku_attr as Any,
                    "num":model.target_Count as Any,
                    "unit":model.unit as Any,
                    "price":model.target_Price as Any,
                    "amount":amount as Any,
                    "pog_id":model.pog_id as Any,
                    "edit_status":model.edit_status as Any
                ]
                goodsInfoArr?.append(goods)
            }
        }else{
            datas.forEach { (model) in
                let goods = [
                    "goods_id":model.goods_id as Any,
                    "sku_id":model.sku_id as Any,
                    "goods_name":model.goods_name as Any,
                    "sku_name":model.sku_attr as Any,
                    "num":model.target_Count as Any,
                    "unit":model.unit as Any,
                    "price":model.price as Any,
                    "amount":model.target_Price as Any,
                    "pog_id":model.pog_id as Any
                ]
                goodsInfoArr?.append(goods)
            }
        }
        let goods_info = dataChangeString(sender: goodsInfoArr!)
        var dict = [
            "user_token":UserToken as Any,
            "ven_id":ven_id as Any,
            "purchase_time":dayTime as Any,
            "purchaser":cgName as Any,
            "type":typeSelect + 1 as Any,
            "remarks":contentStr as Any,
            "goods_info":goods_info as Any
        ]
        HUD.flash(.progress)
        if orderNum != nil {
            dict["po_id"] = po_id!
            purchaseOrderEdit(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "修改成功"), delay: 1.2)
                self.delegate?.XinCaiGouViewControllerFinish()
                self.navigationController?.popViewController(animated: true)
            }) { (err) in
                
            }
            return
        }
        
        
       
        if isSQ == true && idx != nil {//申请入口
            dict["is_apply"] = 1
        }else{
            
            if idx != nil {
                dict["is_apply"] = 1
            }
            let idx2 = model?.auth?.firstIndex(of: "119")
            if idx2 != nil {
                dict["is_apply"] = 2
            }
        }
        
        purchaseOrderAdd(dict, success: { (data) in
            HUD.hide()
            HUD.flash(.labeledSubSuccess(subtitle: "提交成功"), delay: 1.2)
            self.delegate?.XinCaiGouViewControllerFinish()
            self.navigationController?.popViewController(animated: true)
        }) { (error) in
            
        }
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        if textField.text!.containsEmoji {
            HUD.flash(.label("不可输入表情符号"), delay: 1.2)
            textField.text = ""
            return
        }
        if textField.tag == 3 {
            cgName = textField.text!
        }
        
        listView.reloadData()
    }
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        typeSelect = selectnum
        view.removeFromSuperview()
        glSelectView = nil
    }
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        typeSelect = selectNum
        if typeSelect != 10086 {
            holderArr.insert(typeArr[typeSelect], at: 4)
            holderArr.remove(at: 5)
            listView.reloadData()
        }
        view.removeFromSuperview()
        glSelectView = nil
    }
    func XuanZeShangPinViewControllerSubmitAction(selectArr: Array<GetGoodsInfoDataModel>) {
        for item in selectArr{
            datas.append(item)
        }
        listView.reloadData()
    }
    
    func XuanZeShangPinViewControllerYuShou(YuShouData: Array<GetGoodsInfoDataModel>) {
        
    }
    
    func XuanZeShangPinViewControllerEdit(selectArr: Array<GetGoodsInfoDataModel>) {
        
    }
    
    //MARK: - 删除
    func CGDCellDelAction(cell: CGDCell) {
        datas.remove(at: cell.tag)
        listView.reloadData()
    }
    var dayTimeStr = ""
    var dayTime:Double?
    @IBOutlet weak var btmLbl: UILabel!
    
    
    var glSelectView:GLAlertSelectView?
    var typeSelect = 1
    var cgName = ""
    var contentStr = ""
    //MARK: - 提交审核
    @IBAction func submitAction(_ sender: Any) {
        print("submit")
        if dayTime == nil {
            HUD.flash(.label("请选择时间"), delay: 1.2)
            return
        }
        if ven_id == nil {
            HUD.flash(.label("请选择供应商"), delay: 1.2)
            return
        }
        if typeSelect == nil && typeSelect != 10086 {
            HUD.flash(.label("请选择采购类型"), delay: 1.2)
            return
        }
        if datas.count == 0 {
            HUD.flash(.label("请选择商品"), delay: 1.2)
            return
        }
        
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        if orderNum == nil {
            alertView.titileLbl.text = "是否提交申请？"
        }else{
            alertView.titileLbl.text = "是否提交修改？"
            alertView.rightBtn.tag = 999
        }
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
        self.view.window?.addSubview(alertView)
        
    }
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var btmLine: UIView!
    var datas:Array<GetGoodsInfoDataModel> = []
    var recordArr:Array<GetGoodsInfoDataModel> = []
    let typeArr = ["临时采购","固定采购"]
    
    let titleArr = ["采购单号","采购日期","供应商","采购人","采购类型","备注"]
    var holderArr = ["","","请选择供应商","请输入采购人姓名","固定采购","请输入备注"]
    
    var orderNum:String?
    var ven_name:String?
    var ven_id:Int?
    var po_id:Int?
    
    var model:InitInfoDataModel?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        if ven_name != nil {
            holderArr.insert((ven_name)!, at: 2)
            holderArr.remove(at: 3)
        }
        
        if orderNum == nil {
            navbar.title = "新增采购单"
        }else{
            navbar.title = "编辑采购单"
            btmLbl.text = "确认修改提交"
        }
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: btmLine)
        listView.separatorStyle = .none
        
        listView.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtnCell")
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "CGDDayCell", bundle: nil), forCellReuseIdentifier: "CGDDayCell")
        listView.register(UINib(nibName: "CGDCell", bundle: nil), forCellReuseIdentifier: "CGDCell")
        
        listView.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        
        InitInfo(["user_token":UserToken as Any], success: { (data) in
            let mo = data as! InitInfoModel
            self.model = mo.data
            self.idx = self.model?.auth?.firstIndex(of: "125")
            let idx2 = self.model?.auth?.firstIndex(of: "119")
            if self.isSQ == false {
                if self.idx == nil && idx2 == nil{
                    self.listView.isHidden = true
                    self.btmLbl.isHidden = true
                    HUD.flash(.label("亲，您不具备新增采购单的权限"), delay:1.2)
                }
            }else{
                if self.idx == nil {
                    self.listView.isHidden = true
                    self.btmLbl.isHidden = true
                    HUD.flash(.label("亲，您不具备申请采购单的权限"), delay:1.2)
                }
            }
            
        }) { (err) in

        }
        
        
    }
    
    //MARK: - cell delegate
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.section == 0 {
            switch indexPath.row {
            case 1://时间
                print("跳转日期选择")
                let timeSelectV = ShowTimeSelectView(frame: self.view.window!.bounds)
                timeSelectV.moreSelection = false
                //把默认值传回去
                
                if dayTime != nil {
                    
                    let time = TimeInterval(exactly:dayTime!)
                    timeSelectV.BeginDate = Date(timeIntervalSince1970: time!)
                    timeSelectV.EndDate = Date(timeIntervalSince1970: time!)//无用处
                    
                }
                timeSelectV.endDateByWork = Date()
                
                timeSelectV.titleLbl.text = "请选择采购日期"
                timeSelectV.delegate = self
                self.view.window?.addSubview(timeSelectV)
                break
            case 2://供应商
                let vc = GYSListViewController()
                vc.barTitle = "选择供应商"
                vc.delegate = self
                self.navigationController?.pushViewController(vc, animated: true)
                break
            case 4://采购类型
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    view.tag = indexPath.row
                    view.selectNum = typeSelect
                    view.tempNum = view.selectNum
                    view.isOnlySelectKuWei = true
                    view.delegate = self
                    view.titleLbl.text = "请选择采购类型"
                    view.dataArr = typeArr
                    self.view.addSubview(view)
                    glSelectView = view
                }
                break
            case 5:
                let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
                alterView.delegate = self
                alterView.titleLbl.text = "请填写备注（选填）"
                alterView.placerLbl.text = "请填写备注..."
                if contentStr.count == 0 {
                    alterView.placerLbl.isHidden = false
                }else{
                    alterView.textview.text = contentStr
                    alterView.placerLbl.isHidden = true
                }
                self.view.window?.addSubview(alterView)
                break
            default:
                break
            }
        }
    }
    //MARK:--选择时间回调数据
    
    func showTimeSelectByData(timeStr: String, beginDate: Date, endginDate: Date) {
        let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
        print(timeStr,"采购日期",timeInterval)
        dayTimeStr = timeStr
        dayTime = Double(Int(timeInterval))
        
        listView.reloadData()
    }
    //MARK: - 添加商品
    @objc func addItemAction(){
        
        let vc = XuanZeShangPinViewController()
        vc.delegate = self
        vc.barTitle = "选择商品"
        vc.isCG = true
        self.navigationController?.pushViewController(vc, animated: true)
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            if indexPath.row == 2 || indexPath.row == 4{
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                cell.nameLbl.text = titleArr[indexPath.row]
                cell.contentLbl.text = holderArr[indexPath.row]
                cell.btn.isUserInteractionEnabled = false
                return cell
            }else if indexPath.row == 1{
                let cell = tableView.dequeueReusableCell(withIdentifier: "CGDDayCell") as! CGDDayCell
                if dayTimeStr.count > 0 {
                    cell.dayLbl.text = dayTimeStr
                }else{
                    cell.dayLbl.text = getTimeDayNow()
                    dayTime = Double(Date().timeStamp)
                }
                return cell
            }else{
                if indexPath.row == 5 {
                    let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
                    cell.nameLbl.text = titleArr[indexPath.row]
                    cell.btmLine.isHidden = true
                    cell.contentLbl.text = holderArr[indexPath.row]
                    cell.btmW.constant = 0
                    cell.contentRight.constant = 0
                    cell.imgRight.constant = 15
                    cell.contentLbl.textColor = UIColor(named: "#999999")
                    if contentStr.count != 0 {
                        cell.contentLbl.text = contentStr
                        cell.btmW.constant = 15
                        cell.contentRight.constant = 5
                        cell.imgRight.constant = 22
                        cell.contentLbl.textColor = UIColor(named: "标题字颜色")
                    }
                    return cell
                }
                
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
                if orderNum != nil {
                    cell.textTF.clearButtonMode = .always
                }
                if indexPath.row == 0 {
                    if orderNum == nil {
                        cell.nameLbl.isHidden = true
                        cell.textTF.isHidden = true
                    }else{
                        cell.nameLbl.isHidden = false
                        cell.textTF.isHidden = false
                        cell.textTF.text = orderNum!
                        cell.textTF.isUserInteractionEnabled = false
                        cell.textTF.clearButtonMode = .never
                    }
                }
                cell.nameLbl.text = titleArr[indexPath.row]
                cell.textTF.placeholder = holderArr[indexPath.row]
                cell.textTF.delegate = self
                cell.textTF.tag = indexPath.row
                if indexPath.row == 3 {
                    cell.textTF.text = cgName
                }
                
                return cell
            }
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "CGDCell") as! CGDCell
        cell.tag = indexPath.row
        cell.delegate = self
        let model = datas[indexPath.row]
        cell.nameLbl.text = model.goods_name!
        cell.detailLbl.text = model.spec_str! + " ¥" + model.target_Price! + "x\(model.target_Count!) " + model.unit!
        cell.cgCount.text = "\(model.target_Count!)"
        cell.cgPrice.text = model.target_Price!
        let price = model.target_Price! as NSString
        cell.cgTotalPrice.text = String(format: "%.2f", Float(model.target_Count!)*price.floatValue)
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 1 {
            return 174
        }
        if indexPath.section == 0 {
            if indexPath.row == 0 {
                if orderNum == nil {
                    return 0.01
                }
            }
            if indexPath.row == 5 {
                return UITableView.automaticDimension
//                if getStrHeight(str: contentStr)+30 > 49 {
//                    return getStrHeight(str: contentStr)+30
//                }
            }
        }
        return 49
    }
    
    func getStrHeight(str:String) -> CGFloat{
        let lbl = UILabel()
        lbl.text = titleArr.last
        lbl.font = UIFont.systemFont(ofSize: 13)
        lbl.sizeToFit()
        let margin = lbl.bounds.size.width + 77
        let viewSize = CGSize(width:fullScreenWidth - margin , height: CGFloat(MAXFLOAT))
        let font = UIFont.systemFont(ofSize: 13)
        return (str as NSString).boundingRect(with: viewSize, options: [.usesLineFragmentOrigin], attributes: [NSAttributedString.Key.font:font], context: nil).height
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 0 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 15))
            view.backgroundColor = UIColor(named: "app底色")
            return view
        }
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 135))
        view.backgroundColor = UIColor.white
        let img = UIImageView()
        img.image = UIImage(named: "tianjiashangpin")
        view.addSubview(img)
        img.snp.makeConstraints { (make) in
            make.top.equalTo(50)
            make.centerX.equalTo(view.snp_centerX)
            make.width.height.equalTo(52)
        }
        let btn = UIButton()
        view.addSubview(btn)
        btn.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalTo(0)
        }
        btn.addTarget(self, action: #selector(addItemAction), for: .touchUpInside)
        return view
    }
    
    
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0 {
            return 15
        }
        return 135
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 0 {
            return titleArr.count
        }
        return datas.count
    }
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 1 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 39))
            let lbl = UILabel(frame: CGRect(x: 15, y: 15, width: fullScreenWidth, height: 21))
            lbl.text = "选择商品"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            view.addSubview(lbl)
            return view
        }
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 1 {
            return 39
        }
        return 0.001
    }
    func GYSListViewControllerGetGYS(sender: VendorListDataModel) {
        ven_name = sender.ven_name
        ven_id = sender.ven_id
        holderArr.insert(ven_name!, at: 2)
        holderArr.remove(at: 3)
        listView.reloadData()
    }
    
}
extension Date {
    
    /// 获取当前 秒级 时间戳 - 10位
    var timeStamp : Int {
        let timeInterval: TimeInterval = self.timeIntervalSince1970
        let timeStamp = Int(timeInterval)
        return timeStamp
    }
}
