//
//  HuoLaLaDiZhiCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/7/31.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol HuoLaLaDiZhiCellDelegate {
    func HuoLaLaDiZhiCellBtnClick(model:citySearchDataPoiChildrenModel,cityStr:String)
}
class HuoLaLaDiZhiCell: UITableViewCell {
    var delegate:HuoLaLaDiZhiCellDelegate?
    var cityStr:String = ""
    @IBOutlet weak var btmH: NSLayoutConstraint!
    @IBOutlet weak var marginValue: NSLayoutConstraint!
    @IBOutlet weak var btnViewBG: UIView!
    @IBOutlet weak var btnViewH: NSLayoutConstraint!
    @IBOutlet weak var contentLbl: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    var children:Array<citySearchDataPoiChildrenModel>?
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        // Initialization code
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        for item in btnViewBG.subviews {
            item.removeFromSuperview()
        }
        if children != nil && children!.count > 0 {
               for i in 0 ..< children!.count {
                   setLocUI(index: i, bg: btnViewBG!)
               }
            }
    }
    
    func setLocUI(index:Int,bg:UIView){
        
        let item = children![index]
        let width = fullScreenWidth - 40 - bg.frame.minX
        let w = width / 3
        let cols = 3
        
        let col = index % cols
        let row = index / cols
    
        let shopX = CGFloat(col) * (w + 10)
        let shopY = CGFloat(row) * (30 + 10)
        
        let btn = UIButton(frame: CGRect(x: shopX , y: shopY , width: w, height: 30))
        btn.addTarget(self, action: #selector(abc(sender:)), for: .touchUpInside)
        btn.tag = index
        btn.layer.borderColor = UIColor(named: "提示语字体颜色")?.cgColor
        btn.layer.borderWidth = 1
        btn.layer.cornerRadius = 3
        btn.layer.masksToBounds = true
        btn.setTitle(item.address, for: .normal)
        btn.titleLabel?.font = UIFont.systemFont(ofSize: 11)
        btn.setTitleColor(UIColor(named: "灰色字体颜色"), for: .normal)
        bg.addSubview(btn)
        
    }
    //
    @objc func abc(sender:UIButton){
        delegate?.HuoLaLaDiZhiCellBtnClick(model: children![sender.tag],cityStr: cityStr)
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
