//
//  WayBillAddressItemCell.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class WayBillAddressItemCell: UITableViewCell {

    @IBOutlet weak var lineTopView: UIView!
    @IBOutlet weak var iconW: NSLayoutConstraint!
    @IBOutlet weak var iconH: NSLayoutConstraint!
    @IBOutlet weak var lineView: UIView!
    @IBOutlet weak var namePhoneLbl: UILabel!
    @IBOutlet weak var addressDetailLbl: UILabel!
    @IBOutlet weak var addressLbl: UILabel!
    @IBOutlet weak var iconLbl: UILabel!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
    }
    open override func layoutSubviews() {
        super.layoutSubviews()
        self.contentView.setNeedsLayout()
        self.contentView.layoutIfNeeded()
        drawLineOfDashByCAShapeLayer(lineView:lineView, lineLength: 4, lineSpacing: 4, lineColor: UIColor.init(named: "虚线分界线颜色")!, isHorizonal: false)
        drawLineOfDashByCAShapeLayer(lineView:lineTopView, lineLength: 4, lineSpacing: 4, lineColor: UIColor.init(named: "虚线分界线颜色")!, isHorizonal: false)

    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }

}
