//
//  OtherDemandViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/23.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
protocol OtherDemandViewControllerDelegate {
    func OtherDemandViewControllerResult(strs:Array<spec_req_arr_data>,selectArr:Array<Int>)
}
class OtherDemandViewController: BaseViewController ,UITableViewDelegate,UITableViewDataSource{
    var delegate:OtherDemandViewControllerDelegate?
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if carModel != nil && ((carModel?.spec_req_arr!.count)!) > 0 {
            return (carModel?.spec_req_arr!.count)!
        }
        return 0
    }
    
    @IBOutlet weak var sureBtn: LGButton!
    @IBOutlet weak var listView: UITableView!
    var carModel:cityCartDataModel?
    override func viewDidLoad() {
        super.viewDidLoad()
        if selectArr.count == 0 {
            if carModel != nil && carModel!.spec_req_arr!.count > 0 {
                for _ in carModel!.spec_req_arr! {
                    selectArr.append((carModel?.spec_req_arr!.count)!)
                }
            }
        }
        
        navbar.title = "额外需求"
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: sureBtn)
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelectCell")
    }
    
    
    var selectArr:Array<Int> = []
    @IBAction func sureDemandAction(_ sender: LGButton) {
        print("sureDemandAction")
        var tempArr:Array<spec_req_arr_data> = []
        for item in selectArr {
            if item != selectArr.count {
                tempArr.append((carModel?.spec_req_arr![item]) as! spec_req_arr_data)
            }
        }
        delegate?.OtherDemandViewControllerResult(strs: tempArr,selectArr: selectArr)
        self.navigationController?.popViewController(animated: true)
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        let item = selectArr[indexPath.row]
        if item == indexPath.row {
            selectArr.insert(selectArr.count, at: indexPath.row)
        }else{
            selectArr.insert(indexPath.row, at: indexPath.row)
        }
        selectArr.remove(at: indexPath.row + 1)
        tableView.reloadData()
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 50
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelectCell") as! TitleAndSelectCell
        let data = (carModel?.spec_req_arr![indexPath.row])
        cell.titleLbl.text = data?.name
        cell.tag = indexPath.row
        if cell.tag == selectArr[indexPath.row] {
            cell.selectBtn.isSelected = true
        }else{
            cell.selectBtn.isSelected = false
        }
        
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        
        return 40
    }
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView()
        view.backgroundColor = UIColor.white
        for suv in view.subviews {
            suv.removeFromSuperview()
        }
        let lbl = UILabel()
        lbl.textColor = UIColor.init(named: "标题字颜色")
        lbl.font = UIFont.boldSystemFont(ofSize: 15)
        view.addSubview(lbl)
        lbl.snp.makeConstraints { (make) in
            make.left.equalTo(15)
            make.bottom.equalTo(-5)
        }
        
        let lblFU = UILabel()
        lblFU.textColor = UIColor.init(named: "灰色字体颜色")
        lblFU.font = UIFont.init(name: "PingFang SC", size: 11)
        view.addSubview(lblFU)
        lblFU.snp.makeConstraints { (make) in
            make.left.equalTo(lbl.snp_right)
            make.bottom.equalTo(-5)
        }
        
        lbl.text = "其它服务"
        lblFU.text = "(多选)"
        
        return view
    }
    
}
