//
//  CKGmCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol CKGmCellDelegate {
    func CKGmCellDelAction(cell:CKGmCell)
    func CKGmCellSelectAction(cell:CKGmCell)
}
class CKGmCell: UITableViewCell {
    var dataArr:Array<GetGoodBatchDataModel>? = []
    @IBOutlet weak var listBg: UIView!
    @IBOutlet weak var titleViewH: NSLayoutConstraint!
    
    @IBOutlet weak var detailLbl: UILabel!
    @IBOutlet weak var titleView: UIView!
    var delegate:CKGmCellDelegate?
    @IBAction func selectAction(_ sender: Any) {
        delegate?.CKGmCellSelectAction(cell: self)
    }
    @IBAction func delAction(_ sender: Any) {
        delegate?.CKGmCellDelAction(cell: self)
    }
    @IBOutlet weak var nameLbl: UILabel!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        // Initialization code
    }
    override func layoutIfNeeded() {
        listBg.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        if dataArr!.count > 0 {
            for i in 0 ..< dataArr!.count {
                let model = dataArr![i]
                let view = UIView()
                listBg.addSubview(view)
                view.snp.makeConstraints { (make) in
                    make.top.equalTo(i * 30)
                    make.height.equalTo(30)
                    make.left.right.equalTo(0)
                }
                let leftL = UILabel()
                view.addSubview(leftL)
                leftL.textColor = UIColor(named: "个人中心灰色字体")
                leftL.font = UIFont.systemFont(ofSize: 13)
                leftL.snp.makeConstraints { (make) in
                    make.left.equalTo(30)
                    make.top.bottom.right.equalTo(0)
                }
                leftL.text = "\(model.batch_id!)"
                
                let rightL = UILabel()
                view.addSubview(rightL)
                rightL.textColor = UIColor(named: "个人中心灰色字体")
                rightL.textAlignment = .right
                rightL.font = UIFont.systemFont(ofSize: 13)
                rightL.snp.makeConstraints { (make) in
                    make.right.equalTo(-30)
                    make.top.bottom.left.equalTo(0)
                }
                rightL.text = "\(model.chuHuoLiang!)"
            }
        }
        super.layoutIfNeeded()
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
