//
//  CKNonGmCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol CKNonGmCellDelegate {
    func CKNonGmCellDelAction(cell:CKNonGmCell)
    func CKNonGmCellInputCount(sender:String,cell:CKNonGmCell)
}
class CKNonGmCell: UITableViewCell,UITextFieldDelegate {
    var delegate:CKNonGmCellDelegate?
    @IBAction func delAction(_ sender: UIButton) {
        delegate?.CKNonGmCellDelAction(cell: self)
    }
    @IBOutlet weak var ckCountTf: UITextField!
    @IBOutlet weak var detailLbl: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        ckCountTf.delegate = self
        // Initialization code
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        delegate?.CKNonGmCellInputCount(sender: textField.text!, cell: self)
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
