//
//  PiCiXuanZeCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/28.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol PiCiXuanZeCellDelegate {
    func PiCiXuanZeCellBtnTextChange(sender:String,cell:PiCiXuanZeCell)
    func PiCiXuanZeCellBtnSelect(cell:PiCiXuanZeCell)
    func PiCiXuanZeCellRefreshCount(cell:PiCiXuanZeCell)
}
class PiCiXuanZeCell: UITableViewCell,UITextFieldDelegate {
    
    var delegate:PiCiXuanZeCellDelegate?
    
    @IBAction func btnClickAction(_ sender: UIButton) {
        iconBtn.isSelected = !iconBtn.isSelected
        delegate?.PiCiXuanZeCellBtnSelect(cell: self)
    }
    
    @IBOutlet weak var iconBtn: UIButton!
    @IBOutlet weak var dateLbl: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var SLLbl: UILabel!
    @IBOutlet weak var textTF: UITextField!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        textTF.keyboardType = .numberPad
        textTF.delegate = self
        textTF.addTarget(self, action: #selector(textChange(sender:)), for: .allEditingEvents)
        // Initialization code
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        print("fuck == ",textField.text)
        if isPurnInt(string: textTF.text!){
           delegate?.PiCiXuanZeCellRefreshCount(cell:self)
        }
    }
    @objc func textChange(sender:UITextField){
        if isPurnInt(string: textTF.text!){
            let num1 = textTF.text as! NSString
            let num2 = SLLbl.text as! NSString
            if num1.integerValue > num2.integerValue {
                HUD.flash(.label("超出库存"), delay: 1.2)
                textTF.text = SLLbl.text
            }
            if num1.integerValue == 0{
                HUD.flash(.label("出库数量不能为0"), delay: 1.2)
                textTF.text = ""
            }
            delegate?.PiCiXuanZeCellBtnTextChange(sender: textTF.text!, cell: self)
        }
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
