//
//  CRKListVC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator //cell动效

class CRKListVC: BaseViewController,UITableViewDelegate,UITableViewDataSource,CRKCellDelegate,UISearchBarDelegate, SearchBarViewDelegate,CRKXiangQVCDelegate ,MoreAndTimeSelectViewDelegate,GeliAlertTextViewDelegate,GeliAlertViewDelegate{
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    func sureGeliAlertViewAction(sender: UIButton) {
        //MARK: - 出入库列表 iog_id
        
        let data = datas![selectIdx!]
        
        var goodInfoArr:Array<Any> = []
        data.goods_res?.forEach({ (model) in
            let goods = [
                "w_id":0 as Any,
                "p_id":0 as Any,
                "iog_id":0 as Any
            ]
            goodInfoArr.append(goods)
        })
        let goodsInfo = dataChangeString(sender: goodInfoArr)
        
        let dict = [
            "user_token":UserToken as Any,
            "io_id":data.io_id as Any,
            "goods_info":goodsInfo as Any
        ]
        GoodsInputAudit(dict, success: { (data) in
            self.listView.mj_header?.beginRefreshing()
        }) { (error) in
            
        }
    }
    
    
    
    
    //刷新？？？
    func CRKXiangQVCFinishAction() {
        listView.mj_header?.beginRefreshing()
    }
    weak var searchV:SearchBarView!
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(searchBgView.snp_bottom)
            
            make.left.right.bottom.equalToSuperview()
        }
        
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        if moreTimeSelectView != nil {
            moreTimeSelectView.removeFromSuperview()
            moreTimeSelectView  = nil
        }
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    var isSearch = false
    var blackBtnView:UIButton! = nil
    
    //MARK: - searchView delegate
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    //MARK:--编辑即将结束
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        if keyword.count > 0 {
            keyword = searchBar.text!
            if keyword.count == 0 {
                loadData()
            }
        }
        removeBlackBtnView()
        
    }
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        removeBlackBtnView()
        
        listView.mj_header?.beginRefreshing()
        
        
    }
    //MARK: - 权限控制
    var isGm = true
    
    private let animations = [AnimationType.from(direction: .bottom, offset: 300*glscale)]
    
    @IBOutlet weak var topBtn: UIButton!
    var BeginDate: Date! = nil
    var EndDate: Date! = nil
    var paySArr:Array<Bool> = [false,false,false,false]
    var bugSArr:Array<Bool> = [false,false,false]
    var sendSArr:Array<Bool> = []
    var moreTimeSelectView:MoreAndTimeSelectView! = nil
    @IBAction func openViewAction(_ sender: Any) {
        print("筛选选项")
        removeBlackBtnView()
        
        if  moreTimeSelectView == nil {
            moreTimeSelectView = MoreAndTimeSelectView()
            moreTimeSelectView.delegate = self
            self.view.addSubview(moreTimeSelectView)
            moreTimeSelectView.snp.makeConstraints { (make) in
                make.left.bottom.right.equalTo(0)
                make.top.equalTo(searchBgView.snp_bottom)
                
            }
            moreTimeSelectView.setUI()
            
            moreTimeSelectView.setUIbyData(beginDate: BeginDate, endginDate: EndDate, paySelectArr: paySArr, bugSelectArr: bugSArr, sendSelectArr: sendSArr)
        }else{
            moreTimeSelectView.removeFromSuperview()
            moreTimeSelectView  = nil
        }
        
        
    }
    //MARK:--筛选回调数据
    func sureActionMoreAndTimeSelectView(beginDate: Date?, endginDate: Date?, paySelectArr: Array<Bool>, bugSelectArr: Array<Bool>, sendSelectArr: Array<Bool>) {
        moreTimeSelectView  = nil
        BeginDate = beginDate
        EndDate = endginDate
        paySArr = paySelectArr
        bugSArr = bugSelectArr
        sendSArr =  sendSelectArr
        
        if BeginDate == nil {
            start_time = 0
            end_time = 0
        }else{
            let timeInterval:TimeInterval = BeginDate!.timeIntervalSince1970
            let timeIntervalEnd:TimeInterval = EndDate!.timeIntervalSince1970
            start_time = Int(timeInterval)
            end_time = Int(timeIntervalEnd)
        }
        
        status = 0
        //单选处理--多选就做拼接。里层UI就不做限制
        for i in 0..<paySArr.count {
            let rowBool = paySArr[i]
            if rowBool {
                status = i
                break
            }
        }
        io_type = 0
        for i in 0..<bugSArr.count {
            let rowBool = bugSArr[i]
            if rowBool {
                io_type = i
                break
            }
        }
        if io_type == 1 {
            //入库
            i_type = 0
            o_type = 0
            for i in 0..<sendSArr.count {
                let rowBool = sendSArr[i]
                if rowBool {
                    i_type = i
                    break
                }
            }
        }else if io_type == 2{
            //出库
            i_type = 0
            o_type = 0
            for i in 0..<sendSArr.count {
                let rowBool = sendSArr[i]
                if rowBool {
                    o_type = i
                    break
                }
            }
        }else{
            //全部
            i_type = 0
            o_type = 0
        }
        
        listView.mj_header?.beginRefreshing()
        
    }
    //MARK:--筛选回调数据
    func colseActionMoreAndTimeSelectView() {
        moreTimeSelectView  = nil
    }
    
    @IBOutlet weak var searchBG: UIView!
    
    var datas:Array<WarehouseIoListDataDetailModel>? = []
    
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var searchBgView: UIView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "出入库记录"
        self.view.addSubview(navbar)
        //初始化筛选条件
        pushTheSelectData()
        //searchbar
        let searchBr = SearchBarView.init()
        searchV = searchBr
        self.searchBgView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(topBtn.snp_left)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        searchBG = searchBr
        searchBr.placeholderStr = "请输入商品名称"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        
        SetTopFrame(view: searchBgView, height: 44)
        
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "CRKCell", bundle: nil), forCellReuseIdentifier: "CRKCell")
        
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        self.listView!.mj_header = headerMJ
        //上拉加载相关设置
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        self.listView!.mj_footer = footerMJ
        self.listView?.mj_header?.beginRefreshing()
        
        
    }
    func pushTheSelectData(){
        for i in 0..<paySArr.count {
            if i == status {
                paySArr[i] = true
            }
        }
        for i in 0..<bugSArr.count {
            if i == io_type {
                bugSArr[i] = true
            }
        }
    }
    var status = 0 //    出入库(审核)状态，1审核中，2通过，3不通过；0全部
    var io_type = 0 //类型(出/入库)，1入库，2出库，3撤销入库,0全部
    var i_type = 0 //入库类型，选项见下文
    var o_type = 0 //出库类型，选项见下文
    var start_time = 0
    var end_time = 0
    var keyword = ""
    var page = 0
    var auth:Array<String> = []
    @objc func loadData(){
        page = 1
      
        let dic = ["user_token":UserToken as Any,"status":status as Any,"page":page as Any,"io_type":io_type as Any ,"i_type":i_type  as Any,"o_type":o_type  as Any,"start_time":start_time as Any,"end_time":end_time as Any,"keyword":keyword as Any]
        
        WarehouseIoList(dic , success: { (data) in
            self.datas?.removeAll()
            let model = data as! WarehouseIoListModel
            model.data?.io_res!.forEach({ (item) in
                self.datas?.append(item)
                
            })
            
            model.data?.auth?.forEach({ (item) in
                self.auth.append(item)
            })
            
            self.listView.reloadData()
            
            self.listView.mj_header?.endRefreshing()
            self.page = 2
            self.listView.performBatchUpdates({
                UIView.animate(views: self.listView!.visibleCells,
                               animations: self.animations, completion: {
                                
                })
            }, completion: nil)
            if model.data?.io_res?.count == 0  || model.data?.io_res == nil{
                self.listView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.listView?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView?.mj_header?.endRefreshing()
        }
    }
    
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        print("page = ",page)
        
        let dic = ["user_token":UserToken as Any,"status":status as Any,"page":page as Any,"io_type":io_type as Any ,"i_type":i_type  as Any,"o_type":o_type  as Any,"start_time":start_time as Any,"end_time":end_time as Any,"keyword":keyword as Any]
        
        WarehouseIoList(dic, success: { (data) in
            let dataM = data as! WarehouseIoListModel
            if dataM.data?.io_res?.count == 0 || dataM.data?.io_res == nil{
                self.listView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                dataM.data?.io_res?.forEach({ (model) in
                    self.datas?.append(model)
                })
                self.listView.reloadData()
                self.listView?.mj_footer?.endRefreshing()
            }
            
        }) { (error) in
            self.listView?.mj_footer?.endRefreshing()
            
        }
        
    }
    
    //MARK: - 提交申请
    
    func sureGeliAlertTextViewAction(sender: String) {
        
        HUD.show(.progress)
        if sender.count == 0 {
            HUD.flash(.label("请填写备注"), delay: 1.2)
            return
        }
      
        
        if isPass {//通过
            let data = datas![selectIdx!]
            let batchInfo:Array<Any> = []
            var goodsInfoArr : Array<Any> = []
            data.goods_res?.forEach({ (item) in
                let goods = [
                    "goods_id":item.goods_id as Any,
                    "goods_name":item.goods_name as Any,
                    "goods_spec":item.goods_spec as Any,
                    "sku_id":item.sku_id as Any,
                    "number":item.number as Any,
                    "batch_info":batchInfo
                    ] as [String : Any]
                goodsInfoArr.append(goods)
            })
            
            let goods_info = dataChangeString(sender: goodsInfoArr)
            let dict = [
                "user_token":UserToken as Any,
                "io_id":data.io_id as Any,
                "audit_remark":sender,
                "goods_info":goods_info]
            GoodsOutputAudit(dict, success: { (data) in
                self.listView.mj_header?.beginRefreshing()
            }) { (error) in
            }
            
        }else{//不通过
            let data = datas![selectIdx!]
            let dict = [
                "user_token":UserToken as Any,
                "io_id":data.io_id as Any,
                "audit_remark":sender as Any
            ]
            AuditFail(dict, success: { (data) in
                self.listView.mj_header?.beginRefreshing()
            }) { (error) in
                
            }
        }
        
    }
    var isPass = false
    var selectIdx:Int?
    var alterView:GeliAlertTextView?
    //MARK: - 通过，不通过方法
    func CRKCellBtnClick(sender: UIButton, cell: CRKCell) {
   
        selectIdx = cell.tag
        let data = datas![selectIdx!]
        if sender.tag == 0 {//通过
            if data.io_type == 1{
                let alertView = GeliAlertView(frame: self.view.window!.bounds)
                alertView.delegate = self;
                alertView.tishiLbl.text = ""
                alertView.titileLbl.text = "是否通过审核？"
                alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
                self.view.window?.addSubview(alertView)
            }
            if data.io_type == 2 {
                let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
                alterView.delegate = self
                alterView.titleLbl.text = "请填写通过备注"
                alterView.placerLbl.text = "请填写通过备注..."
                self.view.window?.addSubview(alterView)
                isPass = true
            }
        }else{//不通过
            let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
            alterView.delegate = self
            alterView.titleLbl.text = "请填写不通过备注"
            alterView.placerLbl.text = "请填写不通过备注..."
            self.view.window?.addSubview(alterView)
            isPass = false
        }
        
    }
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        //MARK: - 跳转详情 出入库
        let model = datas![indexPath.row]
        let vc = CRKXiangQVC()
        vc.delegate = self
        vc.status = model.status
        vc.model = model
        
        if model.io_type == 1 && auth.contains("122"){//入库
            vc.isGm = true
           
            InputInitInfo(["user_token":UserToken as Any,"goods_id":model.goods_res?.first?.goods_id as Any], success: { (data) in
                let model = data as! InputInitInfoModel
                model.data?.warehouse_res?.forEach({ (item) in
                    if item.is_default == 1 {
                        vc.w_id = item.w_id
                        vc.w_name = item.w_name
                        item.warehouse_position?.forEach({ (poi) in
                            if poi.is_default == 1 {
                                vc.p_id = poi.p_id
                                vc.p_name = poi.p_name
                            }
                        })
                    }
                })
                self.navigationController?.pushViewController(vc, animated: true)
            }) { (error) in
                
            }
            return
        }
        if model.io_type == 2 && auth.contains("121"){
            vc.isGm = true
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas!.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "CRKCell") as!
        CRKCell
        
        cell.isGm = isGm
        let model = datas![indexPath.row]
        cell.status = model.status
        
        cell.isGm = false
        if model.io_type == 1 && auth.contains("122"){
            cell.isGm = true
            
        }
        if model.io_type == 2 && auth.contains("121"){
            cell.isGm = true
            
        }
        cell.dataArr = model.goods_res
        cell.delegate = self
        cell.tag = indexPath.row
        cell.nameLbl.text = model.applicant
        let strs = model.io_type_cn?.components(separatedBy: ":")
        cell.statusLbl.text = (strs?.first)! + "："
        cell.statusNameLbl.text = strs?.last
        var count = 0
        for item in model.goods_res! {
            count += item.number!
        }
        if model.io_type == 1 {
            cell.countLbl.text = "入库总数：" + "\(count)"
        }
        if model.io_type == 2 {
            cell.countLbl.text = "出库总数：" + "\(count)"
        }
        cell.timeLbl.text = dayAndTimeByDouble(sender: model.add_time!)
        
        return cell
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        let model = datas![indexPath.row]
        
        var num = 0
        if model.goods_res != nil {
            num = model.goods_res!.count
            if num > 4 {
                num = 4
            }
        }
        if model.status == 1 && isGm == false {//审核中&非管理者
            return 174.5 + CGFloat(num * 49) - 45
        }else{
            return 174.5 + CGFloat(num * 49)
        }
        
    }
    
}
