//
//  KeHuGuanLiCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/28.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol KeHuGuanLiCellDelegate {
    @objc optional func KeHuGuanLiCellEditClick(cell:KeHuGuanLiCell)
}
class KeHuGuanLiCell: UITableViewCell {
    @IBOutlet weak var photoIcon: UIImageView!
    @IBOutlet weak var nameLbl2: UILabel!
    @IBOutlet weak var arrowImg: UIImageView!
    var delegate:KeHuGuanLiCellDelegate?
    @IBOutlet weak var iconImg: UIImageView!
    @IBOutlet weak var compenyLbl: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    
    
    @IBOutlet weak var btnWidth: NSLayoutConstraint!
    @IBOutlet weak var statusLbl1: UILabel!
    @IBOutlet weak var statusLbl2: UILabel!
    @IBOutlet weak var statusLbl3: UILabel!
    var phoneNum = ""
    var cus_type:Int?
    @IBAction func phoneCallAction(_ sender: Any) {
        if phoneNum.count > 0 {
            UIApplication.shared.openURL(NSURL.init(string: "tel://\(phoneNum)")! as URL)
        }
    }
    @IBAction func editAction(_ sender: Any) {
        delegate?.KeHuGuanLiCellEditClick?(cell: self)
    }
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        // Initialization code
    }
    override func layoutIfNeeded() {
        super.layoutIfNeeded()
        if cus_type == 1 {
            statusLbl1.text = "个人"
            statusLbl1.textColor = UIColor(named: "蓝色字体颜色")
        }else{
            statusLbl1.text = "企业"
            statusLbl1.textColor = UIColor(named: "企业、预售字体")
        }
        statusLbl1.layer.borderColor = statusLbl1.textColor.cgColor
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
