//
//  ChuKuViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/26.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class ChuKuViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,TitleAndTFCellDelegate,UITextViewDelegate,TilteAndTextViewCellDelegate{


     let titleArr = ["出库类型","出库数量","备注"]
    @IBOutlet weak var lietView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
       
        navbar.title = "出库"//库存商品的出库
        self.view.addSubview(navbar)
        
        lietView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(273.5*glscale)
        }
        lietView.separatorStyle = .none
        lietView.isScrollEnabled = false
        lietView.register(UINib(nibName: "TilteAndTextViewCell", bundle: nil), forCellReuseIdentifier: "TilteAndTextView")
        lietView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTF")
        lietView.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtn")
        // TilteAndTextViewCell  TitleAndTFCell TitleAndBtnCell
        
    }
    
    
    @IBAction func submitAction(_ sender: Any) {
    }
//MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        switch indexPath.row {
        case 0,1:return 49*glscale
        default:return 173.5*glscale
            
        }
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.row {
        case 0:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtn") as! TitleAndBtnCell
            cell.contentLbl.text = "请选择出库类型"
            cell.nameLbl.text = titleArr[indexPath.row]
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTF") as! TitleAndTFCell
            cell.textTF.placeholder = "不得大于库存"
            cell.textTF.font = UIFont.systemFont(ofSize: 13)
            cell.textTF.textAlignment = .center
            cell.textTF.layer.cornerRadius = 2
            cell.textTF.layer.masksToBounds = true
            cell.textTF.layer.borderWidth = 1
            cell.textTF.layer.borderColor = UIColor(named: "灰色字体颜色")?.cgColor
            cell.delegate = self
            cell.textTF.snp.updateConstraints { (make) in
                make.centerY.equalTo(cell.snp_centerY)
                make.width.equalTo(120*glscale)
                make.height.equalTo(32*glscale)
                make.right.equalTo(-15)
            }
            cell.textTF.keyboardType = .numberPad
            cell.nameLbl.text = titleArr[indexPath.row]
            return cell
        default:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TilteAndTextView") as! TilteAndTextViewCell
            cell.holderLbl.text = "申请备注（非必填）"
            cell.titleLbl.text = titleArr[indexPath.row]
            cell.delegate = self
            return cell
            
        }
    }
    
    func TilteAndTextViewCellResponseStr(str: String, cell: TilteAndTextViewCell) {
        print(str)
    }
    func textFieldContent(content: String, cell: TitleAndTFCell) {
        print(content)
    }
}
