//
//  YingFuZhangKuanXQCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol YingFuZhangKuanXQCellDelegate {
    @objc optional func YingFuZhangKuanXQCellBtnClick(cell:YingFuZhangKuanXQCell,sender:UIButton)
}
class YingFuZhangKuanXQCell: UITableViewCell {
    @IBOutlet weak var date2Lbl: UILabel!
    var delegate:YingFuZhangKuanXQCellDelegate?
    @IBAction func submitAction(_ sender: UIButton) {
        delegate?.YingFuZhangKuanXQCellBtnClick?(cell: self,sender:sender)
    }
    
    @IBOutlet weak var p3Title: UILabel!
    @IBOutlet weak var p2Title: UILabel!
    @IBOutlet weak var p1Title: UILabel!
    @IBOutlet weak var submitBtn: UIButton!
    @IBOutlet weak var priceLbl3: UILabel!
    @IBOutlet weak var priceLbl2: UILabel!
    @IBOutlet weak var priceLbl1: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var dateLbl: UILabel!
    var model:accountsPayableDetailDataListModel?
    var data:accountReceivableDetailListModel?
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        // Initialization code
    }
    override func layoutIfNeeded() {
        super.layoutIfNeeded()
        submitBtn.layer.cornerRadius = 3
        submitBtn.layer.masksToBounds = true
        priceLbl1.text = "-"
        priceLbl2.text = "-"
        priceLbl3.text = "-"
        
        if data != nil {
            nameLbl.text = data?.order_sn
            if data?.add_time != nil {
                dateLbl.text = dayAndTimeByDouble(sender: (data?.add_time)!)
            }
            date2Lbl.isHidden = true
            if data?.pay_time != 0 && data?.pay_time != nil {
                date2Lbl.text = "收款时间:" + dayAndTimeByDouble(sender: (data?.pay_time)!)
                date2Lbl.isHidden = false
            }
            
            priceLbl3.text = data?.arrears_money!
            priceLbl1.text = data?.money
            priceLbl2.text = data?.money
            submitBtn.isUserInteractionEnabled = true
            
            if data?.type == 2 && data?.status == 0 {
                submitBtn.backgroundColor = UIColor.clear
                submitBtn.setTitleColor(UIColor(named: "灰色字体颜色"), for: .normal)
                submitBtn.setTitle("设置未收款", for: .normal)
                submitBtn.layer.borderWidth = 1
                
            }else if data?.type == 1 && data?.status == 1 {
                
                priceLbl2.text = "-"
                submitBtn.backgroundColor = UIColor(named: "按钮渐变色下,字体颜色")
                submitBtn.setTitle("收款", for: .normal)
                submitBtn.setTitleColor(UIColor.white, for: .normal)
                submitBtn.layer.borderWidth = 0
            }else{
                submitBtn.isUserInteractionEnabled = false
                submitBtn.backgroundColor = UIColor(named: "灰色字体颜色")
                submitBtn.setTitle("已收款", for: .normal)
                submitBtn.setTitleColor(UIColor.white, for: .normal)
                submitBtn.layer.borderWidth = 0
            }
        }
        
        if model != nil {
            nameLbl.text = model?.po_no!
            dateLbl.text = dayAndTimeByDouble(sender: (model?.add_time!)!)
            date2Lbl.isHidden = true
            if model?.pay_time != 0 && model?.pay_time != nil {
                date2Lbl.text = "付款时间:" + dayAndTimeByDouble(sender: (model?.pay_time!)!)
                date2Lbl.isHidden = false
            }
            //            if model?.type == 1 {//应付
            priceLbl1.text = model?.money
            //            }else{//已付
            priceLbl2.text = model?.money
            //            }
            priceLbl3.text = model?.payable_money
            submitBtn.backgroundColor = UIColor.clear
            submitBtn.setTitleColor(UIColor(named: "灰色字体颜色"), for: .normal)
            submitBtn.setTitle("设置未付款", for: .normal)
            submitBtn.layer.borderWidth = 1
            
            if model?.status == 1 {
                
                priceLbl2.text = "-"
                submitBtn.backgroundColor = UIColor(named: "按钮渐变色下,字体颜色")
                submitBtn.setTitle("付款", for: .normal)
                submitBtn.setTitleColor(UIColor.white, for: .normal)
                submitBtn.layer.borderWidth = 0
            }
        }
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
