//
//  PuTongJieTiCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/22.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol PuTongJieTiCellDelegate {
    @objc optional func PuTongJieTiDelAction(sender:PuTongJieTiCell)
    @objc optional func PuTongJieTiContent(price:String,count:String,cell:PuTongJieTiCell)
    @objc optional func PuTongJieTiContentSp(price:String,count:String,cell:PuTongJieTiCell)
    @objc optional func PuTongJieTiClickDone()
}
class PuTongJieTiCell: UITableViewCell,UITextFieldDelegate {
    var delegate:PuTongJieTiCellDelegate?
    @IBAction func delAction(_ sender: UIButton) {
        delegate?.PuTongJieTiDelAction?(sender: self)
    }
    
    @IBOutlet weak var priceTF: UITextField!
    @IBOutlet weak var countTF: UITextField!
    @IBOutlet weak var titleLbl: UILabel!
    @IBOutlet weak var btn: UIButton!
    var isYuShou:Bool?
    override func awakeFromNib() {
        super.awakeFromNib()
        selectionStyle = .none
        priceTF.tag = 0
        countTF.tag = 1
        countTF.keyboardType = .numberPad
        priceTF.keyboardType = .decimalPad
        priceTF.returnKeyType = .done
        priceTF.delegate = self
        countTF.delegate = self
        // Initialization code
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        if textField == priceTF{//价格
            if isPurnNumber(str: textField.text!) == false{
                HUD.flash(.label("请输入正确的价格"), delay: 1.2)
                textField.text = "0"
                return
            }
            priceTF.text = formatShowNumber(value: textField.text!)
        }else{//数量
            if isPurnInt(string: textField.text!) == false{
                HUD.flash(.label("请输入正确的数量"), delay: 1.2)
                textField.text = "1"
                return
            }
            countTF.text = formatShowNumber(value: textField.text!)
        }
        if isYuShou! {
            delegate?.PuTongJieTiContentSp?(price: priceTF.text!, count: countTF.text!, cell: self)
        }else{
        delegate?.PuTongJieTiContent?(price: priceTF.text!, count: countTF.text!, cell: self)
        }
    }
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        ((delegate?.PuTongJieTiClickDone?()) != nil)
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
