//
//  NewCreatHeader.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/22.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol NewCreateFooterDelegate {
    @objc optional func footerClickAction()
}
class NewCreateFooter: UIView {

    @IBAction func clickAction(_ sender: Any) {
        delegate?.footerClickAction?()
    }
    var contentView:UIView!
    var delegate:NewCreateFooterDelegate?
    //初始化时将xib中的view添加进来
       override init(frame: CGRect) {
           super.init(frame: frame)
           contentView = loadViewFromNib()
           addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
               make.left.top.right.bottom.equalToSuperview()
           }
       }
       //    /初始化时将xib中的view添加进来
       required init?(coder aDecoder: NSCoder) {
           super.init(coder: aDecoder)
           contentView = loadViewFromNib()
           addSubview(contentView)
           contentView.snp.makeConstraints { (make) in
               make.left.top.right.bottom.equalToSuperview()
           }
       }
       //加载xib
       func loadViewFromNib() -> UIView {
           let className = type(of: self)
           let bundle = Bundle(for: className)
           let name = NSStringFromClass(className).components(separatedBy: ".").last
           let nib = UINib(nibName: name!, bundle: bundle)
           let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
           return view
       }
    

}
