//
//  ShowAlGoodsViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/26.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator

class ShowAlGoodsViewController: BaseViewController  , UITableViewDelegate, UITableViewDataSource{
    var order_goods:Array<OrderDetailGoodsModel>? = []
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        navbar.title = "查看全部商品"
        self.view.addSubview(navbar)
        setTabv()
    }
    var tableV :UITableView!
    
    private let animations = [AnimationType.from(direction: .bottom, offset: 150*glscale)]
    func setTabv() {
        tableV = UITableView()
        view.addSubview(tableV);
        tableV.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(navbar.snp_bottom)
        }
        tableV.backgroundColor = UIColor.init(named: "白色背景色")
        tableV.delegate = self
        tableV.dataSource = self
        tableV.separatorStyle = .none
        
 
        tableV?.register(UINib(nibName: "XuanZeShangPinCell", bundle: nil), forCellReuseIdentifier: "XuanZeShangPinCell")
        
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        return order_goods!.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "XuanZeShangPinCell") as! XuanZeShangPinCell
        cell.selectBtn.isHidden = true
        cell.priceLbl.isHidden = false
        let rowModel = order_goods![indexPath.row]
        cell.nameLbl.text = rowModel.goods_name
        if rowModel.goods_attr != nil {
            cell.detailLbl.text = "规格:" + rowModel.goods_attr!

        }else{
            cell.detailLbl.text = "规格:" +  "-"
        }
        cell.priceLbl.text = "￥" + (rowModel.goods_price!)
        cell.iconImg.sd_setImage(with: URL(string: SERVERCE_ImageHost + (rowModel.goods_thumb)!))
        cell.detailLbl2.text = "x" + StringByInt(number: rowModel.cart_number!)
        
        return cell
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        print(indexPath)
        
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 120*glscale
    }
    
    
}
