//
//  TitleTimeHeaderView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import Foundation
class TitleTimeHeaderFooterView: UIView {
    var contentView:UIView!

    @IBOutlet weak var specLbl5: UILabel!
    @IBOutlet weak var specLbl4: UILabel!
    @IBOutlet weak var specLbl3: UILabel!
    @IBOutlet weak var specLbl2: UILabel!
    @IBOutlet weak var specLbl1: UILabel!
    @IBOutlet weak var specLbl0: UILabel!
    @IBOutlet weak var driveTypeNameLbl: UILabel!
    @IBOutlet weak var fuTitleLbl: UILabel!
    @IBOutlet weak var titleLbl: UILabel!
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
}
